Vue.directive('left-slide-list-item', {
    inserted: function (el, binding) {
        var defaults = {
            itemDelete: '.left_slide_menu_area' //删除元素
        };
        var opts = $.extend({}, defaults); //配置选项

        var obj = null;
        var delWidth = $(el).find(opts.itemDelete).width();
        var delLeftAreaWidth = $(window).width() - delWidth;
        var active = false;

        var initX; //触摸位置
        var moveX; //滑动时的位置
        var X = 0; //移动距离
        var objX = 0; //目标对象位置
        var delClicking = false;

        $(el).on('touchstart', function (event) {
            obj = this;
            initX = event.targetTouches[0].pageX;
            if (active) {
                if (initX < delLeftAreaWidth) {
                    event.preventDefault();
                    event.stopPropagation();
                    obj.style.transition = "all 0.1s";
                    obj.style.WebkitTransform = "translateX(" + 0 + "px)";
                    objX = 0;
                    active = false;
                    delClicking = false;
                } else {
                    delClicking = true;
                }
            }
            var objXString = obj.style.WebkitTransform;
            objX = (objXString.substring(11, objXString.length - 3)) * 1;
        });

        $(el).on('touchmove', function (event) {
            moveX = event.targetTouches[0].pageX;
            X = moveX - initX;
            obj.style.transition = "all 0";
            if (objX == 0) {
                if (X >= 0) {
                    obj.style.WebkitTransform = "translateX(" + 0 + "px)";
                } else if (X < 0) {
                    if (-X > delWidth) {
                        obj.style.WebkitTransform = "translateX(" + -delWidth + "px)";
                    } else {
                        obj.style.WebkitTransform = "translateX(" + X + "px)";
                    }
                }
            } else if (objX < 0) {
                if (X >= 0) {
                    var r = -delWidth + X;
                    if (r > 0) {
                        obj.style.WebkitTransform = "translateX(" + 0 + "px)";
                    } else {
                        obj.style.WebkitTransform = "translateX(" + r + "px)";
                    }
                } else { //向左滑动
                    obj.style.WebkitTransform = "translateX(" + -delWidth + "px)";
                }
            }
        });

        $(el).on('touchend', function (event) {
            var objXString = obj.style.WebkitTransform;
            objX = (objXString.substring(11, objXString.length - 3)) * 1;
            if (objX > -delWidth / 2) {
                obj.style.transition = "all 0.1s";
                obj.style.WebkitTransform = "translateX(" + 0 + "px)";
                objX = 0;
            } else {
                obj.style.transition = "all 0.1s";
                obj.style.WebkitTransform = "translateX(" + -delWidth + "px)";
                objX = -delWidth;
                active = true;
                delClicking = false;
            }
        });

        $(window).on('touchstart', function (event) {
            if (active && !delClicking) {
                obj.style.transition = "all 0.1s";
                obj.style.WebkitTransform = "translateX(" + 0 + "px)";
                objX = 0;
                active = false;
                delClicking = false;
            }
        });
    }
})