window.onload = function() {
    uShowLoadingPage();
    var mVersionName = "";
    var vm = new Vue({
        el: '#view-container',
        data: {
            aboutInfo: {
                versionName: "",
            }
        },
        created: function() {
            var self = this;
            this.$nextTick(function() {
                uShowSelf();
            });
        },
        mounted: function() {
            var self = this;
            uSetPublicBackButtonClickListener(function() {
                self.goBack();
            });
            this.$nextTick(function() {
                mVersionName = "DevCloud  " + uGetAppVersion();
                self.aboutInfo.versionName = mVersionName;
                var about_footer_left = document.getElementById("about_footer_left");
                about_footer_left.setAttribute('style', 'pointer-events:all');
                var about_footer_right = document.getElementById("about_footer_right");
                about_footer_right.setAttribute('style', 'pointer-events:all');
                setTimeout(function() {
                    makeqrcode();
                    uHideLoadingPage();
                }, 100)
            });
        },
        methods: {

            goBack: function() {
                uFinishCurrentPage();
            },
            savepictrue: function() {
                var base64 = $($('#real_qrcode').find('img')[0]).attr('src');
                usavepicture(base64, "");
            },
            share: function() {
                var base64 = $($('#real_qrcode').find('img')[0]).attr('src');
                uqrshare(base64, "", "");
            },
            privacyStatement:function(){
                uPrivacyStatement();
            },
            openSource:function(){
                uOpenSource();
            }
        }
    })



    function intercept() {
        if ($('#projectname').height() > 120) {
            var text = $('#projectname').html() + '...';
            while ($('#projectname').height() > 120) {
                text = text.substr(0, text.length - 4) + '...';
                $('#projectname').html(text);
            }
        }
    }

    function makeqrcode() {
//        var region = uGetRegion();
//        if (region == ZONE_NORTHEAST || region == ZONE_SELF) {
//            baseurl = "https://dl.devcloud.huaweicloud.com";
//        } else if (region == ZONE_NORTH) {
//            baseurl = "https://devcloud.huaweicloud.com";
//        } else if(region ==ZONE_EAST) {
//            baseurl = "https://hd.devcloud.huaweicloud.com";
//        }else {
//            baseurl = "https://hn.devcloud.huaweicloud.com";
//        }

        //java层做了处理，自用环境返回大连region host
        var regionHost = uGetZoneHttpHost();
        baseurl = "https://"+regionHost;

        var qrcode = new QRCode('qrcode', {
            text: baseurl + "/m/openApp.html?page=downloadApp",
            width: 578,
            height: 578,
            colorLight: "#ffffff",
        });
        var qrcode = new QRCode('qrcode1', {
            text: baseurl + "/m/openApp.html?page=downloadApp",
            width: 700,
            height: 700,
            colorLight: "#ffffff",
        });
        console.log("qrcode:" + baseurl);
        var fake_canvas = document.getElementById("qrcode1").firstElementChild.getContext("2d");
        var real_canvas = document.getElementById("real_qrcode").firstElementChild.getContext("2d");
        real_canvas.fillStyle = "#ffffff";
        real_canvas.fillRect(0, 0, 910, 1090);
        var imgData = fake_canvas.getImageData(0, 0, 700, 700);
        real_canvas.putImageData(imgData, 105, 324);
        var img = document.getElementById("project_img");
        real_canvas.drawImage(img, 105, 60, 180, 180);
        real_canvas.font = "bold 50px Microsoft YaHei, SimSun, sans-serif";
        real_canvas.fillStyle = "black";
        canvasTextAutoLine("DevCloud APP", real_canvas, 310, 155, 50, 600);
        var real_img = document.getElementById("real_qrcode_img");
        real_img.setAttribute("src", document.getElementById("real_qrcode").firstElementChild.toDataURL("image/png"));

    }

    function canvasTextAutoLine(str, canvas, initX, initY, lineHeight, weight) {
        var ctx = canvas;
        var lineWidth = 0;
        var canvasWidth = weight;
        var lastSubStrIndex = 0;
        for (var i = 0; i < str.length; i++) {
            lineWidth += ctx.measureText(str[i]).width;
            if (lineWidth > 600) {
                ctx.fillText(str.substring(lastSubStrIndex, i), initX, initY);
                initY += lineHeight;
                lineWidth = 0;
                lastSubStrIndex = i;
            }
            if (i == str.length - 1) {
                ctx.fillText(str.substring(lastSubStrIndex, i + 1), initX, initY);
            }
        }
    }
}