window.onload = function () {
    var projectUUId = uGet("project_uuid");
    var isSaving = false;
    var vm = new Vue({
        el: '#view-container',
        data: {
            items: [],
            itemList: [],
            searchHint: [stringMap.no_member],
            indexList: [],
            indexObjectList: [],
            count:0
        },

        mounted: function () {
            var self = this;
            uSetSaveButtonClickable("false");
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            uSetPublicCompleteButtonClickListener(function () {
                self.save();
            });
            this.getUserList(projectUUId);

            document.addEventListener('scroll', self.pageScroll, true);

        },

        methods: {
            save: function () {
                if (isSaving) {
                    return;
                }
                var self = this;
                var userList = [];
                for (var i = 0; i < self.itemList.length; i++) {
                    for (var j = 0; j < self.itemList[i].group_members.length; j++) {
                        if (self.itemList[i].group_members[j].checked) {
                            userList.push({
                                "enterprice_id": self.itemList[i].group_members[j].enterprice_id,
                                "enterprice_name": self.itemList[i].group_members[j].enterprice_name,
                                "name": self.itemList[i].group_members[j].name,
                                "user_id": self.itemList[i].group_members[j].id,
                                "email":""
                            });
                        }
                    }
                }
                isSaving = true;
                hAddMember({
                    "project_uuid": projectUUId,
                    "users":userList
                }, function (data) {
                    isSaving = false;
                    uFinishCurrentPage();
                    uSet("project_member_updated","true");
                    uSet("needRequestProject","true");
                }, function (data) {
                    isSaving = false;
                    uHideLoadingPage();
                    uShowAlertDialog(data.reason);
                });
                console.log("members:"+JSON.stringify(userList));
            },
            showAddMemberOfOtherCorporationPage: function () {
                uShowSubPage();
            },
            getUserList: function (projectId) {
                var self = this;
                uShowLoadingPage();
                hGetUserList({
                    "project_uuid": projectId
                }, function (data) {
                    self.itemList = data.members;

                    for (var i = 0; i < self.itemList.length; i++) {
                        for (var j = 0; j < self.itemList[i].group_members.length; j++) {
                            self.itemList[i].group_members[j].checked = false;
                            self.itemList[i].group_members[j].sid = j;
                            self.itemList[i].group_members[j].imageId = Math.round(Math.random()*10) % 4;
                        }
                    }

                    self.items = self.itemList;

                    self.$nextTick(function () {
                        uShowSelf();

                        if ($("#workItem_memberList")[0] && $("#workItem_memberList")[0].scrollHeight > window.innerHeight) {
                            $("#workItem_memberList")[0].style.height = window.innerHeight - 158 + "px";
                        }

                        for (var i = 0; i < self.items.length; i++) {
                            if (self.items[i].group_name == '#') {
                                self.items[i].top = $("#number_sign").offset().top;
                            } else {
                                self.items[i].top = $("#" + self.items[i].group_name).offset().top;
                            }
                        }
                        self.indexList = ["#", "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];

                        for (var j = 0; j < self.indexList.length; j++) {
                            if (self.items.length && self.indexList[j] == self.items[0].group_name) {
                                self.indexObjectList.push({"name":self.indexList[j], "checked": true});
                            } else {
                                self.indexObjectList.push({"name":self.indexList[j], "checked": false});
                            }
                        }
                        uHideLoadingPage();
                    });
                });
            },

            chooseMember: function(item,itemGroup) {
                var self = this;
                for (var i = 0; i < self.itemList.length; i++) {
                    if (self.itemList[i].group_name == itemGroup.group_name) {
                        self.itemList[i].group_members[item.sid].checked = !self.itemList[i].group_members[item.sid].checked;
                        if (self.itemList[i].group_members[item.sid].checked) {
                            self.count++;
                        } else {
                            self.count--;
                        }
                        Vue.set(self.itemList[i].group_members, item.sid, self.itemList[i].group_members[item.sid]);
                    }
                }
            },

            scrollToIndex: function (index) {
                console.log("scrollToIndex:" + index);
                for (var i = 0; i < this.items.length; i++) {
                    if (this.items[i].group_name.toUpperCase() == index) {
                        var div = $("#workItem_memberList")[0];
                        div.scrollTop = this.items[i].top - 158;
                    }
                }
            },
            goBack: function () {
                if (isSaving) {
                    return;
                }
                uFinishCurrentPage();
            },

            search: function () {
                if (this.queryValue != "") {
                    if (!this.isAssignerList) {
                        this.items = [];
                        for (var i = 0; i < this.itemList.length; i++) {
                            if (this.itemList[i].name.indexOf(this.queryValue) >= 0) {
                                this.items.push(this.itemList[i]);
                            }
                        }
                    } else {
                        this.items = [];

                        for (var i = 0; i < this.itemList.length; i++) {
                            var tmpGroups = {
                                "group_name":this.itemList[i].group_name,
                                "group_members":[]
                            };
                            for (var j = 0; j < this.itemList[i].group_members.length; j++) {
                                if ((this.itemList[i].group_members[j].display_name.toUpperCase()).indexOf(this.queryValue.toUpperCase()) == 0) {
                                    tmpGroups.group_members.push(this.itemList[i].group_members[j]);
                                }
                            }
                            if (tmpGroups.group_members.length) {
                                this.items.push(tmpGroups);
                            }
                        }
                    }
                } else {
                    this.items = this.itemList;
                }
            },
            pageScroll:function() {
                var div = $("#workItem_memberList")[0];
                console.log(div.scrollTop);
                var currentIndex;
                for (var i = 0; i < this.items.length; i++) {
                    if (div.scrollTop >= this.items[i].top - 158) {
                        currentIndex = this.items[i].group_name.toUpperCase();
                    }
                }
                for (var j = 0; j < this.indexObjectList.length; j++) {
                    if (this.indexObjectList[j].name == currentIndex) {
                        this.indexObjectList[j].checked = true;
                        console.log("scroll to:" + currentIndex);
                    } else {
                        this.indexObjectList[j].checked = false;
                    }
                }
            }
        },

        watch: {
            count:function (val,oldVal) {
                if (val > 0) {
                    uSet("member_count", val);
                    console.log("member_count" + val);
                    uSetSaveButtonClickable("true");
                } else {
                    uSetSaveButtonClickable("false");
                }
            }
        }
    });
};
