window.onload = function(){
    var isSaving = false;
    var currentUserInfo;
    var projectUUId = uGet("project_uuid");
    var namePattern = /^[A-Za-z0-9\-_]+$/;
    var vm = new Vue({
        el:'#view-container',
        data:{
            corporationInfo: {
                "corporationUsername": "",
                "username": ""
            },
            canClick: false
        },
        created:function(){
            this.$nextTick(function () {
                uShowSelf();
            });
        },
        mounted:function(){
            var self = this;
            uSetPublicBackButtonClickListener(function (){
                self.goBack();
            });
            uShowLoadingPage();
            hGetCurrentUserInfo({}, function (data) {
                currentUserInfo = data;
                uHideLoadingPage();
            });
        },
        watch: {
            corporationInfo: {
                handler: function (val, oldVal) {
                    console.log(this.corporationInfo);
                    var subject = this.corporationInfo.corporationUsername;
                    if (subject.replace(/\s/g, "") != "" ) {
                        console.log("canClick");
                        this.canClick = true;
                    } else {
                        this.canClick = false;
                    }
                },
                deep: true
            }
        },
        methods:{
            goBack: function () {
                uFinishCurrentPage();
            },
            addOtherDomainUser:function (domainName, username) {
                var self = this;
                var params = {
                    "enterprise_name": domainName,
                    "project_uuid": projectUUId,
                    "user_name": username ? username : ""
                };
                hTenantInvitation(params, function (data) {
                    uSet("project_member_updated","true");
                    uSet("needRequestProject","true");
                    self.corporationInfo.corporationUsername = "";
                    self.corporationInfo.username = "";
                    isSaving = false;
                }, function (data) {
                    isSaving = false;
                    if (data && data.code === "DEV_21_500549") {
                        uShowAlertDialog(data && data.reason ?  data.reason : stringMap.add_member_fail1);
                    } else if (data.code === "DEV_21_500546") {
                        uShowAlertDialog(data && data.reason ?  data.reason : stringMap.add_member_fail1);
                    } else {
                        uShowAlertDialog(data && data.reason ?  data.reason : stringMap.add_member_fail2);
                    }
                })
            },
            invite:function () {
                if (this.canClick) {
                    console.log("invite");
                    var self = this;
                    if (isSaving) {
                        return;
                    }
                    var corporationUsername = self.corporationInfo.corporationUsername;
                    if (corporationUsername === "") {
                        uShowToast(stringMap.business_account_limit1);
                    } else if (corporationUsername.length < 5) {
                        uShowToast(stringMap.business_account_limit2);
                    } else if (corporationUsername.length > 32) {
                        uShowToast(stringMap.business_account_limit3);
                    } else if (!corporationUsername.match(namePattern)) {
                        uShowToast(stringMap.business_account_limit4);
                    } else if (currentUserInfo.domain_name == corporationUsername) {
                        uShowToast(stringMap.business_account_limit5);
                    } else {
                        isSaving = true;
                        hGrantedTenantVerification({
                            "enterprise_name": corporationUsername,
                             "project_uuid": projectUUId
                        }, function (data) {
                            var resultCode = data.status;
                            switch (resultCode) {
                                case 2:
                                    uShowToast(stringMap.invite_fail1);
                                    isSaving = false;
                                    break;
                                case 1:
                                    uShowToast(stringMap.invite_fail2);
                                    isSaving = false;
                                    break;
                                case 3:
                                    var username = self.corporationInfo.username;
                                    if (username === "") {
                                        self.addOtherDomainUser(corporationUsername);
                                    } else {
                                        if (username.length < 5) {
                                            uShowToast(stringMap.user_name_limit1);
                                            isSaving = false;
                                        } else if (username.length > 32) {
                                            uShowToast(stringMap.user_name_limit2);
                                            isSaving = false;
                                        } else if (!corporationUsername.match(namePattern)) {
                                            uShowToast(stringMap.user_name_limit3);
                                            isSaving = false;
                                        } else {
                                            hUserTenantVerification({
                                                "enterprise_name": corporationUsername,
                                                "user_name": username
                                            }, function (data) {
                                                if (data.exist) {
                                                    self.addOtherDomainUser(corporationUsername, username);
                                                } else {
                                                    uShowToast(stringMap.user_not_exist);
                                                    isSaving = false;
                                                }
                                            }, function (data) {
                                                data && uShowAlertDialog(data.reason);
                                                isSaving = false;
                                            })
                                        }
                                    }
                                    break;
                                case 4:
                                    uShowToast(stringMap.already_invite);
                                    break;
                                default:
                                    break;
                            }
                        }, function (data) {
                            isSaving =false;
                            data && uShowAlertDialog(data.reason);
                        });
                    }
                }
            }
        }
    })
};