window.onload = function () {
    var projectUUId = uGet("project_uuid");
    var isSaving = false;
    var requestDoneFlags = {
        getApprovedMembers: true,
        getUserListByProjectId: false
    };
    var isAllRequestDone = function () {
        var allRequestDone = true;
        for (var request in requestDoneFlags) {
            if (!requestDoneFlags[request]) {
                allRequestDone = false;
            }
        }
        console.log("requestDoneFlags:" + JSON.stringify(requestDoneFlags));
        return allRequestDone;
    };
    var vm = new Vue({
        el: '#view-container',
        data: {
            items: [],
            itemList: [],
            indexList: [],
            indexObjectList: [],
            toDoMembers:[],
            readOnly: true
        },

        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            uSetUpdateProjectListener(function () {
                self.updateProjectMember();
            });

            this.getProjectDetails(projectUUId);
            document.addEventListener('scroll', self.pageScroll, true);
        },

        methods: {
            getProjectDetails: function (projectId) {
                var self = this;
                uShowLoadingPage();
                hGetProjectDetails({
                    "project_uuid": projectId
                }, function (data) {
                    var role = Number(data.project.role);
                    self.readOnly = !((role == ROLE.CREATOR) || (role == ROLE.MANAGER) || (role == ROLE.TESTMANAGER));
                    hUserBetaStatus({
                        "project_uuid": projectId
                    }, function (result) {
                        if (2 === result.order_status) {
                            self.readOnly = true;
                        } else if (0 === result.status && 0 === result.free_quota) {
                            self.readOnly = true;
                        }
                        if (!self.readOnly) {
                            requestDoneFlags.getApprovedMembers = false;
                            self.getApprovedMembers(projectId);
                        }
                        requestDoneFlags.getUserListByProjectId = false;
                        self.getUserListByProjectId(projectId);
                    })
                },function (data) {
                    if (data.code == "DEV_21_100169") {
                        uHideLoadingPage();
                        uShowToast(data.reason);
                        setTimeout(function () {
                            self.goBack();
                        },1000);
                    } else {
                        uHideLoadingPage();
                        uShowAlertDialog(data.reason);
                    }
                });
            },
            updateProjectMember: function () {
                if (!self.readOnly) {
                    requestDoneFlags.getApprovedMembers = false;
                    this.getApprovedMembers(projectUUId);
                }
                requestDoneFlags.getUserListByProjectId = false;
                this.getUserListByProjectId(projectUUId);
            },
            rejectMember: function (member) {
                var self = this;
                if (isSaving) {
                    return;
                }
                isSaving = true;
                uShowLoadingPage();
                hApproveMembers({
                    "audit_uuid": member.audit_uuid,
                    "status": false
                }, function (data) {
                    isSaving = false;
                    requestDoneFlags.getApprovedMembers = false;
                    requestDoneFlags.getUserListByProjectId = false;
                    self.getApprovedMembers(projectUUId);
                    self.getUserListByProjectId(projectUUId);
                    uSet("needRequestDealMessage","true");
                    uHideLoadingPage();
                }, function (data) {
                    isSaving = false;
                    uHideLoadingPage();
                    uShowAlertDialog(data.reason);
                });
            },
            acceptMember: function (member) {
                var self = this;
                if (isSaving) {
                    return;
                }
                isSaving = true;
                uShowLoadingPage();
                hApproveMembers({
                    "audit_uuid": member.audit_uuid,
                    "status": true
                }, function (data) {
                    isSaving = false;
                    requestDoneFlags.getApprovedMembers = false;
                    requestDoneFlags.getUserListByProjectId = false;
                    self.getApprovedMembers(projectUUId);
                    self.getUserListByProjectId(projectUUId);
                    uHideLoadingPage();
                    uSet("needRequestProject","true");
                    uSet("needRequestDealMessage","true");
                }, function (data) {
                    isSaving = false;
                    uHideLoadingPage();
                    uShowAlertDialog(data.reason);
                });
            },
            getApprovedMembers: function (projectId) {
                var self = this;
                uShowLoadingPage();
                hGetApprovedMembers({
                    "project_uuid": projectId
                }, function (data) {
                    self.toDoMembers = data.auditing_members;
                    for (var i=0; i<self.toDoMembers.length;i++) {
                        self.toDoMembers[i].imageId = Math.round(Math.random()*10) % 4;
                        self.toDoMembers[i].imageName = self.toDoMembers[i].login.substring(0,1).toUpperCase();
                    }
                    requestDoneFlags.getApprovedMembers = true;
                    if (isAllRequestDone()) {
                        uHideLoadingPage();
                    }
                });
            },
            showAddMemberPage: function () {
                uShowSubPage();
            },
            getUserListByProjectId: function (projectId) {
                var self = this;
                uShowLoadingPage();
                hGetUserListByProjectId({
                    "project_uuid": projectId
                }, function (data) {
                    self.itemList = data.members;
                    self.items = self.itemList;

                    self.$nextTick(function () {
                        uShowSelf();
                        if ($("#workItem_memberList")[0].scrollHeight > window.innerHeight) {
                            if (self.readOnly) {
                                $("#workItem_memberList")[0].style.height = window.innerHeight + "px";
                            } else {
                                $("#workItem_memberList")[0].style.height = window.innerHeight - 158 + "px";
                            }
                        }

                        for (var i = 0; i < self.items.length; i++) {
                            if (self.items[i].group_name == '#') {
                                self.items[i].top = $("#number_sign").offset().top;
                            } else {
                                self.items[i].top = $("#" + self.items[i].group_name).offset().top;
                            }
                        }
                        self.indexList = ["#", "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
                        self.indexObjectList = [];
                        for (var j = 0; j < self.indexList.length; j++) {
                            if (self.indexList[j] == self.items[0].group_name) {
                                self.indexObjectList.push({"name":self.indexList[j], "checked": true});
                            } else {
                                self.indexObjectList.push({"name":self.indexList[j], "checked": false});
                            }
                        }
                    });
                    requestDoneFlags.getUserListByProjectId = true;
                    if (isAllRequestDone()) {
                        uHideLoadingPage();
                    }
                });
            },
            scrollToIndex: function (index) {
                console.log("scrollToIndex:" + index);
                for (var i = 0; i < this.items.length; i++) {
                    if (this.items[i].group_name.toUpperCase() == index) {
                        var div = $("#workItem_memberList")[0];
                        if (this.readOnly) {
                            div.scrollTop = this.items[i].top;
                        } else {
                            div.scrollTop = this.items[i].top - 158;
                        }
                    }
                }
            },
            goBack: function () {
                uFinishCurrentPage();
            },

            search: function () {
                if (this.queryValue != "") {
                    if (!this.isAssignerList) {
                        this.items = [];
                        for (var i = 0; i < this.itemList.length; i++) {
                            if (this.itemList[i].name.indexOf(this.queryValue) >= 0) {
                                this.items.push(this.itemList[i]);
                            }
                        }
                    } else {
                        this.items = [];

                        for (var i = 0; i < this.itemList.length; i++) {
                            var tmpGroups = {
                                "group_name":this.itemList[i].group_name,
                                "group_members":[]
                            };
                            for (var j = 0; j < this.itemList[i].group_members.length; j++) {
                                if (this.itemList[i].group_members[j].display_name.toUpperCase().indexOf(this.queryValue.toUpperCase()) == 0) {
                                    tmpGroups.group_members.push(this.itemList[i].group_members[j]);
                                }
                            }
                            if (tmpGroups.group_members.length) {
                                this.items.push(tmpGroups);
                            }
                        }
                    }
                } else {
                    this.items = this.itemList;
                }
            },
            pageScroll:function() {
                var div = $("#workItem_memberList")[0];
                console.log(div.scrollTop);
                var currentIndex;
                var startPos = this.readOnly ? 0 : 158;

                for (var i = 0; i < this.items.length; i++) {
                    if (div.scrollTop >= this.items[i].top - 158) {
                        currentIndex = this.items[i].group_name.toUpperCase();
                    }
                }

                for (var j = 0; j < this.indexObjectList.length; j++) {
                    if (this.indexObjectList[j].name == currentIndex) {
                        this.indexObjectList[j].checked = true;
                        console.log("scroll to:" + currentIndex);
                    } else {
                        this.indexObjectList[j].checked = false;
                    }
                }
            }
        }
    });
};
