window.onload = function(){
    uShowLoadingPage();
    var mirror;
    var configModel = {
        lineNumbers: true,
        theme: 'night',
        fullScreen: false,
        mode: 'text/x-sh',
        readOnly: "nocursor",
        lineWrapping: true,
        scrollbarStyle: "native"
    };
    var vm = new Vue({
        el:'#view-container',
        data:{

        },
        created:function(){

        },
        mounted:function(){
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            this.initEditor();
            this.getTaskLog();
        },
        methods:{
            goBack: function () {
                uFinishCurrentPage();
            },
            initEditor: function () {
                var winHeight, codeMirrorHeight;
                // 获取窗口高度
                if (window.innerHeight) {
                    winHeight = window.innerHeight;
                }else if ((document.body) && (document.body.clientHeight)) {
                    winHeight = document.body.clientHeight;
                }
                // 通过深入Document内部对body进行检测，获取窗口大小
                if (document.documentElement && document.documentElement.clientHeight && document.documentElement.clientWidth) {
                    winHeight = document.documentElement.clientHeight;
                }

                mirror = CodeMirror.fromTextArea(document.getElementById('logs'), configModel);
                mirror.setSize('auto', winHeight);
            },
            getTaskLog: function () {
                var self = this;
                var params2 = uGet("getPipelineLogParams");
                if (params2 != "") {
                    params2 = JSON.parse(params2);
                    hGetPipelineLog(params2,
                        function (data) {
                            self.setEditorValue(mirror, data.content);
                            uHideLoadingPage();
                        },function (data) {
                            uHideLoadingPage();
                            uShowAlertDialog(data.reason);
                            uHideLog();
                        });
                }
            },
            setEditorValue: function (editor, value) {
                editor.setCursor(editor.lineCount());
                editor.replaceSelection(value);
                editor.refresh();
            }
        }
    })
};