window.onload = function () {
    var isSaving = false;
    var lastIterationName = "";
    var lastIterationDes = "";
    var lastModuleName = "";
    var lastModuleDes = "";
    var lastStartDate;
    var lastDueDate;
    var lastOwner;
    uShowLoadingPage();
    var mIteration = uGet("iteration");
    var mModule = uGet("module");
    console.log(mIteration + "+++++++++++" + mModule);
    var project_uuid = uGet("project_uuid");
    var iteration_id = uGet("iteration_id");
    var iteration_name = uGet("iteration_name");
    var module_name = uGet("module_name");
    console.log(module_name + "+++++++++++" + iteration_name);
    var module_id = uGet("module_id");
    var requestDoneFlags = {
        goProjectMoudleDetail: false,
        getUserListByProjectId: false,
    };
    var searchHintList = {
        'project': [stringMap.project_not_found],
        'assigner': [stringMap.member_not_found],
        'milestone': [stringMap.iteration_not_found, stringMap.no_iteration],
        'module': [stringMap.module_not_found, stringMap.no_module],
        'domain': [stringMap.domain_not_found, stringMap.no_domain]
    };
    var isAllRequestDone = function () {
        var allRequestDone = true;
        console.log("requestDoneFlags: " + JSON.stringify(requestDoneFlags));
        for (var request in requestDoneFlags) {
            if (!requestDoneFlags[request]) {
                allRequestDone = false;
            }
        }
        return allRequestDone;
    };
    console.log(mIteration + "+++++++++++" + mModule + module_id);
    var iterationtitlePattern = /^([\u4E00-\u9FA5]|[A-Za-z0-9\-.])*$/;
    var moduletitlePattern = /^[a-zA-Z0-9\u4E00-\u9FA5\-_]+$/;
    var vm = new Vue({
        el: '#view-container',
        data: {
            projectIterationDetail: {
                iterationName: "",
                iterationDes: "",
            },
            errorStatus: {
                "iterationName": false,
                "iterationDes": false,
                "have_task": true,
            },
            projectModuleDetail: {
                moduleName: "",
                moduleDes: "",
                ownername: "",
                ownerid: 0,
            },
            dueDate: "",
            startDate: "",
            iteration: mIteration,
            module: mModule,
            showSelf: false,
        },
        watch: {
            projectIterationDetail: {
                handler: function (val, oldVal) {
                    var subject = this.projectIterationDetail.iterationName;
                    if (subject.replace(/\s/g, "") != "") {
                    } else {
                    }
                },
                deep: true
            }
        },
        created: function () {
            self = this;

            this.$nextTick(function () {
                uShowSelf();
            });
            uSetConfirmDialogConfirmedListener(function () {
                self.confirmBack();
            });
        },
        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            uSetChooseDateFinishedListener(function (date) {
                self.chooseDate(date);
            });
            if (mIteration == "true") {
                self.getProjectIterationDetail();
            }
            if (mModule == "true") {
                self.goProjectMoudleDetail();
                self.getUserListByProjectId();
            }
            uSetUpdateWorkItemListener(function () {
                self.updateWorkItem();
            });
            uSetdeleteModuleListener(function () {
                self.deleteModule();
            });
            uSetdeleteIterationListener(function () {
                self.deleteIteration();
            });
            updateIterationTitleListener(function (titleStr) {
                console.log(titleStr);
                if (self.module === 'true') {
                    self.projectModuleDetail.moduleName = titleStr;
                    self.moduleTitleClass();
                    self.changeModuleName();
                } else if (self.iteration === 'true') {
                    self.projectIterationDetail.iterationName = titleStr;
                    self.iterationTitleClass();
                    self.changeIterationName();
                }
            });
            updateIterationDesListener(function (desStr) {
                if (self.module === 'true') {
                    self.projectModuleDetail.moduleDes = desStr;
                    if (self.projectModuleDetail.moduleDes == '') {
                        $('#projectModule_description_input').html("请输入模块描述");
                        var projectModule_description_input = document.getElementById("projectModule_description_input");
                        projectModule_description_input.setAttribute("class", "create_iteration_module_name_hint_des")
                    } else {
                        self.moduleDesClass();
                    }
                    self.changeModuleDes()
                } else if (self.iteration === 'true') {
                    self.projectIterationDetail.iterationDes = desStr;
                    if (self.projectIterationDetail.iterationDes == '') {
                        $('#projectInsertion_description_input').html("请输入迭代描述");
                        var projectInsertion_description_input = document.getElementById("projectInsertion_description_input");
                        projectInsertion_description_input.setAttribute("class", "create_iteration_module_name_hint_des")

                    } else {
                        self.iterationDesClass();
                    }
                    self.changeIterationDes();
                }
            });
        },
        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },
        methods: {
            changeIterationName: function () {
                if (lastIterationName != this.projectIterationDetail.iterationName) {
                    uHideKeyboard();
                    $("#projectiteration_name_input")[0].blur();
                    this.update(false);
                }
            },
            changeIterationDes: function () {
                console.log(lastIterationDes);
                console.log(this.projectIterationDetail.iterationDes);
                if (lastIterationDes != this.projectIterationDetail.iterationDes) {
                    uHideKeyboard();
                    $("#projectiteration_name_input")[0].blur();
                    this.update(false);
                }
            },
            changeModuleName: function () {
                if (lastModuleName != this.projectModuleDetail.moduleName) {
                    uHideKeyboard();
                    $("#projectModule_name_input")[0].blur();
                    this.update(false);
                }
            },
            changeModuleDes: function () {
                if (lastModuleDes != this.projectModuleDetail.moduleDes) {
                    uHideKeyboard();
                    $("#projectModule_description_input")[0].blur();
                    this.update(false);
                }
            },
            confirmBack: function () {
                uHideLoadingPage();
                uFinishCurrentPage();
            },
            goBack: function () {

                if (isSaving) {
                    return;
                }
                if (!self.showSelf) {
                    uFinishCurrentPage();
                } else {
                    if (mModule == "true") {
                        var subject = this.projectModuleDetail.moduleName;
                        var des = this.projectModuleDetail.moduleDes;
                        var ownerid = this.projectModuleDetail.ownerid;
                        console.log(ownerid + "_" + lastOwner);
                        console.log(subject.replace(/\s/g, "") + "_" + lastModuleName);
                        console.log(des.replace(/\s/g, "") + "_" + lastModuleDes);
                        if (subject.replace(/\s/g, "") != lastModuleName || des.replace(/\s/g, "") != lastModuleDes || ownerid != lastOwner) {
                            uHideKeyboard();
                            console.log("baocun");
                            this.update(true);
                        } else {
                            uHideLoadingPage();
                            console.log("bbaocun");
                            uFinishCurrentPage();
                        }
                    }
                    if (mIteration == "true") {
                        var subject = this.projectIterationDetail.iterationName;
                        var des = this.projectIterationDetail.iterationDes;
                        if (subject.replace(/\s/g, "") != lastIterationName || des.replace(/\s/g, "") != lastIterationDes) {
                            uHideKeyboard();
                            this.update(true);
                        } else {

                            uHideLoadingPage();
                            uFinishCurrentPage();
                        }
                    }
                }

            },
            showDatePicker: function (flag) {
                this.startDatePicker = flag;
                uSetData();
            },
            validateIteration: function () {
                var newIterationName = this.projectIterationDetail.iterationName;
                var newIterationDescription = this.projectIterationDetail.iterationDes;
                this.errorStatus.iterationName = false;
                this.errorStatus.iterationDes = false;
                if (newIterationName == "") {
                    uShowToast(stringMap.iteration_name_limit1);
                    this.errorHintMessage = "迭代名称不能为空";
                    this.errorStatus.iterationName = true;
                } else if ((!(newIterationName.match(iterationtitlePattern)))) {
                    uShowToast(stringMap.iteration_name_limit2);
                    this.errorHintMessage = "迭代名称输入不合法";
                    this.errorStatus.iterationName = true;
                } else if ((newIterationDescription.length > 0 && !(newIterationDescription.match(iterationtitlePattern)))) {
                    uShowToast(stringMap.iteration_description_limit2);
                    this.errorHintMessage = "迭代描述输入不合法";
                    this.errorStatus.iterationDes = true;
                } else if (newIterationName.length > 60) {
                    uShowToast(stringMap.iteration_name_limit3);
                    this.errorHintMessage = "迭代名称不能超过60个字符";
                    this.errorStatus.iterationName = true;
                } else if (newIterationDescription && newIterationDescription.length > 255) {
                    uShowToast(stringMap.iteration_description_limit1);
                    this.errorHintMessage = "迭代描述不能超过255个字符";
                    this.errorStatus.iterationDes = true;
                } else {
                    this.errorHintMessage = "";
                    return true;
                }
                return false;
            },
            validateModule: function () {
                var newIterationName = this.projectModuleDetail.moduleName;
                var newIterationDescription = this.projectModuleDetail.moduleDes;
                this.errorStatus.iterationName = false;
                this.errorStatus.iterationDes = false;
                if (newIterationName == "") {
                    uShowToast(stringMap.module_name_limit1);
                    this.errorHintMessage = "模块名称不能为空";
                    this.errorStatus.iterationName = true;
                } else if ((!(newIterationName.match(moduletitlePattern)))) {
                    uShowToast(stringMap.module_name_limit2);
                    this.errorHintMessage = "模块名称输入不合法";
                    this.errorStatus.iterationName = true;
                } else if ((newIterationDescription.length > 0 && !(newIterationDescription.match(moduletitlePattern)))) {
                    uShowToast(stringMap.module_description_limit2);
                    this.errorHintMessage = "模块描述输入不合法";
                    this.errorStatus.iterationDes = true;
                } else if (newIterationName.length > 30) {
                    uShowToast(stringMap.module_name_limit3);
                    this.errorHintMessage = "模块名称不能超过30个字符";
                    this.errorStatus.iterationName = true;
                } else if (newIterationDescription.length > 255) {
                    uShowToast(stringMap.module_description_limit1);
                    this.errorHintMessage = "模块描述不能超过255个字符";
                    this.errorStatus.iterationDes = true;
                } else {
                    this.errorHintMessage = "";
                    return true;
                }
                return false;
            },
            update: function (closePage) {
                console.log("isSaving=" + isSaving);
                self = this;
                if (mIteration == "true") {

                    if (this.validateIteration()) {
                        var newIterationName = this.projectIterationDetail.iterationName.replace(/(^\s*)|(\s*$)/g, "");
                        var newIterationDescription = this.projectIterationDetail.iterationDes.replace(/(^\s*)|(\s*$)/g, "");
                        var self = this;
                        uShowLoadingPage();
                        if (mIteration == "true") {
                            self.checkIterationName(newIterationName, closePage);
                            console.log("迭代更新");
                        }
                    }
                }
                if (mModule == "true") {
                    if (this.validateModule()) {
                        var newIterationName = this.projectModuleDetail.moduleName.replace(/(^\s*)|(\s*$)/g, "");
                        var newIterationDescription = this.projectModuleDetail.moduleDes.replace(/(^\s*)|(\s*$)/g, "");
                        var self = this;
                        uShowLoadingPage();
                        self.updateProjectModuleDetail(closePage);

                    }
                }
            },

            updateProjectIterationDetail: function (closePage) {
                self = this;
                hUpatateIterations({
                    "project_uuid": project_uuid,
                    "iteration_id": iteration_id,
                    "name": self.projectIterationDetail.iterationName,
                    "description": self.projectIterationDetail.iterationDes,
                    "start_date": new Date(this.startDate).getTime(),
                    "due_date": new Date(this.dueDate).getTime(),
                }, function (data) {
                    uHideLoadingPage();
                    lastIterationName = data.iteration.name;
                    lastIterationDes = data.iteration.description;
                    if (closePage) {
                        uFinishCurrentPage();
                    }
                    uSet("needRefreshIteration", "true");
                    isSaving = false;
                    console.log(data);
                }, function (err) {
                    uHideLoadingPage();
                    uShowAlertDialog(err.reason);
                    isSaving = false;
                });
            },
            checkIterationName: function (iterationName, closePage) {
                self = this;
                console.log(self.projectModuleDetail.moduleName);
                if (isSaving) {
                    return;
                }
                isSaving = true;
                console.log(self.projectIterationDetail.iterationName + "___" + lastIterationName);
                if ((self.projectIterationDetail.iterationName) && (self.projectIterationDetail.iterationName == lastIterationName)) {
                    self.checkIterationDate(closePage);
                } else {
                    hCheckIterationName({
                        "project_uuid": project_uuid,
                        "iteration_name": iterationName,
                    }, function (data) {
                        console.log(data.exist + "________");
                        if (data.exist == "true") {
                            uHideLoadingPage();
                            if (closePage) {
                                uFinishCurrentPage();
                            } else {
                                uShowToast(stringMap.iteration_name_duplicate);
                                isSaving = false;
                            }
                        } else {
                            self.checkIterationDate(closePage);
                        }


                    }, function (err) {
                        uHideLoadingPage();
                        isSaving = false;
                        uShowAlertDialog(err.reason);
                    });
                }


            },
            checkIterationDate: function (closePage) {
                self = this;
                a = new Date(self.startDate);
                b = new Date(self.dueDate)
                console.log(a + lastStartDate + b + lastDueDate + (self.startDate) + (self.startDate));
                console.log((self.startDate) + (new Date(self.startDate) == lastStartDate) + (self.dueDate) + (new Date(self.dueDate) == lastDueDate))
                if ((self.startDate) && (new Date(self.startDate).getTime() == lastStartDate.getTime()) && (self.dueDate) && (new Date(self.dueDate).getTime() == lastDueDate.getTime())) {
                    console.log("成功");
                    self.updateProjectIterationDetail(closePage);
                } else {
                    hCheckIterationDate({
                        "project_uuid": project_uuid,
                        "start_date": new Date(self.startDate).getTime(),
                        "due_date": new Date(self.dueDate).getTime(),
                        "iteration_id": iteration_id,
                    }, function (data) {
                        if (data.exist == "true") {
                            if (closePage) {
                                uFinishCurrentPage();
                            } else {
                                uShowToast(stringMap.iteration_overlap);
                                isSaving = false;
                                uHideLoadingPage();
                            }

                        } else {
                            self.updateProjectIterationDetail(closePage);
                        }
                    }, function (err) {
                        uHideLoadingPage();
                        isSaving = false;
                        uShowAlertDialog(err.reason);
                    });
                }

            },
            updateProjectModuleDetail: function (closePage) {
                self = this;
                if (isSaving) {
                    return;
                }
                isSaving = true;
                hCheckModuleName({
                    "project_uuid": project_uuid,
                    "module_name": self.projectModuleDetail.moduleName,
                }, function (data) {
                    console.log(data.exist + "________" + lastModuleName + self.projectModuleDetail.moduleName);
                    if (!data.exist || lastModuleName == self.projectModuleDetail.moduleName) {
                        hUpatateModule({
                            "project_uuid": project_uuid,
                            "module_id": module_id,
                            "name": self.projectModuleDetail.moduleName,
                            "description": self.projectModuleDetail.moduleDes,
                            "owner": self.projectModuleDetail.ownerid
                        }, function (data) {
                            uHideLoadingPage();
                            lastModuleName = data.module.name;
                            lastModuleDes = data.module.description;
                            lastModuleOwnerId = data.module.owner_id;
                            self.projectModuleDetail.ownerid = data.module.owner_id;
                            lastOwner = data.module.owner_id;
                            console.log(closePage + "______________");
                            if (closePage) {
                                uFinishCurrentPage();
                            }
                            isSaving = false;
                            uSet("needRefreshModule", "true");
                            console.log(data);
                        }, function (err) {
                            uHideLoadingPage();
                            uShowAlertDialog(err.reason);
                            isSaving = false;
                        });

                    } else {
                        uHideLoadingPage();
                        if (closePage) {
                            uFinishCurrentPage();
                        } else {
                            isSaving = false;
                            uShowToast(stringMap.module_name_duplicate);
                        }
                    }
                    //新建模块成功 刷新迭代列表
                }, function (err) {
                    uHideLoadingPage();
                    isSaving = false;
                    uShowAlertDialog(err.reason);
                });

            },
            getProjectIterationDetail: function () {
                self = this;
                hGetProjectIterationDetail({
                    "project_uuid": project_uuid,
                    "iteration_id": iteration_id,
                }, function (data) {
                    uHideLoadingPage();
                    console.log(data);
                    self.projectIterationDetail.iterationName = data.iteration.name;
                    lastIterationName = data.iteration.name;
                    if (data.iteration.description != '') {
                        self.projectIterationDetail.iterationDes = data.iteration.description;
                        self.iterationDesClass();
                    }
                    self.projectIterationDetail.have_task = data.iteration.have_task;
                    lastIterationDes = data.iteration.description;
                    self.dueDate = new Date(data.iteration.due_date);
                    lastDueDate = new Date(data.iteration.due_date);
                    self.startDate = new Date(data.iteration.start_date);
                    lastStartDate = new Date(data.iteration.start_date);

                    self.$nextTick(function () {
                        uShowSelf();
                        self.iterationTitleClass();
                        self.showSelf = true;
                    });
                    console.log(self.startDate + "," + self.dueDate);
                    console.log(self.projectIterationDetail.iterationName);
                }, function (err) {
                    uHideLoadingPage();
                    uShowAlertDialog(err.reason);
                    isSaving = false;
                });
            },
            getUserListByProjectId: function () {
                var self = this;
                hGetUserListByProjectId({
                    "project_uuid": project_uuid
                }, function (data) {
                    userList = data.members;
                    requestDoneFlags.getUserListByProjectId = true;
                    if (isAllRequestDone()) {
                        uHideLoadingPage();
                    }
                });
            },
            goProjectMoudleDetail: function () {
                self = this;
                hGetProjectModuleDetail({
                    "project_uuid": project_uuid,
                    "module_id": module_id,
                }, function (data) {

                    requestDoneFlags.goProjectMoudleDetail = true;
                    self.projectModuleDetail.moduleName = data.modulel.name;
                    lastModuleName = data.modulel.name;
                    lastModuleDes = data.modulel.description;
                    console.log(lastModuleName);
                    console.log(lastModuleDes);
                    if (data.modulel.description != '') {
                        console.log("desisnotnull");
                        self.projectModuleDetail.moduleDes = data.modulel.description;
                        self.moduleDesClass();
                    }
                    self.projectModuleDetail.ownername = data.modulel.owner.nickname || data.modulel.owner.name;
                    self.projectModuleDetail.ownerid = data.modulel.owner.id;
                    lastOwner = data.modulel.owner.id;
                    console.log(lastOwner);
                    self.$nextTick(function () {
                        uShowSelf();
                        self.showSelf = true;
                        self.moduleTitleClass();

                    });
                    if (isAllRequestDone()) {
                        uHideLoadingPage();
                    }
                    console.log(data);
                }, function (err) {
                    uHideLoadingPage();
                    uShowAlertDialog(err.reason);
                });
            },
            showItemListPage: function (key) {
                this.listKey = key;
                switch (key) {
                    case 'assigner':
                        uSet("web_view_fragment_title", "选择处理人");
                        uSet("hasSearch", "true");
                        uSet("itemList", JSON.stringify(userList));
                        uSet("searchHint", JSON.stringify(searchHintList["assigner"]));
                        uSet("choosedItem", JSON.stringify(self.projectModuleDetail));
                        break;
                }
                uSet("DescriptionClickFinish", "false");
                uSet("web_view_fragment_url", "file:///android_asset/page/workItemSubPage/workItemList.html");
                uShowSubPage();
            },
            updateWorkItem: function () {
                if (uGet("choosedItem") && uGet("choosedItem") != "") {
                    var choosedItem = JSON.parse(uGet("choosedItem"));
                    if (this.listKey == 'assigner') {
                        var choosedItemGroup = JSON.parse(uGet("choosedItemGroup"));
                        var choosedItem = JSON.parse(uGet("choosedItem"));
                        console.log(JSON.stringify(choosedItemGroup) + "++++++++++++++");
                        console.log(JSON.stringify(choosedItem) + "++++++++++++++");
                        if (choosedItem.id) {
                            nickname = choosedItem.nickname;
                            name = choosedItem.name;
                            console.log(nickname + "_" + name);
                            self.projectModuleDetail.ownername = nickname || name;
                            self.projectModuleDetail.ownerid = choosedItem.id;
                            console.log(self.projectModuleDetail.ownerid + lastOwner);
                            if (self.projectModuleDetail.ownerid != lastOwner) {
                                self.update(false);
                            }
                        }


                    } else {
                    }
                    uSet("choosedItem", "");
                }
            },
            deleteModule: function () {
                uShowLoadingPage();
                hDeleteModule({
                    "project_uuid": project_uuid,
                    "module_id": module_id
                }, function (data) {
                    console.log(data.status);
                    uSet("needRefreshModule", "true");
                    uHideLoadingPage();
                    uFinishCurrentPage();
                }, function (err) {
                    if (err.code == 'DEV_21_40037') {
                        uShowToast(stringMap.module_delete_fail);
                    }
                    uHideLoadingPage();
                });

            },
            deleteIteration: function () {
                self = this;
                uShowLoadingPage();
                if (self.projectIterationDetail.have_task) {
                    uShowToast(stringMap.iteration_delete_fail);
                    uHideLoadingPage();
                    return;
                }
                hDeleteIteration({
                    "project_uuid": project_uuid,
                    "iteration_id": iteration_id
                }, function (data) {
                    console.log(data.status);
                    uSet("needRefreshIteration", "true");
                    uHideLoadingPage();
                    uFinishCurrentPage();
                });

            },
            chooseDate: function (date) {
                //判断日期是否合法
                if (this.startDatePicker) {
                    if (new Date(date).getTime() > new Date(this.dueDate).getTime() && formatDateTime(new Date(date), 'yyyy-MM-dd') != formatDateTime(new Date(this.dueDate), 'yyyy-MM-dd')) {
                        uShowToast(stringMap.date_limit1);
                    } else {
                        this.startDate = new Date(date);
                        this.update(false);
                        uSet("startDateStamp", this.startDate.getTime());
                    }
                } else {
                    if (new Date(date).getTime() < new Date(this.startDate).getTime() && formatDateTime(new Date(date), 'yyyy-MM-dd') != formatDateTime(new Date(this.startDate), 'yyyy-MM-dd')) {
                        uShowToast(stringMap.date_limit2);
                    }
                    else {
                        this.dueDate = new Date(date);
                        this.update(false);
                    }
                }
            },
            goTitlePage: function () {
                if (this.module === 'true') {
                    uGoTitlePageWithStr(this.projectModuleDetail.moduleName);
                } else if (this.iteration === 'true') {
                    uGoTitlePageWithStr(this.projectIterationDetail.iterationName);

                }
            },
            goDesPage: function () {
                if (this.module === 'true') {
                    uGoDesPageWithStr(this.projectModuleDetail.moduleDes);
                } else if (this.iteration === 'true') {
                    uGoDesPageWithStr(this.projectIterationDetail.iterationDes);
                }
            },
            iterationTitleClass: function () {
                var projectiteration_name_input = document.getElementById("projectiteration_name_input");
                projectiteration_name_input.innerHTML = self.projectIterationDetail.iterationName;
                projectiteration_name_input.setAttribute('style', 'color: #333333');
                if ($('#projectiteration_name_input').height() > 170) {
                    projectiteration_name_input.setAttribute("class", "create_iteration_module_name_text")
                }
            },
            iterationDesClass: function () {
                var projectInsertion_description_input = document.getElementById("projectInsertion_description_input");
                projectInsertion_description_input.innerHTML = self.projectIterationDetail.iterationDes;
                console.log($('#projectInsertion_description_input').height());
                if ($('#projectInsertion_description_input').height() > 131) {
                    console.log("131_" + $('#projectInsertion_description_input').height());
                    projectInsertion_description_input.setAttribute("class", "create_iteration_module_name_des")
                }
                if ($('#projectInsertion_description_input').height() > 245) {
                    console.log("245_" + $('#projectInsertion_description_input').height());
                    var text = $('#projectInsertion_description_input').html() + '...';
                    while ($('#projectInsertion_description_input').height() > 245) {
                        console.log("245_while" + $('#projectInsertion_description_input').height());
                        text = text.substr(0, text.length - 4) + '...';
                        $('#projectInsertion_description_input').html(text);
                    }
                }
            },
            moduleTitleClass: function () {
                var projectModule_name_input = document.getElementById("projectModule_name_input");
                projectModule_name_input.innerHTML = self.projectModuleDetail.moduleName;
                projectModule_name_input.setAttribute('style', 'color: #333333');
                if ($('#projectModule_name_input').height() > 170) {
                    projectModule_name_input.setAttribute("class", "create_iteration_module_name_text")
                }
            },
            moduleDesClass: function () {
                var projectModule_description_input = document.getElementById("projectModule_description_input");
                projectModule_description_input.innerHTML = self.projectModuleDetail.moduleDes;
                console.log($('#projectModule_description_input').height());
                if ($('#projectModule_description_input').height() > 131) {
                    console.log("131_" + $('#projectModule_description_input').height());
                    projectModule_description_input.setAttribute("class", "create_iteration_module_name_des")
                }
                if ($('#projectModule_description_input').height() > 245) {
                    console.log("245_" + $('#projectModule_description_input').height());
                    var text = $('#projectModule_description_input').html() + '...';
                    while ($('#projectModule_description_input').height() > 245) {
                        console.log("245_while" + $('#projectModule_description_input').height());
                        text = text.substr(0, text.length - 4) + '...';
                        $('#projectModule_description_input').html(text);
                    }
                }
            },
        }
    })

}