window.onload = function () {
    var project_uuid = uGet("project_uuid");
    var mIteration = uGet("iteration");
    var mDomains = uGet("domains");
    var mModule = uGet("module");
    console.log(mIteration + "+++++++++++" + mDomains + "+++++" + mModule);
    var vm = new Vue({
        el: '#view-container',
        data: {
            projectMoudle: {
                title: "",
                creator: "",
                create_time: "",
                description: "",
            },
            showSelf: false,
            iterations: [],
            fixediterations: [],
            modules: [],
            fixedmodules: [],
            domains: [],
            finaldomains: [],
            iteration: mIteration,
            module: mModule,
            domain: mDomains,
            queryValue: "",
        },
        created: function () {
            this.$nextTick(function () {
                uShowSelf();
            });

        },

        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            if (mIteration == "true") {
                self.getIterations();
            }
            if (mModule == "true") {
                self.getModules();
            }
            if (mDomains == "true") {
                self.getAllDomains();
            }

            uSetGetIterationsListener(function () {
                self.getIterations();
            });
            uSetGetModuleListener(function () {
                self.getModules();
            });

        },
        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },
        methods: {
            goBack: function () {
                uFinishCurrentPage();
            },

            goProjectIterationDetail: function (iteration) {
                console.log(iteration.id);
                uSet("iteration_id", iteration.id);
                uSet("iteration_name", iteration.name);
                uGoProjectIterationDetail();
            },
            goProjectModuleDetail: function (module) {
                uSet("module_id", module.id);
                uSet("module_name", module.name);
                console.log(module.id + "_________");
                uGoProjectModuleDetail();
            },
            addDate: function (date, days) {
                if (days == undefined || days == '') {
                    days = 0;
                }
                var date = new Date(date);
                date.setDate(date.getDate() + days);
                var month = date.getMonth() + 1;
                var day = date.getDate();
                return date.getFullYear() + '-' + self.getFormatDate(month) + '-' + self.getFormatDate(day);
            },
            getIterations: function () {
                self = this;
                uShowLoadingPage();
                console.log("_____________");
                hGetIterations({
                    "project_uuid": project_uuid,
                }, function (data) {
                    console.log(data);
                    uSet("needRefreshIteration", "false");
                    self.iterations = data.iterations;
                    self.fixediterations = data.iterations;
                    if (data.iterations.length > 0) {
                        var lastdata = data.iterations[data.iterations.length - 1];
                        uSet("startDate", self.addDate(lastdata.due_date, 1));
                        uSet("dueDate", self.addDate(lastdata.due_date, 2));
                    } else {
                        $('#no_iteration_result').html('暂无迭代');

                        uSet("startDate", self.addDate(new Date(), 0));
                        uSet("dueDate", self.addDate(new Date(), 1));
                    }
                    console.log(uGet("startDate"));
                    console.log(uGet("dueDate"));
                    uHideLoadingPage();
                    self.$nextTick(function () {
                        uShowSelf();
                        self.showSelf = true;
                    });
                });
            },
            getModules: function () {
                self = this;
                uShowLoadingPage();
                hGetModules({
                    "project_uuid": project_uuid,
                }, function (data) {
                    console.log(data);
                    uSet("needRefreshModule", "false");
                    self.modules = data.modules;
                    self.fixedmodules = data.modules;
                    if (self.modules.length == 0) {
                        $('#no_module_result').html('暂无模块');
                    }
                    self.$nextTick(function () {
                        uShowSelf();
                        self.showSelf = true;
                    });
                    uHideLoadingPage();
                });
            },
            getDomains: function () {
                self = this;
                uShowLoadingPage();
                hGetDomains({
                    "project_uuid": project_uuid,
                }, function (data) {
                    console.log(data);
                    for (var i = 0; i < self.domains.length; i++) {
                        for (var j = 0; j < data.domains.length; j++) {
                            if (self.domains[i].id == data.domains[j].id) {
                                self.domains[i].isopen = true;
                            }
                        }
                    }
                    self.finaldomains = self.domains;
                    self.$nextTick(function () {
                        uShowSelf();
                        self.showSelf = true;
                    });
                    console.log(JSON.stringify(data));
                    uHideLoadingPage();
                });
            },
            closeOropenDomain: function (domain) {
                self = this;
                if (domain.isopen) {
                    self.closeDomain(domain);
                } else {
                    self.openDomain(domain);
                }
            },
            getAllDomains: function () {
                self = this;
                uShowLoadingPage();
                hGetAllDomains({}, function (data) {
                    self.domains = data.domains;
                    self.getDomains();
                });
            },
            openDomain: function (domain) {
                console.log("______________开启");
                self = this;
                hOpenDomains({
                    "project_uuid": project_uuid,
                    "domain_id": domain.id,
                }, function (data) {
                    console.log(data);
                    domain.isopen = true;
                    for (var i = 0; i < self.domains.length; i++) {
                        if (self.finaldomains[i].id == domain.id) {
                            self.finaldomains[i].isopen = true;
                            Vue.set(self.finaldomains, i, self.finaldomains[i]);

                        }
                    }
                });
            },
            closeDomain: function (domain) {
                console.log("______________关闭");
                self = this;
                hCloseDomains({
                    "project_uuid": project_uuid,
                    "domain_id": domain.id,
                }, function (data) {
                    domain.isopen = false;
                    for (var i = 0; i < self.domains.length; i++) {
                        if (self.finaldomains[i].id == domain.id) {
                            self.finaldomains[i].isopen = false;
                            Vue.set(self.finaldomains, i, self.finaldomains[i]);
                        }
                    }

                }, function (err) {
                    if (err.code == 'DEV_21_40036') {
                        uShowToast(stringMap.domain_delete_fail);
                    }
                });
            },

            // 日期月份/天的显示，如果是1位数，则在前面加上'0'
            getFormatDate: function (arg) {
                if (arg == undefined || arg == '') {
                    return '';
                }

                var re = arg + '';
                if (re.length < 2) {
                    re = '0' + re;
                }

                return re;
            },
            search: function () {
                console.log("queryValue:" + this.queryValue);
                console.log("iteration:" + this.iteration);
                console.log("module:" + this.module);
                if (this.queryValue != "") {
                    if (this.iteration == 'true') {
                        this.iterations = [];
                        for (var i = 0; i < this.fixediterations.length; i++) {
                            console.log(this.fixediterations[i].name);
                            if (this.fixediterations[i].name.indexOf(this.queryValue) >= 0) {
                                this.iterations.push(this.fixediterations[i]);
                            }
                        }
                        console.log(this.iterations.length+"——————————————");
                        if (this.iterations.length == 0) {
                            $('#no_iteration_result').html('没有匹配的迭代');
                        }
                    } else if (this.module == 'true') {
                        console.log("module");
                        this.modules = [];
                        for (var i = 0; i < this.fixedmodules.length; i++) {
                            console.log(this.fixedmodules[i].name);
                            if (this.fixedmodules[i].name.indexOf(this.queryValue) >= 0) {
                                this.modules.push(this.fixedmodules[i]);
                            }
                        }
                        console.log(this.modules.length+"——————————————");
                        if (this.modules.length == 0) {
                            $('#no_module_result').html('没有匹配的模块');

                        }
                    }
                } else {
                    if (this.module == 'true') {
                        this.modules = this.fixedmodules;
                        $('#no_module_result').html('暂无模块');

                    } else if (this.iteration == 'true') {
                        this.iterations = this.fixediterations;
                        $('#no_iteration_result').html('暂无迭代');

                    }
                }
            },
        },
        watch: {
            queryValue: function (val, oldVal) {
                console.log("watch");
                this.search();
            }
        }
    })

}