window.onload = function () {
    console.log("starttime_showloading");
    uShowLoadingPage();
    var issueId = uGet("issue_id");
    var originalProjectUUId = uGet("project_uuid");
    var issue = null;
    var attachmentLongPressed = false;

    var TITLE_PATTERN = /^[a-zA-Z0-9\u4E00-\u9FA5\s\^\-_*&`~\\/|;；:：{},!@#$&().'\&quot;\[\]<>?·！（）——、‘“”？—。，《》%【】\\+]+$/;
    var DESCRIPTION_PATTERN = /\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F]/g;
    var currentUserInfo = {};
    var projectList = [];
    var userList = [];
    var iterationList = [];
    var moduleList = [];
    var domainList = [];
    var fileCount = 0;
    var totalSize = 0;
    var lastSubject = "";
    var params = {};
    var typeList = [
        {'name': '需求', 'checked': false, 'id': '1', 'sid': 0},
        {'name': '任务', 'checked': false, 'id': '2', 'sid': 1},
        {'name': '缺陷', 'checked': true, 'id': '3', 'sid': 2}
    ];
    var priorityList = [
        {'name': '低', 'checked': false, 'id': '1', 'sid': 0},
        {'name': '中', 'checked': true, 'id': '2', 'sid': 1},
        {'name': '高', 'checked': false, 'id': '3', 'sid': 2}
    ];
    var searchHintList = {
        'project': ['没有找到相匹配的项目'],
        'assigner': ['没有找到相匹配的人员'],
        'iteration': ['没有找到相匹配的迭代', '当前项目下没有迭代'],
        'module': ['没有找到相匹配的模块', '当前项目下没有模块'],
        'domain': ['没有找到相匹配的领域', '当前项目下没有领域']
    };
    var timeOutEvent = 0;
    var isSaving = false;
    var myScroll;
    var firstGetComment = true;
    var requestDoneFlags = {
        getIssueDetail: false,
        getUserBetaStatus: false
    };
    var isAllRequestDone = function () {
        var allRequestDone = true;
        for (var request in requestDoneFlags) {
            if (!requestDoneFlags[request]) {
                allRequestDone = false;
            }
        }
        console.log("requestDoneFlags:" + JSON.stringify(requestDoneFlags));
        return allRequestDone;
    };
    var originHeight = window.innerHeight;
    var vm = new Vue({
        el: '#view-container',
        data: {
            listKey: "",
            workItemInfo: {
                'type': {},
                'priority': {},
                'status': {},
                'project': {},
                'assigner': {},
                'startDate':  new Date(),
                'dueDate': new Date(new Date().getTime() + 1 * 3600000 * 24),
                'subject': '',
                'description': '',
                'issueId': '',
                'author': {},
                'severity': {},
                'tagList': [],
                'iteration': {},
                'module': {},
                'domain': {}
            },
            hasChildOrParent: false,
            hasChild: false,
            canClose: true,
            canDelete:false,
            canFullEdit:false,
            canPartEdit:false,
            allTaglist: [],
            tmpTagList:[],
            showMoreFlag:false,
            rearrangedDescriptionText:"",
            rearrangedDescriptionImg: "",
            comment: true,
            history: false,
            uploadStates: {
                "DONE":0,
                "DOING": 1,
                "FAILED": 2,
                "TIMEOUT": 3
            },
            downloadStates: {
                "DONE":0,
                "DOING": 1,
                "TODO": 2
            },
            commentList:[],
            historyList: [{member:"李晓明",time:"2017/2/18",content:{type:"create",detail:"创建了工作项"}},
                {member:"李晓明",time:"2017/2/19",content:{type:"update",detail:'更新截止时间为2017年5月8日18:00'}},
                {member:"张莉",time:"2017/2/20",content:{type:"update",detail:'更新工作项状态为"测试中"'}},
                {member:"李晓明",time:"2017/2/22",content:{type:"update",detail:'更新工作项状态为"已解决"'}},
                {member:"李晓明",time:"2017/2/28",content:{type:"complete",detail:'完成了工作项"'}}],
            attachmentList: [],
            record:false,
            attachmentDeleteButton:false,
            tagColor: "#48cfad",
            originalWorkItemInfo:null,
            newComment: "",
            isKeyboardShown: false,
            keyboardHeight: 0,
            inputHeight:144,
            windowHeight:0,
            hasComment:false,
            betaStatus:0,
            isUploading:false
        },

        mounted: function () {
            //清空缓存
            uSet("queryProjectTags","false");
            uSet("domainList","");
            uSet("moduleList","");
            uSet("iterationList","");
            uSet("projectList","");
            uSet("statusList","");
            uSet("severityList","");
            uSet("userList","");

            uSetSaveButtonClickable("false");
            var self = this;
            uSetCheckDataListener(function () {
                self.checkData();
            });

            uSetUpdateAttachmentListener(function (args) {
                    self.updateAttachment(args);
            });

            uSetUpdateDataListener(function () {
                self.updateData();
            });

            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });

            uSetPublicCompleteButtonClickListener(function () {
                self.save();
            });

            uSetPublicDeletePositiveButtonClickListener(function () {
                self.deleteWorkItem();
            });

            uSetOpenSingleAttachmentFinishedListener(function (src,duration,fileSize) {
                var maxSize = uIsSelfRegion() ? 4 : 10;
                if (fileSize > maxSize * 1024 * 1024) {
                    var index1=src.lastIndexOf("/");
                    var index2=src.lastIndexOf(".");
                    var fileName=src.substring(index1+1);
                    uShowAlertDialog("文件" + fileName + "大小超过" + maxSize + "MB限制,上传失败");
                } else {
                    if (totalSize + fileSize > 20 * 1024 * 1024){
                        uShowAlertDialog("附件总大小超过20M限制，上传失败");
                    } else {
                        self.uploadAttachment(src,fileSize);
                    }
                }
            });

            uSetOpenMultipleAttachmentFinishedListener(function (srcGroup) {
                var maxSize = uIsSelfRegion() ? 4 : 10;
                srcGroup = JSON.parse(srcGroup);
                for (var i = 0; i < srcGroup.length; i++) {
                    if (srcGroup[i].fileSize > maxSize * 1024 * 1024) {
                        var index1=srcGroup[i].src.lastIndexOf("/");
                        var index2=srcGroup[i].src.lastIndexOf(".");
                        var fileName=srcGroup[i].src.substring(index1+1);
                        uShowAlertDialog("文件" + fileName + "大小超过" + maxSize + "MB限制,上传失败");
                    } else {
                        if (totalSize + srcGroup[i].fileSize > 20 * 1024 * 1024){
                            uShowAlertDialog("附件总大小超过20M限制，上传失败");
                            break;
                        } else {
                            self.uploadAttachment(srcGroup[i].src,srcGroup[i].fileSize);
                        }
                    }
                }
            });

            uSetConfirmDialogConfirmedListener(function () {
                self.conformDeleteWorkItem();
            });

            uSetUpdateWorkItemListener(function () {
                self.updateWorkItem();
            });

            uSetKeyboardHeightListener(function (height) {
                self.isKeyboardShown = height == "0" ? false: true;
                self.keyboardHeight = Number(height);
                self.showKeyboard(self.keyboardHeight);
            });

            $(window).on('touchstart', function (event) {
                if (!attachmentLongPressed && self.attachmentDeleteButton) {
                    self.attachmentDeleteButton = false;
                }
            });

            this.requestData();
        },

        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },

        watch: {
            attachmentList:function(val,oldVal){
                if (this.attachmentList.length) {
                    $("#wrapper").css("height", 310 + "px");
                } else {
                    $("#wrapper").css("height", 0);
                }
            }
        },

        methods: {
            changeSubject: function () {
                if (lastSubject != this.workItemInfo.subject) {
                    uHideKeyboard();
                    $("#autoTest_workItem_title")[0].blur();
                    this.save();
                }
            },
            checkData: function () {
                console.log("checkData");
                if (this.workItemInfo.project.id == null) {
                    uShowLoadingPage();
                    requestDoneFlags = {
                        getIssueDetail: false,
                        getUserBetaStatus: false
                    };
                    this.requestData();
                }
            },
            updateAttachment: function (args) {
                console.log("updateAttachment:" + args);
                this.isUploading = false;
                if (args != "") {
                    var self = this;
                    hShowIssueDetail({
                        "issue_id": issueId,
                        "project_uuid": originalProjectUUId
                    }, function (data) {
                        issue = data.issueDetail.issue;
                        if (issue.attachments) {
                            if (self.attachmentList.length == 0) {
                                $("#wrapper").css("height", 310 + "px");
                                for (var i = 0; i < issue.attachments.length; i++) {
                                    var fileName = issue.attachments[i].filename;

                                    var index1 = fileName.lastIndexOf("/");
                                    var index2 = fileName.lastIndexOf(".");
                                    var realName = fileName.substring(index1 + 1);

                                    var suffix = fileName.substring(fileName.lastIndexOf(".") + 1).toLowerCase();
                                    if (suffix == "gif" || suffix == "jpeg" || suffix == "jpg" || suffix == "png" || suffix == "bmp") {
                                        fileName = "../../theme/image/workItem-attachment-pic.png";
                                        self.addAttachment(fileName, issue.attachments[i].filesize, UPLOAD_STATES.DONE, issue.attachments[i], DOWNLOAD_STATES.TODO, realName);
                                    } else {
                                        self.addAttachment(fileName, issue.attachments[i].filesize, UPLOAD_STATES.DONE, issue.attachments[i], DOWNLOAD_STATES.TODO);
                                    }
                                }
                            }
                        }
                    }, function (data) {

                    });
                }
            },
            updateData: function () {
                console.log("updateData");
                uShowLoadingPage();
                requestDoneFlags = {
                    getIssueDetail: false,
                    getUserBetaStatus: false
                };
                this.requestData();
            },
            requestData: function () {
                var self = this;
                self.getUserBetaStatus();
                console.log("starttime_hShowIssueDetail");
                hShowIssueDetail({
                    "issue_id": issueId,
                    "project_uuid": originalProjectUUId
                }, function (data) {
                    console.log("endtime_hShowIssueDetail");

                    issue = data.issueDetail.issue;
                    currentUserInfo = data.userInfo;
                    if (data.issueRole.is_master == 1) {
                        self.canDelete = true;
                    }
                    if ((data.issueRole.is_author == 1) || (data.issueRole.is_master == 1) || (data.issueRole.is_assigned == 1)) {
                        self.canPartEdit = true;
                        if ((data.issueRole.is_author == 1) || (data.issueRole.is_master == 1)) {
                            self.canFullEdit = true;
                        }
                    }
                    var tmpCommentList = data.issueComments.comments;
                    for (var i = tmpCommentList.length - 1; i >= 0; i--) {
                        if (tmpCommentList[i].user.id == currentUserInfo.id) {
                            tmpCommentList[i].user.role = "me";
                        } else {
                            tmpCommentList[i].user.role = "other";
                        }
                        tmpCommentList[i].user.displayName = tmpCommentList[i].user.first_name.substring(0,1).toUpperCase();
                        tmpCommentList[i].content = {type:"text",detail:tmpCommentList[i].content};
                        self.commentList.push(tmpCommentList[i]);
                    }

                    if (issue != null) {
                        if ((issue.parent && issue.parent.id && issue.parent.id != 0) || (issue.children && issue.children.length != 0)) {
                            self.hasChildOrParent = true;
                        }
                        if (issue.children && issue.children.length != 0) {
                            self.hasChild = true;
                            for (var i = 0; i < issue.children.length; i++) {
                                if (issue.children[i].status_id != 5) {
                                    self.canClose = false;
                                    break;
                                }
                            }
                        }

                        uSet("parent_issue_name",issue.subject);
                        uSet("parent_issue_id",issue.id + "");

                        self.workItemInfo.type = issue.type;
                        self.workItemInfo.priority = issue.priority;
                        self.workItemInfo.status = issue.status;
                        self.workItemInfo.project = issue.project;
                        self.workItemInfo.assigner = issue.assigned_to;
                        self.workItemInfo.author = issue.author;
                        self.workItemInfo.startDate = issue.start_date;
                        self.workItemInfo.dueDate = issue.due_date;
                        self.workItemInfo.subject = issue.subject;
                        self.workItemInfo.description = issue.description;
                        self.workItemInfo.issueId = issue.id;
                        self.workItemInfo.severity = issue.severity;

                        if (issue.tags) {
                            for (var i = 0; i < issue.tags.length; i++) {
                                if (issue.tags[i].color_id == 0) {
                                    issue.tags[i].color_id = 8;
                                }
                            }
                        }

                        self.workItemInfo.tagList = issue.tags ? issue.tags : [];
                        self.workItemInfo.iteration = {};
                        self.workItemInfo.module = {};
                        self.workItemInfo.domain = {};

                        lastSubject = issue.subject;
                        if (issue.attachments) {
                            if (self.attachmentList.length == 0) {
                                $("#wrapper").css("height", 310 + "px");
                                for (var i = 0; i < issue.attachments.length; i++) {
                                    var fileName = issue.attachments[i].filename;

                                    var index1=fileName.lastIndexOf("/");
                                    var index2=fileName.lastIndexOf(".");
                                    var realName=fileName.substring(index1+1);

                                    var suffix=fileName.substring(fileName.lastIndexOf(".") + 1).toLowerCase();
                                    if (suffix == "gif" || suffix == "jpeg" || suffix == "jpg" || suffix == "png" || suffix == "bmp"){
                                        fileName = "../../theme/image/workItem-attachment-pic.png";
                                        self.addAttachment(fileName,issue.attachments[i].filesize,UPLOAD_STATES.DONE,issue.attachments[i],DOWNLOAD_STATES.TODO,realName);
                                    } else {
                                        self.addAttachment(fileName,issue.attachments[i].filesize,UPLOAD_STATES.DONE,issue.attachments[i],DOWNLOAD_STATES.TODO);
                                    }
                                }
                            }
                        }

                        if (issue.iteration && issue.iteration.name) {
                            self.workItemInfo.iteration = issue.iteration;
                        } else {
                            self.workItemInfo.iteration = {'name': '待分配','id':-1};
                        }
                        if (issue.module && issue.module.name) {
                            self.workItemInfo.module = issue.module;
                        } else {
                            self.workItemInfo.module = {'name': '待分配','id':-1};
                        }
                        if (issue.domain && issue.domain.name) {
                            self.workItemInfo.domain = issue.domain;
                        } else {
                            self.workItemInfo.domain = {'name': '待分配','id':-1};
                        }
                        self.originalWorkItemInfo = _.clone(self.workItemInfo);
                        uSet("workItemInfo",JSON.stringify(self.workItemInfo));
                        self.rearrangeDescription();
                        self.setTags();
                        self.setList(typeList,self.workItemInfo.type.id);
                        self.setList(priorityList,self.workItemInfo.priority.id);

                        uSetWorkItemDetail(JSON.stringify(self.workItemInfo));
                        requestDoneFlags.getIssueDetail = true;
                        if (isAllRequestDone()) {
                            uHideLoadingPage();
                            console.log("endtime_showloading");
                            console.log("originalProjectUUId_issueId:" + uGet(originalProjectUUId + '_' + issueId));
                            if (uGet(originalProjectUUId + '_' + issueId) == "isUploading") {
                                self.isUploading = true;
                                uAddCallback();
                            }
                            uShowSelf();
                            $(".workItem_sendComment_textarea").bind('input propertychange', function() {
                                self.changeHeight();
                            });
                            self.windowHeight = window.innerHeight;
                            var input = $("#comment-input")[0];
                            input.style.top = self.windowHeight - self.inputHeight + "px";

                            var div = $(".workItem_content")[0];
                            div.style.height = self.windowHeight - 144 + "px";

                            uSetSaveButtonClickable("true");
                        }
                    }
                }, function (data) {
                    if (data.code == "DEV_21_100401" || data.code == "DEV_21_100169" || data.code == "DEV_21_100161") {
                        uHideLoadingPage();
                        uShowToast(data.reason);
                        setTimeout(function () {
                            self.goBack();
                        },1000);
                    } else {
                        uHideLoadingPage();
                        uShowAlertDialog(data.reason);
                    }
                    uShowSelf();
                });
            },
            getUserBetaStatus: function () {
                var self = this;
                console.log("starttime_hUserBetaStatus");
                hUserBetaStatus({
                    "project_uuid": originalProjectUUId
                }, function (result) {
                    console.log("endtime_hUserBetaStatus");
                    console.log("hUserBetaStatus" + JSON.stringify(result));
                    if (2 === result.order_status) {
                        self.betaStatus = 1;//已冻结
                    } else if (0 === result.status && 0 === result.free_quota) {
                        self.betaStatus = 2;//已关闭
                    } else {
                        self.betaStatus = 0;
                    }
                    requestDoneFlags.getUserBetaStatus = true;
                    if (isAllRequestDone()) {
                        uHideLoadingPage();
                        console.log("endtime_showloading");
                        console.log("originalProjectUUId_issueId:" + uGet(originalProjectUUId + '_' + issueId));
                        if (uGet(originalProjectUUId + '_' + issueId) == "isUploading") {
                            self.isUploading = true;
                            uAddCallback();
                        }
                        uShowSelf();
                        $(".workItem_sendComment_textarea").bind('input propertychange', function() {
                            self.changeHeight();
                        });
                        self.windowHeight = window.innerHeight;
                        var input = $("#comment-input")[0];
                        input.style.top = self.windowHeight - self.inputHeight + "px";

                        var div = $(".workItem_content")[0];
                        div.style.height = self.windowHeight - 144 + "px";

                        uSetSaveButtonClickable("true");
                    }
                });
            },
            getIssueRole: function (project) {
                var self = this;
                uShowLoadingPage();
                hGetIssueRole({
                    "issue_id": issueId,
                    "project_uuid": project
                }, function (data) {
                    if (data.is_master == 1) {
                        self.canDelete = true;
                    }
                    if ((data.is_author == 1) || (data.is_master == 1) || (data.is_assigned == 1)) {
                        self.canPartEdit = true;
                        if ((data.is_author == 1) || (data.is_master == 1)) {
                            self.canFullEdit = true;
                        }
                    }
                    uHideLoadingPage();
                });
            },
            inputFocus: function () {
                $(".workItem_sendComment_textarea").focus();
            },
            changeHeight:function () {
                var input = $("#comment-input")[0];
                this.inputHeight = $("#comment-input")[0].clientHeight;
                input.style.top = this.windowHeight - this.keyboardHeight  - this.inputHeight + "px";

                var div = $(".workItem_content")[0];
                div.style.height = this.windowHeight - this.keyboardHeight - this.inputHeight + "px";

                if ($(".workItem_sendComment_textarea").text() == "") {
                    this.hasComment = false;
                } else {
                    this.hasComment = true;
                }
            },
            updateWorkItem: function () {
                if (uGet("choosedItem") && uGet("choosedItem") != "") {
                    var choosedItem = JSON.parse(uGet("choosedItem"));
                    if (this.listKey == 'assigner') {
                        var choosedItemGroup = JSON.parse(uGet("choosedItemGroup"));
                        this.chooseItemFromList(choosedItem,choosedItemGroup);
                    } else {
                        this.chooseItemFromList(choosedItem);
                    }
                    uSet("choosedItem","");
                }
                if ((uGet("startDate") && uGet("startDate") != "") || (uGet("dueDate") && uGet("dueDate") != "")) {
                    if (this.hasChild) {
                        uShowAlertDialog("父工作项的计划时间不能被修改");
                    } else {
                        params = {};
                        if (uGet("startDate") && uGet("startDate") != "") {
                            params["start_date"] = new Date(JSON.parse(uGet("startDate"))).getTime();
                        }
                        if (uGet("dueDate") && uGet("dueDate") != "") {
                            params["due_date"] = new Date(JSON.parse(uGet("dueDate"))).getTime();
                        }
                        this.save();
                    }
                    uSet("startDate","");
                    uSet("dueDate","");
                }

                if (uGet("tagColor") && uGet("tagColor") != "") {
                    this.tagColor = JSON.parse(uGet("tagColor"));
                    uSet("tagColor","");
                }
                if (uGet("allTaglist") && uGet("allTaglist") != "") {
                    this.allTaglist = JSON.parse(uGet("allTaglist"));
                    this.saveTags();
                    uSet("allTaglist","");
                }
            },
            touchStartForDelete: function () {
                var self = this;
                timeOutEvent = setTimeout(function () {
                    timeOutEvent = 0;
                    self.attachmentDeleteButton = true;
                },500);
                attachmentLongPressed = true;
            },
            touchMoveForDelete: function () {
                clearTimeout(timeOutEvent);
                timeOutEvent = 0;
            },
            touchEndForDelete: function () {
                clearTimeout(timeOutEvent);
                attachmentLongPressed = false;
            },
            setScrollWidth: function () {
                $("#scroller").css("width", 240*this.attachmentList.length + "px");
                myScroll = new IScroll('#wrapper', { eventPassthrough: true, scrollX: true, scrollY: false, preventDefault: false });
            },
            rearrangeDescription: function () {
                this.rearrangedDescriptionText = this.workItemInfo.description.replace(/<img [^>]*src=['"]([^'"]+)[^>]*>/gi, function (match) {
                    return "";
                });
                this.rearrangedDescriptionText = this.rearrangedDescriptionText.replace(/<\/?[^>]*>/g,"");

            },
            goBack: function () {

                if (lastSubject != this.workItemInfo.subject) {
                                    uHideKeyboard();
                                    this.save(false,true);
                 }
                console.log("src:++++++++++++++++++++++++++++++++++" + isSaving);
                if (isSaving) {
                    return;
                }
                console.log("src:++++++++++++++++++++++++++++++++++" + isSaving);
                uHideLoadingPage();
                uFinishCurrentPage();
                console.log("src:++++++++++++++++++++++++++++++++++uFinishCurrentPage" + isSaving);

            },
            save: function (changeProject,closePage) {
                var self = this;
                if(this.canPartEdit || this.canFullEdit) {
                    if (isSaving) {
                        return;
                    }
                    var subject = this.workItemInfo.subject;
                    if (subject.replace(/\s/g, "") == "") {
                        uShowAlertDialog("工作项标题不能为空或空格");
                    } else if (this.workItemInfo.subject.length > 128) {
                        uShowAlertDialog("工作项标题最大长度不超过128个字符!");
                    } else if ((!(this.workItemInfo.subject.match(TITLE_PATTERN)))) {
                        uShowAlertDialog("工作项标题只能包含汉字、英文大小写字母、数字、空格、标点和部分特殊字符!");
                    } else if (this.workItemInfo.description.length > 10000) {
                        uShowAlertDialog("工作项描述不能超过10000个字符");
                    } else if (this.workItemInfo.description.match(DESCRIPTION_PATTERN)) {
                        uShowAlertDialog("工作项描述只能包含汉字、英文大小写字母、数字、空格、标点和部分特殊字符!");
                    } else if (this.workItemInfo.iteration && this.workItemInfo.iteration.id && ((new Date(this.workItemInfo.dueDate).getTime() < new Date(this.workItemInfo.iteration.start_date).getTime()) || (new Date(this.workItemInfo.dueDate).getTime() > new Date(this.workItemInfo.iteration.due_date).getTime()))) {
                        uShowAlertDialog("工作项结束时间必须在迭代时间段" + this.workItemInfo.iteration.start_date + "至" + this.workItemInfo.iteration.due_date + "内!");
                    } else {
                        if (!changeProject) {
                            params["project_uuid"] = this.workItemInfo.project.uuid || this.workItemInfo.project.project_uuid;
                        }
                        params["issue_id"] = issueId;
                        params["subject"] = this.workItemInfo.subject.replace(/(^\s*)|(\s*$)/g, "");

                        isSaving = true;
                        console.log("src:++++++++++++++++++++++++++++++++++更新工作项之前" + isSaving);

                        uShowLoadingPage();
                        hUpdateIssue(params, function (data) {
                            uShowToast("工作项更新成功");
                            initialize();
                            uSet("needRequestAwaitWorkItem","true");
                            isSaving = false;
                            console.log("src:++++++++++++++++++++++++++++++++++更新工作项成功" + closePage);
                            if(closePage){
                               uHideLoadingPage();
                               uFinishCurrentPage();
                            }
                            console.log("src:++++++++++++++++++++++++++++++++++更新工作项成功" + isSaving);
                            issue = data.issue;

                            if (issue != null) {
                                if ((issue.parent && issue.parent.id && issue.parent.id != 0) || (issue.children && issue.children.length != 0)) {
                                    self.hasChildOrParent = true;
                                }
                                if (issue.children && issue.children.length != 0) {
                                    self.hasChild = true;
                                    for (var i = 0; i < issue.children.length; i++) {
                                        if (issue.children[i].status_id != 5) {
                                            self.canClose = false;
                                            break;
                                        }
                                    }
                                }

                                uSet("parent_issue_name",issue.subject);
                                uSet("parent_issue_id",issue.id + "");

                                self.workItemInfo.type = issue.type;
                                self.workItemInfo.priority = issue.priority;
                                self.workItemInfo.status = issue.status;
                                self.workItemInfo.project = issue.project;
                                self.workItemInfo.assigner = issue.assigned_to;
                                self.workItemInfo.author = issue.author;
                                self.workItemInfo.startDate = issue.start_date;
                                self.workItemInfo.dueDate = issue.due_date;
                                self.workItemInfo.subject = issue.subject;
                                self.workItemInfo.description = issue.description;
                                self.workItemInfo.issueId = issue.id;
                                self.workItemInfo.severity = issue.severity;

                                if (issue.tags) {
                                    for (var i = 0; i < issue.tags.length; i++) {
                                        if (issue.tags[i].color_id == 0) {
                                            issue.tags[i].color_id = 8;
                                        }
                                    }
                                }

                                self.workItemInfo.tagList = issue.tags ? issue.tags : [];

                                lastSubject = issue.subject;

                                if (issue.iteration && issue.iteration.name) {
                                    self.workItemInfo.iteration = issue.iteration;
                                } else {
                                    self.workItemInfo.iteration = {'name': '待分配','id':-1};
                                }
                                if (issue.module && issue.module.name) {
                                    self.workItemInfo.module = issue.module;
                                } else {
                                    self.workItemInfo.module = {'name': '待分配','id':-1};
                                }
                                if (issue.domain && issue.domain.name) {
                                    self.workItemInfo.domain = issue.domain;
                                } else {
                                    self.workItemInfo.domain = {'name': '待分配','id':-1};
                                }
                                uSet("workItemInfo",JSON.stringify(self.workItemInfo));

                                self.rearrangeDescription();

                                self.setList(typeList,self.workItemInfo.type.id);
                                self.setList(priorityList,self.workItemInfo.priority.id);

                                for(var i = 0;i < self.allTaglist.length; i++) {
                                    for (var j = 0; j < self.workItemInfo.tagList.length; j++) {
                                        if (self.workItemInfo.tagList[j].name == self.allTaglist[i].name && self.allTaglist[i].id == null) {
                                            self.allTaglist[i].id = self.workItemInfo.tagList[j].id;
                                            break;
                                        }
                                    }
                                }
                                originalProjectUUId = issue.project.uuid;
                                if (changeProject) {
                                    uSet("queryProjectTags","false");
                                    uSet("moduleList","");
                                    uSet("domainList","");
                                    uSet("iterationList","");
                                    uSet("userList","");
                                    uSet("statusList","");
                                    self.getIssueRole(issue.project.uuid);
                                } else {
                                    uHideLoadingPage();
                                }
                                uSetWorkItemDetail(JSON.stringify(self.workItemInfo));
                            }
                        },function (data) {
                            self.workItemInfo.subject = lastSubject;
                            isSaving = false;
                            uHideLoadingPage();
                            uShowAlertDialog(data.reason);
                        });
                    }
                } else {
                    if (1 === this.betaStatus){
                        uShowAlertDialog("项目所属企业用户已被冻结，\n无法编辑此工作项")
                    } else if (2 === this.betaStatus) {
                        uShowAlertDialog("项目所属企业用户已被关闭，\n无法编辑此工作项")
                    } else {
                        uShowAlertDialog("您没有编辑此工作项的权限");
                    }
                }
            },
            showMore: function (flag) {
                var self = this;
                $("#autoTest_workItem_more").slideToggle(300, function () {
                    self.showMoreFlag = !self.showMoreFlag;
                });
            },
            showDescriptionPage: function () {
                uSet("web_view_fragment_title","查看描述");
                uSet("description",this.workItemInfo.description);
                uSet("web_view_fragment_url","file:///android_asset/page/workItemSubPage/workItemDescription.html");
                uShowSubPage();
            },
            showDatePickerPage: function () {
                uSet("web_view_fragment_title","选择计划日期");
                uSet("startDate",JSON.stringify(this.workItemInfo.startDate));
                uSet("dueDate",JSON.stringify(this.workItemInfo.dueDate));
                uSet("web_view_fragment_url","file:///android_asset/page/workItemSubPage/workItemDatePicker.html");
                uShowSubPage();
            },
            showItemListPage: function (key) {
                this.listKey = key;
                switch (key) {
                    case 'type':
                        uSet("web_view_fragment_title","选择类型");
                        uSet("hasSearch","false");
                        uSet("itemList",JSON.stringify(typeList));
                        break;
                    case 'status':
                        uSet("web_view_fragment_title","选择状态");
                        uSet("hasSearch","false");
                        break;
                    case 'priority':
                        uSet("web_view_fragment_title","选择优先级");
                        uSet("hasSearch","false");
                        uSet("itemList",JSON.stringify(priorityList));
                        break;
                    case 'severity':
                        uSet("web_view_fragment_title","选择重要程度");
                        uSet("hasSearch","false");
                        break;
                    case 'assigner':
                        uSet("web_view_fragment_title","选择处理人");
                        uSet("hasSearch","true");
                        uSet("searchHint",JSON.stringify(searchHintList["assigner"]));
                        break;
                    case 'iteration':
                        uSet("web_view_fragment_title","选择迭代");
                        uSet("hasSearch","true");
                        uSet("searchHint",JSON.stringify(searchHintList["iteration"]));
                        break;
                    case 'module':
                        uSet("web_view_fragment_title","选择模块");
                        uSet("hasSearch","true");
                        uSet("searchHint",JSON.stringify(searchHintList["module"]));
                        break;
                    case 'domain':
                        uSet("web_view_fragment_title","选择领域");
                        uSet("hasSearch","false");
                        uSet("searchHint",JSON.stringify(searchHintList["domain"]));
                        break;
                    case 'project':
                        uSet("web_view_fragment_title","选择项目");
                        uSet("hasSearch","true");
                        uSet("searchHint",JSON.stringify(searchHintList["project"]));
                        break;
                }
                uSet("web_view_fragment_url","file:///android_asset/page/workItemSubPage/workItemDetailList.html");
                uShowSubPage();
            },
            setList: function (list, id) {
                for (var i = 0; i < list.length; i++) {
                    list[i].checked = false;
                    list[i].sid = i;
                    if (list[i].id == id) {
                        list[i].checked = true;
                    }
                    if (list[i].project_uuid == id) {
                        list[i].checked = true;
                    }
                }
            },
            chooseItemFromList: function (item,itemGroup) {
                var self = this;
                switch (this.listKey) {
                    case 'type':
                        if (this.workItemInfo.type.id != item.id) {
                            params = {};
                            params["type_id"] = item.id;
                            this.save();
                        }
                        break;
                    case 'status':
                        if(!this.canClose && item.name == "已关闭") {
                            uShowAlertDialog("子工作项未关闭的父工作项不能被关闭");
                        } else if(!this.canFullEdit && item.name == "已关闭") {
                            uShowAlertDialog("工作项责任人不能修改工作项状态为已关闭");
                        } else {
                            if (this.workItemInfo.status.id != item.statusId) {
                                params = {};
                                params["status_id"] = item.statusId;
                                this.save();
                            }
                        }
                        break;
                    case 'priority':
                        if (this.workItemInfo.priority.id != item.id) {
                            if (this.hasChild) {
                                uShowAlertDialog("父工作项的优先级不能被修改");
                                return;
                            }
                            params = {};
                            params["priority_id"] = item.id;
                            this.save();
                        }
                        break;
                    case 'severity':
                        if (this.workItemInfo.severity.id != item.id) {
                            params = {};
                            params["severity_id"] = item.id;
                            this.save();
                        }
                        break;
                    case 'assigner':
                        if (this.workItemInfo.assigner.id != item.id) {
                            params = {};
                            params["assigned_to_id"] = item.id;
                            this.save();
                        }
                        break;
                    case 'project':
                        if (self.workItemInfo.project.id != item.id) {
                            if (this.hasChildOrParent) {
                                uShowAlertDialog("该工作项有子工作项或父工作项，不能迁移");
                                return;
                            }
                            params = {};
                            uShowLoadingPage();
                            hValidateAuthor({"project_uuid": item.project_uuid, "issue_id": issueId}, function (data) {
                                if (!data.exist) {
                                    uHideLoadingPage();
                                    uShowAlertDialog("该工作项的创建人不存在于目标项目下,无法迁移");
                                } else {
                                    hUserBetaStatus({
                                        "project_uuid": item.project_uuid
                                    }, function (data) {
                                        if (2 === data.order_status) {
                                            uHideLoadingPage();
                                            uShowAlertDialog("该项目所属企业用户的系统管理员账户余额不足,无法迁移");
                                        } else if (0 === data.status && 0 === data.free_quota) {
                                            uHideLoadingPage();
                                            uShowAlertDialog("该项目所属企业用户的系统管理员没有开通项目管理服务,无法迁移");
                                        } else {
                                            uHideLoadingPage();
                                            params["project_uuid"] = item.project_uuid;
                                            params["iteration_id"] = -1;
                                            params["module_id"] = -1;
                                            params["domain_id"] = -1;
                                            params["assigned_to_id"] = currentUserInfo.id;

                                            uSet("needRequestProject","true");
                                            self.save(true);
                                        }
                                    });
                                }
                            });
                        }
                        break;
                    case 'iteration':
                        if (this.workItemInfo.iteration.id != item.id) {
                            if (this.hasChild) {
                                uShowAlertDialog("父工作项的迭代不能被修改");
                                return;
                            }
                            params = {};
                            if (item.name == "待分配") {
                            } else {
                                params["start_date"] = new Date(item.start_date).getTime();
                                params["due_date"] = new Date(item.due_date).getTime();
                                uShowToast("切换迭代后计划时间会自动调整!");
                            }
                            params["iteration_id"] = item.id;
                            this.save();
                        }
                        break;
                    case 'module':
                        if (this.workItemInfo.module.id != item.id) {
                            params = {};
                            if (item.name == "待分配") {
                            } else {
                                //切换模块后，需调整工作项负责人
                                var userList = JSON.parse(uGet("userList"));
                                if (userList && userList.length) {
                                    for (var i = 0; i < userList.length; i++) {
                                        for (var j = 0; j < userList[i].group_members.length; j++) {
                                            if (item.owner && userList[i].group_members[j].id == item.owner.id) {
                                                params["assigned_to_id"] = item.owner.id;
                                            }
                                        }
                                    }
                                }
                            }
                            params["module_id"] = item.id;
                            this.save();
                        }
                        break;
                    case 'domain':
                        if (this.workItemInfo.domain.id != item.id) {
                            if (item.name == "待分配") {
                            } else {
                            }
                            params = {};
                            params["domain_id"] = item.id;
                            this.save();
                        }
                        break;
                }
            },
            showTagEditPage: function () {
                uSet("web_view_fragment_title","编辑标签");
                uSet("tagColor",JSON.stringify(this.tagColor));
                uSet("allTaglist",JSON.stringify(this.allTaglist));
                uSet("web_view_fragment_url","file:///android_asset/page/workItemSubPage/workItemDetailTag.html");
                uShowSubPage();
            },
            compare: function (obj1, obj2) {
                var val1 = obj1.name;
                var val2 = obj2.name;
                if (val1 < val2) {
                    return -1;
                } else if (val1 > val2) {
                    return 1;
                } else {
                    return 0;
                }
            },
            saveTags: function () {
                var tmpWorkItemInfoTagList = [];
                this.tmpTagList = [];
                for (var i = 0; i < this.allTaglist.length; i++) {
                    if (this.allTaglist[i].checked) {
                        this.tmpTagList.push(this.allTaglist[i]);
                        if (this.allTaglist[i].id) {
                            tmpWorkItemInfoTagList.push({"name": this.allTaglist[i].name,"id":this.allTaglist[i].id, "color_id":colorIdReverseMap[this.allTaglist[i].color]});
                        } else {
                            tmpWorkItemInfoTagList.push({"name": this.allTaglist[i].name,"color_id":colorIdReverseMap[this.allTaglist[i].color]});
                        }
                    }
                }
                console.log("tmpWorkItemInfoTagList" + JSON.stringify(tmpWorkItemInfoTagList.sort(this.compare)));
                console.log("workItemInfo.tagList" + JSON.stringify(this.workItemInfo.tagList.sort(this.compare)));

                params = {};
                if (!_.isEqual(tmpWorkItemInfoTagList.sort(this.compare), this.workItemInfo.tagList.sort(this.compare))) {
                    if (tmpWorkItemInfoTagList.length) {
                        params["tags"] = tmpWorkItemInfoTagList;
                    } else {
                        params["tags"] = [{"id":-1}];
                    }
                    this.save();
                }
            },
            setTags: function () {
                var self = this;
                self.workItemInfo.tagList = issue.tags ? issue.tags : [];

                self.tmpTagList = JSON.parse(JSON.stringify(self.workItemInfo.tagList));
                self.allTaglist = JSON.parse(JSON.stringify(self.workItemInfo.tagList));

                for (var i = 0; i < self.tmpTagList.length; i++) {
                    if (self.tmpTagList[i].color_id) {
                        self.tmpTagList[i].color = colorIdMap[self.tmpTagList[i].color_id];
                    } else {
                        self.tmpTagList[i].color = colorIdMap[8];
                    }
                    self.tmpTagList[i].styleObject = {backgroundColor:self.tmpTagList[i].color, color:"#FFFFFF", borderColor:self.tmpTagList[i].color};
                }

                for (var i = 0; i < self.allTaglist.length; i++) {
                    self.allTaglist[i].checked = true;
                    self.allTaglist[i].sid = i;
                    if (self.allTaglist[i].color_id) {
                        self.allTaglist[i].color = colorIdMap[self.allTaglist[i].color_id];
                    } else {
                        self.allTaglist[i].color = colorIdMap[8];
                    }
                    self.allTaglist[i].styleObject = {backgroundColor:self.allTaglist[i].color, color:"#FFFFFF", borderColor:self.allTaglist[i].color};
                }
            },
            deleteWorkItem:function () {
                if (this.canDelete) {
                    uShowConformDialog("确定要删除这条工作项及其下的子任务?");
                } else {
                    if(1 === this.betaStatus) {
                        uShowAlertDialog("项目所属企业用户已被冻结，\n无法删除此工作项")
                    } else if(2 === this.betaStatus) {
                        uShowAlertDialog("项目所属企业用户已被关闭，\n无法删除此工作项")
                    } else {
                        uShowAlertDialog("您没有删除此工作项的权限");
                    }
                }
            },
            conformDeleteWorkItem:function () {
                uShowLoadingPage();
                hDeleteIssue({
                    "project_uuid": originalProjectUUId,
                    "issue_id": issueId
                }, function (data) {
                    uHideLoadingPage();
                    uShowToast("工作项删除成功");
                    initialize();
                    uSet("needRequestProject","true");
                    uSet("needRequestAwaitWorkItem","true");
                    uFinishCurrentPage();
                });
            },
            showComment: function (flag) {
                this.comment = flag;
                this.history = !flag;
                if (flag) {
                    $("#workItem-commentOrHistory-border")[0].style.transform = "translate(0,0)";
                    $("#workItem-commentOrHistory-border")[0].style.transition = "250ms";
                    $("#workItem-commentOrHistory-border")[0].style.webkitTransform = "translate(0,0)";
                    $("#workItem-commentOrHistory-border")[0].style.webkitTransition = "250ms";
                } else {
                    $("#workItem-commentOrHistory-border")[0].style.transform = "translate(220px,0)";
                    $("#workItem-commentOrHistory-border")[0].style.transition = "250ms";
                    $("#workItem-commentOrHistory-border")[0].style.webkitTransform = "translate(220px,0)";
                    $("#workItem-commentOrHistory-border")[0].style.webkitTransition = "250ms";
                }
            },
            changeToRecord :function (flag) {
                this.record = flag;
            },
            deleteAttachment:function (attachment) {
                var self = this;
                var num;
                for (var i = 0; i < this.attachmentList.length; i++) {
                    if (attachment.attachmentInfo.disk_filename == this.attachmentList[i].attachmentInfo.disk_filename) {
                        num = i;

                        if (attachment.uploadState == UPLOAD_STATES.DONE) {
                            uShowLoadingPage();
                            hDeleteAttachmentForWorkItem(attachment.attachmentInfo.disk_filename,{
                                "project_uuid":self.workItemInfo.project.uuid || self.workItemInfo.project.project_uuid,
                                "issue_id":issueId,
                                "file_id":attachment.attachmentInfo.id,
                                "file_name":attachment.attachmentInfo.filename,
                                "file_size":attachment.attachmentInfo.filesize
                            }, function (data) {

                                hDeleteAttachmentForDocMan(attachment.attachmentInfo.disk_filename,{
                                    "project_id":self.workItemInfo.project.uuid || self.workItemInfo.project.project_uuid,
                                    "business_tag":issueId,
                                    "system_type":"projectMan",
                                    "storefileNames":[attachment.attachmentInfo.disk_filename],
                                    "fileNames":[attachment.attachmentInfo.filename]
                                }, function (data) {
                                    self.attachmentList.splice(num,1);
                                    fileCount--;
                                    totalSize -= attachment.content.size;
                                    self.setScrollWidth();
                                    uHideLoadingPage();
                                });
                            });
                        } else {
                            this.attachmentList.splice(i,1);
                            fileCount--;
                            totalSize -= attachment.content.size;
                            this.setScrollWidth();
                        }
                        break;
                    }
                }
            },
            reUploadAttachment:function (attachment) {
                if (uIsFileExist(attachment.content.src)) {
                    for (var i = 0; i < this.attachmentList.length; i++) {
                        if (this.attachmentList[i].content.src == attachment.content.src) {
                            this.attachmentList[i].uploadState = UPLOAD_STATES.DOING;
                            break;
                        }
                    }
                    this.uploadAttachmentRequest(attachment.content.src);
                } else {
                    for (var i = 0; i < this.attachmentList.length; i++) {
                        if (this.attachmentList[i].content.src == attachment.content.src) {
                            this.attachmentList[i].uploadState = UPLOAD_STATES.FAILED;
                            break;
                        }
                    }
                    uShowAlertDialog("文件已不存在");
                }
            },
            uploadAttachmentRequest:function (src) {
                var self = this;
                hUploadAttachment({
                    "project_uuid":self.workItemInfo.project.uuid || self.workItemInfo.project.project_uuid,
                    "issue_id":issueId + "",
                    "fileList":[{"src": src}]
                }, function (file, data) {
                    isSaving = false;
                    for (var i = 0; i < self.attachmentList.length; i++) {
                        if (self.attachmentList[i].content.src == src) {
                            self.attachmentList[i].uploadState = UPLOAD_STATES.DONE;
                            self.attachmentList[i].attachmentInfo = data.attachments[0];
                            break;
                        }
                    }
                }, function (file, data) {
                    isSaving = false;
                    for (var i = self.attachmentList.length - 1; i >= 0; i--) {
                        if (self.attachmentList[i].content.src == src) {
                            self.attachmentList[i].uploadState = UPLOAD_STATES.TIMEOUT;
                            break;
                        }
                    }
                    uShowAlertDialog(data.reason);
                }, function (data) {
                    console.log("html upload progress:" +  data.progress);
                    for (var i = self.attachmentList.length - 1; i >= 0; i--) {
                        if (self.attachmentList[i].content.src == src) {
                            self.attachmentList[i].progress = data.progress + "%";
                            break;
                        }
                    }
                });
            },
            uploadAttachment:function (src,fileSize) {
                if (!uIsFileExist(src)) {
                    uShowAlertDialog("文件已不存在");
                    return;
                }
                for (var i = 0; i < this.attachmentList.length; i++) {
                    if (this.attachmentList[i].content.src == src) {
                        uShowAlertDialog("请求文件已存在");
                        return;
                    }
                }
                this.addAttachment(src,fileSize,UPLOAD_STATES.DOING,{},DOWNLOAD_STATES.DONE);
                this.uploadAttachmentRequest(src);
            },
            downloadAttachment:function (attachment) {
                if (uIsSelfRegion()) {
                    uShowAlertDialog("因信息安全红线要求，自用环境禁止文件下载，请到PC端查看");
                    return;
                }
                var self = this;
                if (attachment.downloadState == DOWNLOAD_STATES.TODO) {
                    for(var i = 0; i < self.attachmentList.length; i++) {
                        if (attachment.attachmentInfo.disk_filename == self.attachmentList[i].attachmentInfo.disk_filename) {
                            self.attachmentList[i].downloadState = DOWNLOAD_STATES.DOING;
                            break;
                        }
                    }
                    hDownloadAttachment(attachment.attachmentInfo.disk_filename,{
                        "project_uuid":self.workItemInfo.project.uuid || self.workItemInfo.project.project_uuid,
                        "old_project_id":attachment.attachmentInfo.directory.substring(1,33),
                        "business_tag":issueId,
                        "system_type":"projectMan",
                        "user_agent":"chrome",
                        "storefileNames":attachment.attachmentInfo.disk_filename,
                        "fileNames":attachment.attachmentInfo.filename
                    }, function (data) {
                        for(var i = 0; i < self.attachmentList.length; i++) {
                            if (attachment.attachmentInfo.disk_filename == self.attachmentList[i].attachmentInfo.disk_filename) {
                                self.attachmentList[i].content.src = data.src;

                                var index1=data.src.lastIndexOf("/");
                                var index2=data.src.lastIndexOf(".");
                                var fileName=data.src.substring(index1+1);

                                index1=data.src.lastIndexOf(".");
                                index2=data.src.length;
                                var suffix=data.src.substring(index1+1,index2).toLowerCase();

                                if (suffix == "gif" || suffix == "jpeg" || suffix == "jpg" || suffix == "png" || suffix == "bmp") {
                                    var showSrc = data.src.replace(fileName,encodeURIComponent(fileName));
                                    self.attachmentList[i].content.showSrc = showSrc;
                                }
                                if (suffix == "3gp" || suffix == "mp4" || suffix == "avi" || suffix == "mkv" || suffix == "flv" || suffix == "wmv" || suffix == "mpg" || suffix == "mov" || suffix == "3gp") {
                                    self.attachmentList[i].content.showSrc = "../../theme/image/workItem-attachment-video-play.png";
                                }

                                self.attachmentList[i].downloadState = DOWNLOAD_STATES.DONE;
                                break;
                            }
                        }
                    }, function (data) {
                        console.log(JSON.stringify(data));
                        for(var i = 0; i < self.attachmentList.length; i++) {
                            if (attachment.attachmentInfo.disk_filename == self.attachmentList[i].attachmentInfo.disk_filename) {
                                self.attachmentList[i].downloadState = DOWNLOAD_STATES.TODO;
                                break;
                            }
                        }
                        uShowAlertDialog(data.reason);
                    }, function (data) {
                        console.log("html download progress:" +  data.progress);
                        for(var i = 0; i < self.attachmentList.length; i++) {
                            if (attachment.attachmentInfo.disk_filename == self.attachmentList[i].attachmentInfo.disk_filename) {
                                self.attachmentList[i].progress = data.progress + "%";
                                break;
                            }
                        }
                    });
                } else if (attachment.downloadState == DOWNLOAD_STATES.DONE){
                    self.showAttachment(attachment);
                }
            },
            showAttachment:function (attachment) {
                var tmpAttachmentList = [];
                var index = 0;
                var currentIndex = 0;
                if (attachment.type == "picture") {
                    for(var i = 0; i < this.attachmentList.length; i++) {
                        if (this.attachmentList[i].type == "picture" && this.attachmentList[i].downloadState == DOWNLOAD_STATES.DONE) {
                            if (attachment.content.src == this.attachmentList[i].content.src) {
                                currentIndex = index;
                            }
                            tmpAttachmentList.push({"src": this.attachmentList[i].content.src});
                            index ++;
                        }
                    }
                    uShowAttachment(tmpAttachmentList,currentIndex,"picture");
                } else if (attachment.type == "voice"){
                    this.startPlayingAudio(attachment);
                } else {
                    tmpAttachmentList.push({"src": attachment.content.src});
                    uShowAttachment(tmpAttachmentList,0,"file");
                }
            },
            startPlayingAudio: function (attachment) {
                if (attachment.isPlaying) {
                    uStopPlayingAudio();
                    attachment.isPlaying = false;
                } else {
                    uStopPlayingAudio();
                    for (var i = 0; i < this.attachmentList.length; i++) {
                        if (this.attachmentList[i].isPlaying) {
                            this.attachmentList[i].isPlaying = false;
                        }
                    }
                    uStartPlayingAudio(attachment.content.src);
                    attachment.isPlaying = true;
                }
            },
            addAttachment:function (src,fileSize,uploadStateFlag,info,downloadStateFlag,realName) {
                var index1=src.lastIndexOf("/");
                var index2=src.lastIndexOf(".");
                var fileName=src.substring(index1+1);
                var showSrc = src.replace(fileName,encodeURIComponent(fileName));

                index1=src.lastIndexOf(".");
                index2=src.length;
                var suffix=src.substring(index1+1,index2).toLowerCase();

                var newAttachment = null;
                if (suffix == "arm" || suffix == "amr" ||suffix == "wav") {
                    newAttachment = {type:"voice",content:{name:fileName,src:src,size:fileSize},isPlaying:false,uploadState:uploadStateFlag,attachmentInfo:info,downloadState:downloadStateFlag,progress:"0%"};
                } else if (suffix == "gif" || suffix == "jpeg" || suffix == "jpg" || suffix == "png" || suffix == "bmp"){
                    newAttachment = {type:"picture",content:{name:realName || fileName,src:src,size:fileSize,showSrc:showSrc},uploadState:uploadStateFlag,attachmentInfo:info,downloadState:downloadStateFlag,progress:"0%"};
                } else if (suffix == "3gp" || suffix == "mp4" || suffix == "avi" || suffix == "mkv" || suffix == "flv" || suffix == "wmv" || suffix == "mpg" || suffix == "mov" || suffix == "3gp"){
                    newAttachment = {type:"video",content:{name:fileName,src:src,size:fileSize,showSrc:""},uploadState:uploadStateFlag,attachmentInfo:info,downloadState:downloadStateFlag,progress:"0%"};
                    if (newAttachment.downloadState == this.downloadStates.DONE) {
                        newAttachment.content.showSrc = "../../theme/image/workItem-attachment-video-play.png";
                    } else {
                        newAttachment.content.showSrc = "../../theme/image/workItem-attachment-video.png";
                    }
                } else {
                    if (suffix == "pdf") {
                        showSrc = "../../theme/image/workItem-attachment-pdf.png";
                    } else if (suffix == "ppt" || suffix == "pptx") {
                        showSrc = "../../theme/image/workItem-attachment-ppt.png";
                    } else if (suffix == "rar") {
                        showSrc = "../../theme/image/workItem-attachment-rar.png";
                    } else if (suffix == "txt") {
                        showSrc = "../../theme/image/workItem-attachment-txt.png";
                    } else if (suffix == "doc" || suffix == "docx") {
                        showSrc = "../../theme/image/workItem-attachment-word.png";
                    } else if (suffix == "xls" || suffix == "xlsx") {
                        showSrc = "../../theme/image/workItem-attachment-xlsx.png";
                    } else if (suffix == "xmind") {
                        showSrc = "../../theme/image/workItem-attachment-xmind.png";
                    } else if (suffix == "zip") {
                        showSrc = "../../theme/image/workItem-attachment-zip.png";
                    } else if (suffix == "html") {
                        showSrc = "../../theme/image/workItem-attachment-html.png";
                    } else if (suffix == "xml") {
                        showSrc = "../../theme/image/workItem-attachment-xml.png";
                    } else if (suffix == "log") {
                        showSrc = "../../theme/image/workItem-attachment-log.png";
                    } else {
                        showSrc = "../../theme/image/workItem-attachment-unknown.png";
                    }
                    newAttachment = {type:"file",content:{name:fileName,src:src,showSrc:showSrc,size:fileSize},uploadState:uploadStateFlag,attachmentInfo:info,downloadState:downloadStateFlag,progress:"0%"};
                }

                if (newAttachment) {
                    totalSize += fileSize;
                    fileCount++;
                    this.attachmentList.push(newAttachment);
                    this.$nextTick(function () {
                        this.setScrollWidth();
                    });
                }
            },
            getFileFromPhone: function () {
                uGetFileFromPhone();
            },
            takePicture: function () {
                uTakePicture();
            },
            getImageFromAlbum: function () {
                uGetImageFromAlbum();
            },
            showAddAttachmentDialog: function () {
                uShowPhotoDialog();
            },
            submit: function (event) {
                $(".workItem_sendComment_textarea")[0].innerHTML = $(".workItem_sendComment_textarea").text();
                this.changeHeight();
                var self = this;
                this.newComment = $(".workItem_sendComment_textarea").text().replace(/(^\s*)|(\s*$)/g, "");
                if (self.newComment.replace(/\s/g, "") == "") {
                    $(".workItem_sendComment_textarea")[0].innerHTML = "";
                    self.changeHeight();
                    uShowAlertDialog("工作项评论不能为空或空格");
                    return;
                }
                if (self.newComment.length > 1024) {
                    uShowAlertDialog("工作项评论的最大合法长度为1024个字符,您已超出" + (self.newComment.length - 1024) + "个字符");
                    return;
                }
                if (self.newComment.match(DESCRIPTION_PATTERN)) {
                    uShowAlertDialog("工作项评论只能包含汉字、英文大小写字母、数字、空格、标点和部分特殊字符!");
                    return;
                }
                hAddCommentForWorkItem({
                    "project_uuid": self.workItemInfo.project.uuid || self.workItemInfo.project.project_uuid,
                    "issue_id": issueId,
                    "content": self.newComment
                }, function (data) {
                    $(".workItem_sendComment_textarea")[0].innerHTML = "";
                    self.changeHeight();
                    self.newComment = "";
                    self.getComment();
                });
            },
            getComment: function () {
                var self = this;
                console.log("starttime_hGetCommentOfWorkItem");
                hGetCommentOfWorkItem({
                    "project_uuid": originalProjectUUId,
                    "issue_id": issueId
                }, function (data) {
                console.log("endtime_hGetCommentOfWorkItem");

                    self.commentList = [];
                    for (var i = data.comments.length - 1; i >= 0; i--) {
                        if (data.comments[i].user.id == currentUserInfo.id) {
                            data.comments[i].user.role = "me";
                        } else {
                            data.comments[i].user.role = "other";
                        }
                        data.comments[i].user.displayName = data.comments[i].user.first_name.substring(0,1).toUpperCase();
                        data.comments[i].content = {type:"text",detail:data.comments[i].content};
                        self.commentList.push(data.comments[i]);
                    }

                    self.$nextTick(function () {
                        var div = $(".workItem_content")[0];
                        div.scrollTop = div.scrollHeight;
                    });
                });
            },
            showKeyboard: function (height) {
                var input = $("#comment-input")[0];
                input.style.top = this.windowHeight - this.keyboardHeight  - this.inputHeight + "px";

                var div = $(".workItem_content")[0];
                div.style.height = this.windowHeight - this.keyboardHeight - this.inputHeight + "px";
            }

        }
    });
    function initialize() {
    	uSet("WorkItem0", "0");
    	uSet("WorkItem1", "0");
    	uSet("WorkItem2", "0");
    	uSet("WorkItem3", "0");
    }
};
