window.onload = function(){
    var projectUUId = uGet("project_uuid");
    var currentUserInfo = {};
    var statusList = [];
    var severityList = [];
    var moduleList = [];
    var iterationList = [];
    var domainList = [];
    var assignerList = [];
    var authorList = [];
    var tagList = [];
    var priorityList = [
        {'name': '不限', 'checked': true, 'id': '', 'sid': 0},
        {'name': '低', 'checked': false, 'id': 1, 'sid': 1},
        {'name': '中', 'checked': false, 'id': 2, 'sid': 2},
        {'name': '高', 'checked': false, 'id': 3, 'sid': 3}
    ];
    var checkedStatusList = [];
    var checkedSeverityList = [];
    var checkedModuleList = [];
    var checkedIterationList = [];
    var checkedDomainList = [];
    var checkedPriorityList = [];
    var checkedAssignerList = [];
    var checkedAuthorList = [];
    var checkedTagList = [];
    var requestDoneFlags = {
        getCurrentUserInfo: false,
        getStatus: false,
        getSeverity: false,
        getIteration: false,
        getModule: false,
        getDomain: false,
        getUserListByProjectId: false,
        getTagList: false
    };
    var isAllRequestDone = function () {
        var allRequestDone = true;
        console.log("requestDoneFlags: " + JSON.stringify(requestDoneFlags));
        for (var request in requestDoneFlags) {
            if (!requestDoneFlags[request]) {
                allRequestDone = false;
            }
        }
        return allRequestDone;
    };
    var vm = new Vue({
        el:'#view-container',
        data:{
            tabList : [
                {'name': '状态', 'checked': true, 'sid': 0,'hasContent':false},
                {'name': '重要程度', 'checked': false, 'sid': 1,'hasContent':false},
                {'name': '优先级', 'checked': false, 'sid': 2,'hasContent':false},
                {'name': '模块', 'checked': false, 'sid': 3,'hasContent':false},
                {'name': '迭代', 'checked': false, 'sid': 4,'hasContent':false},
                {'name': '领域', 'checked': false, 'sid': 5,'hasContent':false},
                {'name': '处理人', 'checked': false, 'sid': 6,'hasContent':false},
                {'name': '创建人', 'checked': false, 'sid': 7,'hasContent':false},
                {'name': '标签', 'checked': false, 'sid': 8,'hasContent':false}
            ],
            itemList:[],
            items:[],
            queryValue: "",
            showSearchBar:false,
            isKeyboardShown: false,
            currentTab: 0
        },
        created:function(){
            this.$nextTick(function () {
                uShowSelf();
            });
        },
        mounted:function(){
            var self = this;
            uShowLoadingPage();
            uSetPublicCompleteButtonClickListener(function () {
                self.save();
            });
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            uSetKeyboardHeightListener(function (height) {
                self.isKeyboardShown = height == "0" ? false: true;
                console.log("isKeyboardShown:" + height);
             });
            this.getFilterParams();

            priorityList = this.initList(priorityList, checkedPriorityList);

            this.getFilterConditions(projectUUId);

        },
        methods:{
            getFilterParams: function () {
                var filterParams = uGetFilterParams();
                console.log("getFilterParams:" + filterParams);
                var filterParamsJson;
                if (filterParams != "") {
                    filterParamsJson = JSON.parse(filterParams);
                    checkedStatusList = filterParamsJson.status_id ? filterParamsJson.status_id.split(",") : [];
                    checkedSeverityList = filterParamsJson.severity_id ? filterParamsJson.severity_id.split(",") : [];
                    checkedPriorityList = filterParamsJson.priority_id ? filterParamsJson.priority_id.split(",") : [];
                    checkedModuleList = filterParamsJson.module_id ? filterParamsJson.module_id.split(",") : [];
                    checkedIterationList = filterParamsJson.fixed_version_id ? filterParamsJson.fixed_version_id.split(",") : [];
                    checkedDomainList = filterParamsJson.domain_id ? filterParamsJson.domain_id.split(",") : [];
                    checkedAssignerList = filterParamsJson.assigned_to_id ? filterParamsJson.assigned_to_id.split(",") : [];
                    checkedAuthorList = filterParamsJson.author_id ? filterParamsJson.author_id.split(",") : [];
                    checkedTagList = filterParamsJson.tag_id ? filterParamsJson.tag_id.split(",") : [];
                }
                if (checkedStatusList.length) {
                    this.tabList[0].hasContent = true;
                }
                if (checkedSeverityList.length) {
                    this.tabList[1].hasContent = true;
                }
                if (checkedPriorityList.length) {
                    this.tabList[2].hasContent = true;
                }
                if (checkedModuleList.length) {
                    this.tabList[3].hasContent = true;
                }
                if (checkedIterationList.length) {
                    this.tabList[4].hasContent = true;
                }
                if (checkedDomainList.length) {
                    this.tabList[5].hasContent = true;
                }
                if (checkedAssignerList.length) {
                    this.tabList[6].hasContent = true;
                }
                if (checkedAuthorList.length) {
                    this.tabList[7].hasContent = true;
                }
                if (checkedTagList.length) {
                    this.tabList[8].hasContent = true;
                }
            },
            checkItemFromList: function (item) {
                if (item.name == '不限') {
                    for (var i = 0; i < this.itemList.length; i++) {
                        this.itemList[i].checked = false;
                    }
                    item.checked = true;
                } else {
                    var chooseOneFlag = false;
                    item.checked = !item.checked;
                    for (var i = 0; i < this.itemList.length; i++) {
                        if (this.itemList[i].checked == true) {
                            chooseOneFlag = true;
                        }
                    }
                    this.itemList[0].checked = !chooseOneFlag;
                    if (this.queryValue != "") {
                        this.itemList = this.sort(this.itemList);
                        switch (this.currentTab) {
                            case 0:
                                statusList = this.itemList;
                                break;
                            case 1:
                                severityList = this.itemList;
                                break;
                            case 2:
                                priorityList = this.itemList;
                                break;
                            case 3:
                                moduleList = this.itemList;
                                break;
                            case 4:
                                iterationList = this.itemList;
                                break;
                            case 5:
                                domainList = this.itemList;
                                break;
                            case 6:
                                assignerList = this.itemList;
                                break;
                            case 7:
                                authorList = this.itemList;
                                break;
                            case 8:
                                tagList = this.itemList;
                                break;
                        }
                    }
                }
                this.queryValue = "";
                this.checkContent();
            },
            sort: function (itemList) {
                var tmpList1 = [];
                var tmpList2 = [];
                for (var i = 1; i < itemList.length; i++) {
                    if (itemList[i].checked) {
                        tmpList1.push(itemList[i]);
                    } else {
                        tmpList2.push(itemList[i]);
                    }
                }
                for (var j = 0; j < tmpList2.length; j++) {
                    tmpList1.push(tmpList2[j]);
                }
                tmpList1.unshift(itemList[0]);
                return tmpList1;
            },

            checkContent:function () {
                this.tabList[0].hasContent = !statusList[0].checked;
                this.tabList[1].hasContent = !severityList[0].checked;
                this.tabList[2].hasContent = !priorityList[0].checked;
                this.tabList[3].hasContent = !moduleList[0].checked;
                this.tabList[4].hasContent = !iterationList[0].checked;
                this.tabList[5].hasContent = !domainList[0].checked;
                this.tabList[6].hasContent = !assignerList[0].checked;
                this.tabList[7].hasContent = !authorList[0].checked;
                this.tabList[8].hasContent = !tagList[0].checked;
            },
            getCheckedItemList: function (itemList) {
                var checkedItemList = [];
                for(var i = 0; i < itemList.length; i++) {
                    if (itemList[i].checked) {
                        checkedItemList.push(itemList[i].id + "");
                    }
                }
                return checkedItemList;
            },
            getCheckedStatusString: function (itemList) {
                var checkedItemString = '';
                var firstItemFlag = true;
                for(var i = 0; i < itemList.length; i++) {
                    if (itemList[i].checked) {
                        if (firstItemFlag)
                        {
                            checkedItemString += itemList[i].statusId;
                        }else {
                            checkedItemString += ',' + itemList[i].statusId;
                        }
                        firstItemFlag = false;
                    }
                }
                return checkedItemString;
            },
            getCheckedItemString: function (itemList) {
                var checkedItemString = '';
                var firstItemFlag = true;
                for(var i = 0; i < itemList.length; i++) {
                    if (itemList[i].checked) {
                        if (firstItemFlag)
                        {
                            checkedItemString += itemList[i].id;
                        }else {
                            checkedItemString += ',' + itemList[i].id;
                        }
                        firstItemFlag = false;
                    }
                }
                return checkedItemString;
            },
            formatFilterParams: function () {
                var tmpFilterParams = {};
                if (!statusList[0].checked) {
                    tmpFilterParams["status_id"] = this.getCheckedStatusString(statusList);
                }
                if (!severityList[0].checked) {
                    tmpFilterParams["severity_id"] = this.getCheckedItemString(severityList);
                }
                if (!priorityList[0].checked) {
                        tmpFilterParams["priority_id"] = this.getCheckedItemString(priorityList);
                }
                if (!moduleList[0].checked) {
                    tmpFilterParams["module_id"] = this.getCheckedItemString(moduleList);
                }
                if (!iterationList[0].checked) {
                    tmpFilterParams["fixed_version_id"] = this.getCheckedItemString(iterationList);
                }
                if (!domainList[0].checked) {
                    tmpFilterParams["domain_id"] = this.getCheckedItemString(domainList);
                }
                if (!assignerList[0].checked) {
                    tmpFilterParams["assigned_to_id"] = this.getCheckedItemString(assignerList);
                }
                if (!authorList[0].checked) {
                    tmpFilterParams["author_id"] = this.getCheckedItemString(authorList);
                }
                if (!tagList[0].checked) {
                    tmpFilterParams["tag_id"] = this.getCheckedItemString(tagList);
                }
                return tmpFilterParams;
            },
            save: function () {
                uSetFilterParams(JSON.stringify(this.formatFilterParams()));
                console.log("filterParams:" + JSON.stringify(this.formatFilterParams()));
                uFinishCurrentPage();
            },
            goBack: function () {
                uFinishCurrentPage();
            },
            changeTab: function (sid) {
                switch (sid) {
                    case 0:
                        this.itemList = this.sort(statusList);
                        this.showSearchBar = false;
                        break;
                    case 1:
                        this.itemList = this.sort(severityList);
                        this.showSearchBar = false;
                        break;
                    case 2:
                        this.itemList = this.sort(priorityList);
                        this.showSearchBar = false;
                        break;
                    case 3:
                        this.itemList = this.sort(moduleList);
                        this.showSearchBar = true;
                        break;
                    case 4:
                        this.itemList = this.sort(iterationList);
                        this.showSearchBar = true;
                        break;
                    case 5:
                        this.itemList = this.sort(domainList);
                        this.showSearchBar = false;
                        break;
                    case 6:
                        this.itemList = this.sort(assignerList);
                        this.showSearchBar = true;
                        break;
                    case 7:
                        this.itemList = this.sort(authorList);
                        this.showSearchBar = true;
                        break;
                    case 8:
                        this.itemList = this.sort(tagList);
                        this.showSearchBar = true;
                        break;
                }
                this.items = this.itemList;
                this.queryValue = "";
                for (var i = 0; i < this.tabList.length; i++) {
                    this.tabList[i].checked = false;
                    if (this.tabList[i].sid == sid) {
                        this.tabList[i].checked = true;
                    }
                }
                this.currentTab = sid;
            },
            setList: function (list, id) {
                for (var i = 0; i < list.length; i++) {
                    list[i].checked = false;
                    list[i].sid = i;
                    if (list[i].id == id) {
                        list[i].checked = true;
                    }
                    if (list[i].project_uuid == id) {
                        list[i].checked = true;
                    }
                    if (list[i].statusId == id) {
                        list[i].checked = true;
                    }
                }
            },
            initList: function (list,checkedList) {
                if (checkedList.length > 0) {
                    for (var i = 0; i < checkedList.length; i++) {
                        for (var j = 0; j < list.length; j++) {
                            if (checkedList[i] == list[j].id + "" || checkedList[i] == list[j].statusId) {
                                list[0].checked = false;
                                list[j].checked = true;
                                break;
                            }
                        }
                    }
                    list = this.sort(list);
                }
                return list;
            },
            getFilterConditions: function (projectId) {
                var self = this;
                hGetFilterConditions({
                        "project_uuid": projectId
                }, function (data) {
                    self.setStatusList(data.issueStatusList);
                    self.setSeverityList(data.severitiesList);
                    self.setModuleList(data.moduleList);
                    self.setIterationList(data.iterationsList);
                    self.setDomainList(data.domainList);
                    self.setCurrentUserInfo(data.userInfo);
                    self.setMemberList(data.membersList);
                    self.setTagList(data.tagsList);

                    uSetFilterParams(JSON.stringify(self.formatFilterParams()));
                    self.initialize();
                    uHideLoadingPage();
                });
            },
            setStatusList: function (data) {
                var self = this;
                statusList = [];
                statusList[0] = {'name': '不限', 'checked': true, 'sid': 0, 'id':''};
                if (data.statuses.length > 0) {
                    var tmpStatusList = data.statuses;
                    for (var i = 0; i < tmpStatusList.length; i++) {
                        tmpStatusList[i].sid = i + 1;
                        statusList.push(tmpStatusList[i]);
                    }
                    self.setList(statusList, '');
                }
                statusList = self.initList(statusList, checkedStatusList);
                self.tabList[0].hasContent = statusList[0].checked ? false : true;
                self.itemList = statusList;
                self.items = self.itemList;
            },
            setSeverityList: function (data) {
                var self = this;
                severityList = [];
                severityList[0] = {'name': '不限', 'checked': true, 'sid': 0, 'id':''};
                if (data.severities.length > 0) {
                    var tmpSeverityList = data.severities;
                    for (var i = 0; i < tmpSeverityList.length; i++) {
                        tmpSeverityList[i].sid = i + 1;
                        severityList.push(tmpSeverityList[i]);
                    }
                    self.setList(severityList, '');
                }
                severityList = self.initList(severityList, checkedSeverityList);
                self.tabList[1].hasContent = severityList[0].checked ? false : true;
            },
            setModuleList: function (data) {
                var self = this;
                moduleList = [];
                moduleList[0] = {'name': '不限', 'checked': true, 'sid': 0, 'id':''};
                if (data.modules.length > 0) {
                    var tmpModuleList = data.modules;
                    for (var i = 0; i < tmpModuleList.length; i++) {
                        tmpModuleList[i].sid = i + 1;
                        moduleList.push(tmpModuleList[i]);
                    }
                    self.setList(moduleList, '');
                }
                moduleList = self.initList(moduleList, checkedModuleList);
                self.tabList[3].hasContent = moduleList[0].checked ? false : true;
            },
            setIterationList: function (data) {
                var self = this;
                iterationList = [];
                iterationList[0] = {'name': '不限', 'checked': true, 'sid': 0, 'id':''};
                if (data.iterations.length > 0) {
                    var tmpIterationList = data.iterations;
                    for (var i = 0; i < tmpIterationList.length; i++) {
                        tmpIterationList[i].sid = i + 1;
                        iterationList.push(tmpIterationList[i]);
                    }
                    self.setList(iterationList, '');
                }
                iterationList = self.initList(iterationList, checkedIterationList);
                self.tabList[4].hasContent = iterationList[0].checked ? false : true;
            },
            setDomainList: function (data) {
                var self = this;
                domainList = [];
                domainList[0] = {'name': '不限', 'checked': true, 'sid': 0, 'id':''};
                if (data.domains.length > 0) {
                    var tmpDomainList = data.domains;
                    for (var i = 0; i < tmpDomainList.length; i++) {
                        tmpDomainList[i].sid = i + 1;
                        domainList.push(tmpDomainList[i]);
                    }
                    self.setList(domainList, '');
                }
                domainList = self.initList(domainList, checkedDomainList);
                self.tabList[5].hasContent = domainList[0].checked ? false : true;
            },
            setMemberList: function (data) {
                var self = this;
                assignerList = [];
                authorList = [];
                var k = 0;
                for (var i = 0; i < data.members.length; i++) {
                    for (var j = 0; j < data.members[i].group_members.length; j++) {
                        data.members[i].group_members[j].sid = k++;
                        assignerList.push(data.members[i].group_members[j]);
                        authorList.push(JSON.parse(JSON.stringify(data.members[i].group_members[j])));
                    }
                }
                self.sortList(assignerList);
                self.sortList(authorList);

                self.setList(assignerList, '');
                self.setList(authorList, '');

                assignerList = self.initList(assignerList, checkedAssignerList);
                authorList = self.initList(authorList, checkedAuthorList);

                self.tabList[6].hasContent = assignerList[0].checked ? false : true;
                self.tabList[7].hasContent = authorList[0].checked ? false : true;
            },
            setTagList: function (data) {
                var self = this;
                tagList = [];
                tagList[0] = {'name': '不限', 'checked': true, 'sid': 0, 'id':''};
                if (data.tags.length > 0) {
                    var tmpTagList = data.tags;
                    for (var i = 0; i < tmpTagList.length; i++) {
                        tmpTagList[i].sid = i + 1;
                        tagList.push(tmpTagList[i]);
                    }
                    self.setList(tagList, '');
                }
                tagList = self.initList(tagList, checkedTagList);
                self.tabList[8].hasContent = tagList[0].checked ? false : true;
            },
            setCurrentUserInfo: function (data) {
                var self = this;
                currentUserInfo = data;
            },

            sortList: function(list) {
                var key = null;
                for (var i = 0; i < list.length; i++) {
                    if (list[i].id == currentUserInfo.id) {
                        key = list[i];
                        list.splice(i, 1);
                        break;
                    }
                }
                if (key) {
                    list.unshift(key);
                }
                list.unshift({'name': '不限', 'checked': true, 'sid': 0, 'id':''});
            },
            initialize: function () {
                uSet("WorkItem0", "0");
                uSet("WorkItem1", "0");
                uSet("WorkItem2", "0");
                uSet("WorkItem3", "0");
                uSet("WorkItem4", "0");
            },
            search: function () {
                if (this.queryValue != "") {
                    this.items = [];
                    for (var i = 0; i < this.itemList.length; i++) {
                        if (this.itemList[i].name.indexOf(this.queryValue) >= 0 || (this.itemList[i].nickname && this.itemList[i].nickname.indexOf(this.queryValue) >= 0) || (this.itemList[i].first_name && this.itemList[i].first_name.indexOf(this.queryValue) >= 0)) {
                            this.items.push(this.itemList[i]);
                        }
                    }
                } else {
                    this.items = this.itemList;
                }
            },
            reset: function () {
                this.resetList(statusList);
                this.resetList(severityList);
                this.resetList(priorityList);
                this.resetList(moduleList);
                this.resetList(iterationList);
                this.resetList(domainList);
                this.resetList(assignerList);
                this.resetList(authorList);
                this.resetList(tagList);
                this.checkContent();
            },
            resetList: function (list) {
                for (var i = 0; i < list.length; i++) {
                    list[i].checked = false;
                }
                list[0].checked = true;
            }
        },
        watch: {
            queryValue:function (val,oldVal) {
                this.search();
            }
        }
    })
};
