window.onload = function () {
    uShowLoadingPage();
    var originalProjectUUId = "";
    var lastWorkItemInfo = uGetWorkItemInfo();

    var parentIssueId = uGet("parent_issue_id");
    var parentIssueName = uGet("parent_issue_name");
    var parentIssueType = uGet("parent_issue_type");

    var TITLE_PATTERN = /^[a-zA-Z0-9\u4E00-\u9FA5\s\^\-_*&`~\\/|;；:：{},!@#$&().'\&quot;\[\]<>?·！（）——、‘“”？—。，《》%【】\\+]+$/;
    var DESCRIPTION_PATTERN = /^[a-zA-Z0-9\u4E00-\u9FA5\s\^\-_*&`~\\/|;；:：{},!@#$&().'\&quot;\[\]<>?·！（）——、‘“”？—。，《》%【】\\+]+$/;
    var currentUserInfo;
    var projectList = [];
    var userList = [];
    var milestoneList = [];
    var moduleList = [];
    var domainList = [];
    var initialRequest = true;
    var tmpAllTagList = [];
    var typeList_normal = [
            {'name': '需求', 'checked': false, 'id': '1', 'sid': 0},
            {'name': '任务', 'checked': false, 'id': '2', 'sid': 1},
            {'name': '缺陷', 'checked': true, 'id': '3', 'sid': 2}
        ];
    var typeList_scrum = [
        {'name': 'Bug', 'checked': false, 'id': '3', 'sid': 0},
        {'name': 'Feature', 'checked': false, 'id': '6', 'sid': 1},
        {'name': 'Story', 'checked': true, 'id': '7', 'sid': 2}
    ];
    var typeList = typeList_normal;
    var priorityList = [
            {'name': '低', 'checked': false, 'id': '1', 'sid': 0},
            {'name': '中', 'checked': true, 'id': '2', 'sid': 1},
            {'name': '高', 'checked': false, 'id': '3', 'sid': 2}
        ];
    var severityList = [
            {'name': '关键', 'checked': false, 'id': '10', 'sid': 0},
            {'name': '重要', 'checked': false, 'id': '11', 'sid': 1},
            {'name': '一般', 'checked': true, 'id': '12', 'sid': 2},
            {'name': '提示', 'checked': false, 'id': '13', 'sid': 3}
        ];
    var searchHintList = {
        'project': [stringMap.project_not_found],
        'assigner': [stringMap.member_not_found],
        'milestone': [stringMap.iteration_not_found, stringMap.no_iteration],
        'module': [stringMap.module_not_found, stringMap.no_module],
        'domain': [stringMap.domain_not_found, stringMap.no_domain]
    };
    var tagCount = 0;
    var attachmentLongPressed = false;
    var timeOutEvent = 0;
    var isSaving = false;
    var isWorkItemInfoChanged = false;
    var fileCount = 0;
    var totalSize = 0;
    var getThumbnail = function (tmpImagesParentElement) {
        var imageElements = $(tmpImagesParentElement);
        for (var i = 0; i < imageElements.length; i++) {
            if (imageElements[i].width > imageElements[i].height) {
                imageElements[i].width = 200;
            } else {
                imageElements[i].height = 200;
            }
        }
        $(tmpImagesParentElement).find('img').wrap("<div style='width: 200px; height: 200px; display: flex; justify-content: center; align-items: center; border: 1px solid #eeeeee; margin-left: 10px'></div>")
    };

    var requestDoneFlags = {
        getCurrentUserInfo: false,
        getMyProjects: false,
        getSeverity: false,
        getUserListByProjectId: true,
        getProjectTags: true,
        getMilestone: true,
        getModule: true,
        getDomain: true
    };
    var isAllRequestDone = function () {
        var allRequestDone = true;
        console.log("requestDoneFlags: " + JSON.stringify(requestDoneFlags));
        for (var request in requestDoneFlags) {
            if (!requestDoneFlags[request]) {
                allRequestDone = false;
            }
        }

        return allRequestDone;
    };
    var vm = new Vue({
        el: '#view-container',
        data: {
            listKey: "",
            workItemInfo: {
                'subject': "",
                'priority':priorityList[1],
                'type':typeList[2],
                'severity':"",
                'startDate': new Date(),
                'dueDate': new Date(new Date().getTime() + 1 * 3600000 * 24),
                'description': "",
                'project': {},
                'assigner': {},
                'milestone': {},
                'module': {},
                'domain': {},
                'tagList':[],
                'father':{'id':parentIssueId,"name":parentIssueName}
            },
            allTaglist: [],
            tmpTagList:[],
            showMoreFlag:false,

            attachmentList:[],
            attachmentDeleteButton:false,
            tagColor: "#48CFAD",
            originalWorkItemInfo:null,
            projectTypeNormal:true,
            isChild:false
        },

        mounted: function () {
            console.log("lastWorkItemInfo:" + lastWorkItemInfo);
            var self = this;
            self.isChild = (parentIssueId != "") ? true : false;

            uShowSelf();

            uSetCheckDataListener(function () {
                self.checkData();
            });

            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });

            uSetPublicCompleteButtonClickListener(function () {
                self.save();
            });
            uSetupdateWorkInfoSubjectListener(function (subject) {
                console.log(subject+"______");
                self.changeWorkItemInfoSubject(subject);
            });
            uSetOpenSingleAttachmentFinishedListener(function (src,duration,fileSize) {
                var maxSize = uIsSelfRegion() ? 4 : 10;
                console.log("src:" + src);
                console.log("duration:" + duration);
                console.log("fileSize:" + fileSize);
                if (fileSize > maxSize * 1024 * 1024) {
                    var index1=src.lastIndexOf("/");
                    var index2=src.lastIndexOf(".");
                    var fileName=src.substring(index1+1);
                    uShowAlertDialog("文件" + fileName + "大小超过" + maxSize + "MB限制,上传失败");
                } else {
                    if (uIsSelfRegion() && totalSize + fileSize > 4 * 1024 * 1024){
                        uShowAlertDialog(stringMap.attachment_size_limit);
                    } else if (totalSize + fileSize > 20 * 1024 * 1024){
                        uShowAlertDialog(stringMap.self_zone_attachment_size_limit);
                    } else {
                        self.addAttachment(src,fileSize,duration);
                    }
                }
            });

            uSetVoicePlayFinishedListener(function () {
                self.voicePlayFinished();
            });

            uSetStopRecordListener(function () {
                self.stopRecord();
            });

            uSetOpenMultipleAttachmentFinishedListener(function (srcGroup) {
                srcGroup = JSON.parse(srcGroup);
                var maxSize = uIsSelfRegion() ? 4 : 10;
                for (var i = 0; i < srcGroup.length; i++) {
                    if (srcGroup[i].fileSize > maxSize * 1024 * 1024) {
                        var index1=srcGroup[i].src.lastIndexOf("/");
                        var index2=srcGroup[i].src.lastIndexOf(".");
                        var fileName=srcGroup[i].src.substring(index1+1);
                        uShowAlertDialog("文件" + fileName + "大小超过" + maxSize + "MB限制,上传失败");
                    } else {
                        if (uIsSelfRegion() && totalSize + srcGroup[i].fileSize > 4 * 1024 * 1024){
                            uShowAlertDialog(stringMap.attachment_size_limit);
                            break;
                        }
                        if (totalSize + srcGroup[i].fileSize > 20 * 1024 * 1024){
                            uShowAlertDialog(stringMap.self_zone_attachment_size_limit);
                            break;
                        } else {
                            self.addAttachment(srcGroup[i].src,srcGroup[i].fileSize);
                        }
                    }
                }
            });

            uSetConfirmDialogConfirmedListener(function () {
                self.confirmBack();
            });

            uSetUpdateWorkItemListener(function () {
                self.updateWorkItem();
            });

            $(window).on('touchstart', function (event) {
                if (!attachmentLongPressed && self.attachmentDeleteButton) {
                    self.attachmentDeleteButton = false;
                }
            });

            originalProjectUUId = uGet("project_uuid");
            if (originalProjectUUId == "") {
                if (lastWorkItemInfo != "") {
                    console.log(JSON.parse(lastWorkItemInfo));
                    originalProjectUUId = JSON.parse(lastWorkItemInfo).projectUUID;
                    if (JSON.parse(lastWorkItemInfo).projectType == "normal") {
                        self.projectTypeNormal = true;
                        typeList = typeList_normal;
                        uSet("project_type", "normal");


                    } else {
                        self.projectTypeNormal = false;
                        typeList = typeList_scrum;
                        uSet("project_type", "scrum");

                    }

                    for (var i = 0; i < typeList.length; i++) {
                        if (JSON.parse(lastWorkItemInfo).workItemType == typeList[i].name) {
                            self.workItemInfo.type = typeList[i];
                            self.setList(typeList, self.workItemInfo.type.id);
                        }
                    }


                }
            } else {
                self.projectTypeNormal = (uGet("project_type") == "normal") ? true : false;
                typeList = (uGet("project_type") == "normal") ? typeList_normal : typeList_scrum;
                var typeId = uGet("workItem_type");
                switch (typeId) {
                    case "0":
                        self.workItemInfo.type = (uGet("project_type") == "normal") ? typeList[2] : typeList[1];
                        break;
                    case "1":
                        self.workItemInfo.type = (uGet("project_type") == "normal") ? typeList[0] : typeList[2];
                        break;
                    case "2":
                        self.workItemInfo.type = (uGet("project_type") == "normal") ? typeList[1] : typeList[2];
                        break;
                    case "3":
                        self.workItemInfo.type = (uGet("project_type") == "normal") ? typeList[2] : typeList[0];
                        break;
                    default:
                        self.workItemInfo.type = (uGet("project_type") == "normal") ? typeList[2] : typeList[2];
                        break;
                }
                self.setList(typeList, self.workItemInfo.type.id);
            }

            this.requestData();
        },

        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },
        
        watch: {
            workItemInfo: {
                handler: function (val, oldVal) {
                    var subject = this.workItemInfo.subject;
                    if (subject.replace(/\s/g, "") != "" && (this.workItemInfo.project.uuid || this.workItemInfo.project.project_uuid)) {
                        uSetSaveButtonClickable("true");
                    } else {
                        uSetSaveButtonClickable("false");
                    }
                },
                deep: true
            }
        },

        methods: {
            setTypeList:function () {
                var self = this;
                if(self.isChild && !self.projectTypeNormal) {
                    console.log("parentIssueType:" + parentIssueType);
                    if (parentIssueType == "6") {
                        typeList = [
                            {'name': 'Story', 'checked': true, 'id': '7', 'sid': 0}
                        ];
                        self.workItemInfo.type = typeList[0];
                    }
                    if (parentIssueType == "7") {
                        typeList = [
                            {'name': 'Task', 'checked': true, 'id': '2', 'sid': 0},
                            {'name': 'Bug', 'checked': false, 'id': '3', 'sid': 1}
                        ];
                        self.workItemInfo.type = typeList[0];
                    }
                }
            },
            requestData:function () {
                var self = this;
                if (originalProjectUUId && originalProjectUUId != "") {
                    hUserBetaStatus({
                        "project_uuid": originalProjectUUId
                    }, function (result) {
                        console.log("hUserBetaStatus" + JSON.stringify(result));
                        if (!self.isChild) {
                            if (2 == result.order_status) {
                                uShowAlertDialog(stringMap.work_item_insertion_fail1);
                                originalProjectUUId = "";
                            } else if (0 === result.status && 0 === result.free_quota){
                                uShowAlertDialog(stringMap.work_item_insertion_fail2);
                                originalProjectUUId = "";
                            }
                        }

                        hGetCurrentUserInfo({}, function (data) {
                            currentUserInfo = data;
                            if (originalProjectUUId && originalProjectUUId != "") {
                                requestDoneFlags.getUserListByProjectId = false;
                                self.getUserListByProjectId(originalProjectUUId);
                            }
                            requestDoneFlags.getCurrentUserInfo = true;
                            if (isAllRequestDone()) {
                                if (initialRequest) {
                                    self.originalWorkItemInfo = JSON.parse(JSON.stringify(self.workItemInfo));
                                }
                                uHideLoadingPage();
                                initialRequest = false;
                            }
                        });

                        self.getMyProjects();
                        if (originalProjectUUId && originalProjectUUId != "") {
                            requestDoneFlags.getProjectTags = false;
                            requestDoneFlags.getMilestone = false;
                            requestDoneFlags.getModule = false;
                            requestDoneFlags.getDomain = false;
                            self.getProjectTags(originalProjectUUId);
                            self.getMilestone(originalProjectUUId);
                            self.getModule(originalProjectUUId);
                            self.getDomain(originalProjectUUId);


                            self.setTypeList();
                        }
                    },function (data) {
                        uSetWorkItemInfo("", "", "");
                        hGetCurrentUserInfo({}, function (data) {
                            currentUserInfo = data;
                            requestDoneFlags.getCurrentUserInfo = true;
                            if (isAllRequestDone()) {
                                if (initialRequest) {
                                    self.originalWorkItemInfo = JSON.parse(JSON.stringify(self.workItemInfo));
                                }
                                uHideLoadingPage();
                                initialRequest = false;
                            }
                        });
                        self.getMyProjects();
                    });
                } else {
                    hGetCurrentUserInfo({}, function (data) {
                        currentUserInfo = data;
                        requestDoneFlags.getCurrentUserInfo = true;
                        if (isAllRequestDone()) {
                            if (initialRequest) {
                                self.originalWorkItemInfo = JSON.parse(JSON.stringify(self.workItemInfo));
                            }
                            uHideLoadingPage();
                            initialRequest = false;
                        }
                    });
                    self.getMyProjects();
                }


                hGetSeverity({}, function (data) {
                    severityList = data.severities;
                    for (var i = 0; i < data.severities.length; i++) {
                        if (data.severities[i].is_default == true) {
                            self.workItemInfo.severity = data.severities[i];
                            self.setList(severityList, data.severities[i].id);
                        }
                    }
                    requestDoneFlags.getSeverity = true;
                    if (isAllRequestDone()) {
                        if (initialRequest) {
                            self.originalWorkItemInfo = JSON.parse(JSON.stringify(self.workItemInfo));
                        }
                        uHideLoadingPage();
                        initialRequest = false;
                    }
                });
            },
            checkData: function () {
                console.log("checkData");
                if (this.workItemInfo.project.id == null) {
                    uShowLoadingPage();
                    requestDoneFlags = {
                        getCurrentUserInfo: false,
                        getMyProjects: false,
                        getSeverity: false,
                        getUserListByProjectId: true,
                        getProjectTags: true,
                        getMilestone: true,
                        getModule: true,
                        getDomain: true
                    };
                    this.requestData();
                }
            },
            updateWorkItem: function () {
                if (uGet("choosedItem") && uGet("choosedItem") != "") {
                    var choosedItem = JSON.parse(uGet("choosedItem"));
                    if (this.listKey == 'assigner') {
                        var choosedItemGroup = JSON.parse(uGet("choosedItemGroup"));
                        this.chooseItemFromList(choosedItem,choosedItemGroup);
                    } else {
                        this.chooseItemFromList(choosedItem);
                    }
                    uSet("choosedItem","");
                }
                if (uGet("startDate") && uGet("startDate") != "") {
                    this.workItemInfo.startDate = JSON.parse(uGet("startDate"));
                    uSet("startDate","");
                }
                if (uGet("dueDate") && uGet("dueDate") != "") {
                    this.workItemInfo.dueDate = JSON.parse(uGet("dueDate"));
                    uSet("dueDate","");
                }
                if (uGet("tagColor") && uGet("tagColor") != "") {
                    this.tagColor = JSON.parse(uGet("tagColor"));
                    uSet("tagColor","");
                }
                if (uGet("allTaglist") && uGet("allTaglist") != "") {
                    this.allTaglist = JSON.parse(uGet("allTaglist"));
                    this.saveTags();
                    tagCount = JSON.parse(uGet("tagCount"));
                    uSet("allTaglist","");
                }
            },
            touchStartForRecord: function () {
                $(".workItem_sendAttachment_record")[0].style.color = "#91eed0";
                uStartAudioRecorder();
            },

            touchEndForRecord: function () {
                $(".workItem_sendAttachment_record")[0].style.color = "#555555";
                uStopAudioRecorder();
            },
            stopRecord: function () {
                $(".workItem_sendAttachment_record")[0].style.color = "#555555";
            },
            touchStartForDelete: function () {
                var self = this;
                timeOutEvent = setTimeout(function () {
                    timeOutEvent = 0;
                    self.attachmentDeleteButton = true;
                },500);
                attachmentLongPressed = true;
            },
            touchMoveForDelete: function () {
                clearTimeout(timeOutEvent);
                timeOutEvent = 0;
            },
            touchEndForDelete: function () {
                clearTimeout(timeOutEvent);
                attachmentLongPressed = false;
            },
            confirmBack: function () {
                uHideLoadingPage();
                uFinishCurrentPage();
            },
            goBack: function () {
                if (isSaving) {
                    return;
                }

                console.log("originalProjectUUId:" + originalProjectUUId);
                if (isAllRequestDone() && !(JSON.stringify(this.originalWorkItemInfo) == JSON.stringify(this.workItemInfo)) || (this.attachmentList.length > 0)) {
                    uShowConformDialog(stringMap.go_back_confirm);
                } else {
                    uHideLoadingPage();
                    uFinishCurrentPage();
                }
            },
            save: function () {
                var self = this;
                if (isSaving) {
                    return;
                }
                var subject = this.workItemInfo.subject;
                if (subject.replace(/\s/g, "") == "") {
                    uShowAlertDialog(stringMap.work_item_title_limit1);
                } else if (this.workItemInfo.subject.length > 128) {
                    uShowAlertDialog(stringMap.work_item_title_limit2);
                } else if ((!(this.workItemInfo.subject.match(TITLE_PATTERN)))) {
                    uShowAlertDialog(stringMap.work_item_title_limit3);
                } else if (this.workItemInfo.description.length > 10000) {
                    uShowAlertDialog(stringMap.work_item_title_limit4);
                } else if (this.workItemInfo.description != "" && !this.workItemInfo.description.match(DESCRIPTION_PATTERN)) {
                    uShowAlertDialog(stringMap.work_item_title_limit5);
                }

                else {
                    for (var i = 0; i < this.attachmentList.length; i++) {
                        if (!uIsFileExist(this.attachmentList[i].content.src)) {
                            uShowAlertDialog("文件" + this.attachmentList[i].content.name + "已不存在");
                            return;
                        }
                    }

                    var params = {
                        "project_uuid": this.workItemInfo.project.uuid || this.workItemInfo.project.project_uuid,
                        "subject": this.workItemInfo.subject,
                        "description" : "<p style='font-size: 20px;font-weight: normal;line-height: 30px'>" + this.workItemInfo.description.replace(/&/, "&amp;").replace(/ /g, "&nbsp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/,"&quot;") + "</p>",
                        "type_id": this.workItemInfo.type.id,
                        "priority_id" : this.workItemInfo.priority.id,
                        "start_date": new Date(this.workItemInfo.startDate).getTime(),
                        "due_date": new Date(this.workItemInfo.dueDate).getTime(),
                        "expected_work_hours": "0.0",
                        "assigned_to_id": this.workItemInfo.assigner.id,
                        "severity_id" : this.workItemInfo.severity.id
                    };
                    if (parentIssueId != "") {
                        params["parent_id"] = parentIssueId;
                    }
                    if (this.workItemInfo.milestone.id) {
                        params["iteration_id"] = this.workItemInfo.milestone.id;
                    }
                    if (this.workItemInfo.module.id) {
                        params["module_id"] = this.workItemInfo.module.id;
                    }
                    if (this.workItemInfo.domain.id) {
                        params["domain_id"] = this.workItemInfo.domain.id;
                    }
                    if (this.workItemInfo.tagList.length) {
                        params["tags"] = this.workItemInfo.tagList;
                    }

                    isSaving = true;
                    var tmpAttachmentList = [];
                    for (var i = 0; i < this.attachmentList.length; i++) {
                        tmpAttachmentList.push({"src": this.attachmentList[i].content.src});
                    }

                    uShowLoadingPage();
                    uSetWorkItemInfo(params.project_uuid, this.workItemInfo.type.name, this.projectTypeNormal ? "normal" : "scrum");
                    hCreateIssue(params, function (data) {
                        if (tmpAttachmentList.length) {
                            hUploadAttachment({
                                "project_uuid":self.workItemInfo.project.uuid || self.workItemInfo.project.project_uuid,
                                "issue_id":data.issue.id + "",
                                "fileList":tmpAttachmentList
                            }, function (file, docmanData) {

                                hAddAttachmentForWorkItem(tmpAttachmentList[0].src,{
                                    "project_uuid":self.workItemInfo.project.uuid || self.workItemInfo.project.project_uuid,
                                    "issue_id":data.issue.id,
                                    "files":docmanData
                                }, function (data) {
                                    uHideLoadingPage();
                                    if (self.isChild) {
                                    }
                                    initialize();
                                    uShowToast(stringMap.work_item_create_success);
                                    uSet("needRequestAwaitWorkItem","true");
                                    uSet("needRequestProject","true");
                                    uGoToProject(params.project_uuid, self.projectTypeNormal ? "normal" : "scrum", self.workItemInfo.project.name, self.workItemInfo.type.id);
                                }, function () {
                                    isSaving = false;
                                    uHideLoadingPage();
                                    uShowAlertDialog(stringMap.work_item_attachment_add_fail);
                                });
                            }, function (file, data) {
                                isSaving = false;
                                uHideLoadingPage();
                                uShowAlertDialog(data.reason);
                                uFinishCurrentPage();
                            });
                        } else {
                            uHideLoadingPage();
                            if (self.isChild) {
                            }
                            uShowToast(stringMap.work_item_create_success);
                            initialize();
                            uSet("needRequestAwaitWorkItem","true");
                            uSet("needRequestProject","true");
                            uGoToProject(params.project_uuid, self.projectTypeNormal ? "normal" : "scrum", self.workItemInfo.project.name, self.workItemInfo.type.id);
                        }
                    },function (data) {
                        uHideLoadingPage();
                        isSaving = false;
                        uShowAlertDialog(data.reason);
                    });
                }
            },
            showMore: function (flag) {
                var self = this;
                $("#autoTest_workItemInsertion_more").slideToggle(300, function () {
                    self.showMoreFlag = !self.showMoreFlag;
                });
            },
            showDatePickerPage: function () {
                uSet("web_view_fragment_title","选择计划日期");
                uSet("startDate",JSON.stringify(this.workItemInfo.startDate));
                uSet("dueDate",JSON.stringify(this.workItemInfo.dueDate));
                uSet("milestone",JSON.stringify(this.workItemInfo.milestone));
                uSet("web_view_fragment_url","file:///android_asset/page/workItemSubPage/workItemDatePicker.html");
                uShowSubPage();
            },
            showItemListPage: function (key) {
                this.listKey = key;
                switch (key) {
                    case 'type':
                        uSet("web_view_fragment_title","选择类型");
                        uSet("hasSearch","false");
                        uSet("itemList",JSON.stringify(typeList));
                        break;
                    case 'priority':
                        uSet("web_view_fragment_title","选择优先级");
                        uSet("hasSearch","false");
                        uSet("itemList",JSON.stringify(priorityList));
                        break;
                    case 'severity':
                        uSet("web_view_fragment_title","选择重要程度");
                        uSet("hasSearch","false");
                        uSet("itemList",JSON.stringify(severityList));
                        break;
                    case 'assigner':
                        uSet("web_view_fragment_title","选择处理人");
                        uSet("hasSearch","true");
                        uSet("itemList",JSON.stringify(userList));
                        uSet("searchHint",JSON.stringify(searchHintList["assigner"]));
                        break;
                    case 'milestone':
                        uSet("web_view_fragment_title","选择迭代");
                        uSet("hasSearch","true");
                        uSet("itemList",JSON.stringify(milestoneList));
                        uSet("searchHint",JSON.stringify(searchHintList["milestone"]));
                        break;
                    case 'module':
                        uSet("web_view_fragment_title","选择模块");
                        uSet("hasSearch","true");
                        uSet("itemList",JSON.stringify(moduleList));
                        uSet("searchHint",JSON.stringify(searchHintList["module"]));
                        break;
                    case 'domain':
                        uSet("web_view_fragment_title","选择领域");
                        uSet("hasSearch","false");
                        uSet("itemList",JSON.stringify(domainList));
                        uSet("searchHint",JSON.stringify(searchHintList["domain"]));
                        break;
                    case 'project':
                        uSet("web_view_fragment_title","选择项目");
                        uSet("hasSearch","true");
                        uSet("itemList",JSON.stringify(projectList));
                        uSet("searchHint",JSON.stringify(searchHintList["project"]));
                        break;
                }
                uSet("web_view_fragment_url","file:///android_asset/page/workItemSubPage/workItemList.html");
                uShowSubPage();
            },
            setList: function (list, id) {
                for (var i = 0; i < list.length; i++) {
                    list[i].checked = false;
                    list[i].sid = i;
                    if (list[i].id == id) {
                        list[i].checked = true;
                    }
                    if (list[i].project_uuid == id) {
                        list[i].checked = true;
                    }
                }
            },
            chooseItemFromList: function (item,itemGroup) {
                var self = this;
                switch (this.listKey) {
                    case 'type':
                        this.workItemInfo.type = item;
                        this.setList(typeList, item.id);
                        break;

                    case 'priority':
                        this.workItemInfo.priority = item;
                        this.setList(priorityList, item.id);
                        break;
                    case 'severity':
                        this.workItemInfo.severity = item;
                        this.setList(severityList, item.id);
                        break;
                    case 'assigner':
                        this.workItemInfo.assigner = item;
                        for (var i = 0; i < userList.length; i++) {
                            for (var j = 0; j < userList[i].group_members.length; j++) {
                                userList[i].group_members[j].checked = false;
                            }
                            if (userList[i].group_name == itemGroup.group_name) {
                                userList[i].group_members[item.sid].checked = true;
                            }
                        }
                        break;
                    case 'project':
                        uShowLoadingPage();
                        hUserBetaStatus({
                            "project_uuid": item.project_uuid
                        }, function (data) {
                            if (2 === data.order_status) {
                                uHideLoadingPage();
                                uShowAlertDialog(stringMap.work_item_migrate_fail1);
                            } else if (0 === data.status && 0 === data.free_quota) {
                                uHideLoadingPage();
                                uShowAlertDialog(stringMap.work_item_migrate_fail2);
                            } else {
                                uShowLoadingPage();
                                console.log("choose project:" + JSON.stringify(item));
                                self.workItemInfo.project = item;
                                self.setList(projectList, item.project_uuid);
                                requestDoneFlags.getUserListByProjectId = false;
                                requestDoneFlags.getProjectTags = false;
                                requestDoneFlags.getMilestone = false;
                                requestDoneFlags.getModule = false;
                                requestDoneFlags.getDomain = false;
                                self.getUserListByProjectId(item.project_uuid);
                                self.getMilestone(item.project_uuid);
                                self.getModule(item.project_uuid);
                                self.getDomain(item.project_uuid);
                                self.getProjectTags(item.project_uuid);

                                self.projectTypeNormal = (item.type == "normal") ? true : false;
                                typeList = (item.type == "normal") ? typeList_normal : typeList_scrum;
                                self.workItemInfo.type = (item.type == "normal") ? typeList[2] : typeList[2];

                                console.log("choose projectTypeNormal:" + JSON.stringify(self.projectTypeNormal));
                                console.log("item.type:" + JSON.stringify(typeList));
                                console.log("workItemInfo.type:" + JSON.stringify(self.workItemInfo.type));
                            }
                        });
                        break;
                    case 'milestone':
                        this.setList(milestoneList, item.id);
                        if (item.name == "待分配") {
                            this.workItemInfo.milestone = {'name': '待分配','id':''};
                        } else {
                            this.workItemInfo.milestone = item;
                            //切换迭代后，需调整计划日期
                            this.workItemInfo.startDate = new Date(item.start_date);
                            this.workItemInfo.dueDate = new Date(item.due_date);
                            uShowToast(stringMap.date_update);
                        }
                        break;
                    case 'module':
                        this.setList(moduleList, item.id);
                        if (item.name == "待分配") {
                            this.workItemInfo.module = {'name': '待分配','id':''};
                        } else {
                            this.workItemInfo.module = item;
                            //切换模块后，需调整工作项负责人
                            for (var i = 0; i < userList.length; i++) {
                                for (var j = 0; j < userList[i].group_members.length; j++) {
                                    userList[i].group_members[j].checked = false;
                                    if (item.owner && userList[i].group_members[j].id == item.owner.id) {
                                        userList[i].group_members[j].checked = true;
                                        this.workItemInfo.assigner = userList[i].group_members[j];
                                    }
                                }
                            }
                        }
                        break;
                    case 'domain':
                        this.setList(domainList, item.id);
                        if (item.name == "待分配") {
                            this.workItemInfo.domain = {'name': '待分配','id':''};
                        } else {
                            this.workItemInfo.domain = item;
                        }
                        break;
                }
            },
            showTagEditPage: function () {
                uSet("web_view_fragment_title","编辑标签");
                uSet("tagColor",JSON.stringify(this.tagColor));
                uSet("tagCount",JSON.stringify(tagCount));
                uSet("allTaglist",JSON.stringify(this.allTaglist));
                uSet("web_view_fragment_url","file:///android_asset/page/workItemSubPage/workItemTag.html");
                uShowSubPage();
            },
            saveTags: function () {
                this.workItemInfo.tagList = [];
                this.tmpTagList = [];
                for (var i = 0; i < this.allTaglist.length; i++) {
                    if (this.allTaglist[i].checked) {
                        this.tmpTagList.push(this.allTaglist[i]);
                        this.workItemInfo.tagList.push({"name": this.allTaglist[i].name,"color_id":colorIdReverseMap[this.allTaglist[i].color]});
                    }
                }
            },
            getMyProjects: function () {
                var self = this;
                hGetMyProjects({
                    "query_type": "simplify"
                }, function (data) {
                    projectList = data.projects;
                    self.setList(projectList, -1);
                    for (var i = 0; i < projectList.length; i++) {
                        if (projectList[i].project_uuid == originalProjectUUId) {
                            self.workItemInfo.project = projectList[i];
                            self.setList(projectList, originalProjectUUId);
                        }
                    }
                    requestDoneFlags.getMyProjects = true;
                    if (isAllRequestDone()) {
                        if (initialRequest) {
                            self.originalWorkItemInfo = JSON.parse(JSON.stringify(self.workItemInfo));
                        }
                        uHideLoadingPage();
                        initialRequest = false;
                    }
                });
            },
            getUserListByProjectId: function (projectId) {
                var self = this;
                hGetUserListByProjectId({
                    "project_uuid": projectId
                }, function (data) {
                    userList = data.members;

                    for (var i = 0; i < userList.length; i++) {
                        for (var j = 0; j < userList[i].group_members.length; j++) {
                            userList[i].group_members[j].checked = false;
                            userList[i].group_members[j].sid = j;
                            if (userList[i].group_members[j].name.toLowerCase() == currentUserInfo.user_name.toLowerCase()) {
                                userList[i].group_members[j].checked = true;
                                self.workItemInfo.assigner = userList[i].group_members[j];
                            }
                        }
                    }
                    requestDoneFlags.getUserListByProjectId = true;
                    if (isAllRequestDone()) {
                        if (initialRequest) {
                            self.originalWorkItemInfo = JSON.parse(JSON.stringify(self.workItemInfo));
                        }
                        uHideLoadingPage();
                        initialRequest = false;
                    }
                });
            },
            getMilestone: function (projectId) {
                var self = this;
                hGetMilestone({
                    "project_uuid": projectId
                }, function (data) {
                    milestoneList = [];
                    self.workItemInfo.milestone = {'name': '待分配','id':''};
                    if (data.iterations.length > 0) {
                        milestoneList[0] = {'name': '待分配', 'checked': true, 'sid': 0, 'id':''};
                        var tmpMilestoneList = data.iterations;
                        tmpMilestoneList.sort(function (a, b) {
                            var tmpA  = Math.abs((new Date(a.due_date)).getTime() - new Date().getTime());
                            var tmpB  = Math.abs((new Date(b.due_date)).getTime() - new Date().getTime());
                            return (tmpA - tmpB);
                        });
                        for (var i = 0; i < tmpMilestoneList.length; i++) {
                            tmpMilestoneList[i].sid = i + 1;
                            milestoneList.push(tmpMilestoneList[i]);
                        }
                        self.setList(milestoneList, milestoneList[1].id);
                        self.workItemInfo.milestone = milestoneList[1];

                        for (var i = 1; i < milestoneList.length; i++) {
                            if(new Date(milestoneList[i].due_date).getTime() - new Date().getTime() > 0) {
                                self.setList(milestoneList, milestoneList[i].id);
                                self.workItemInfo.milestone = milestoneList[i];
                                break;
                            }
                        }
                        self.workItemInfo.startDate = new Date(self.workItemInfo.milestone.start_date);
                        self.workItemInfo.dueDate = new Date(self.workItemInfo.milestone.due_date);
                    }
                    requestDoneFlags.getMilestone = true;
                    if (isAllRequestDone()) {
                        if (initialRequest) {
                            self.originalWorkItemInfo = JSON.parse(JSON.stringify(self.workItemInfo));
                        }
                        uHideLoadingPage();
                        initialRequest = false;
                    }
                });
            },
            getModule: function (projectId) {
                var self = this;
                hGetModule({
                    "project_uuid": projectId
                }, function (data) {
                    moduleList = [];
                    self.workItemInfo.module = {'name': '待分配','id':''};
                    if (data.modules.length > 0) {
                        moduleList[0] = {'name': '待分配', 'checked': true, 'sid': 0, 'id':''};
                        var tmpModuleList = data.modules;
                        for (var i = 0; i < tmpModuleList.length; i++) {
                            tmpModuleList[i].sid = i + 1;
                            moduleList.push(tmpModuleList[i]);
                        }
                        self.setList(moduleList, '');
                    }
                    requestDoneFlags.getModule = true;
                    if (isAllRequestDone()) {
                        if (initialRequest) {
                            self.originalWorkItemInfo = JSON.parse(JSON.stringify(self.workItemInfo));
                        }
                        uHideLoadingPage();
                        initialRequest = false;
                    }
                });
            },
            getDomain: function (projectId) {
                var self = this;
                hGetDomain({
                    "project_uuid": projectId
                }, function (data) {
                    domainList = [];
                    self.workItemInfo.domain = {'name': '待分配','id':''};
                    if (data.domains.length > 0) {
                        domainList[0] = {'name': '待分配', 'checked': true, 'sid': 0, 'id':''};
                        var tmpDomainList = data.domains;
                        for (var i = 0; i < tmpDomainList.length; i++) {
                            tmpDomainList[i].sid = i + 1;
                            domainList.push(tmpDomainList[i]);
                        }
                        self.setList(domainList, '');
                    }
                    requestDoneFlags.getDomain = true;
                    if (isAllRequestDone()) {
                        if (initialRequest) {
                            self.originalWorkItemInfo = JSON.parse(JSON.stringify(self.workItemInfo));
                        }
                        uHideLoadingPage();
                        initialRequest = false;
                    }
                });
            },
            getProjectTags: function (projectId) {
                var self = this;
                this.workItemInfo.tagList = [];
                this.tmpTagList = [];
                this.allTaglist = [];

                tagCount = 0;
                hQueryProjectTags({'project_uuid' : projectId}, function (data) {
                    self.allTaglist = data.tags.length ? data.tags : [];
                    for (var i = 0; i < self.allTaglist.length; i++) {
                        self.allTaglist[i].checked = false;
                        self.allTaglist[i].sid = i;
                        self.allTaglist[i].isNew = false;
                        if (self.allTaglist[i].color_id) {
                            self.allTaglist[i].color = colorIdMap[self.allTaglist[i].color_id];
                        } else {
                            self.allTaglist[i].color = colorIdMap[8];
                        }
                        self.allTaglist[i].styleObject = {backgroundColor:"#f4f4f4", color:self.allTaglist[i].color, borderColor:self.allTaglist[i].color};
                    }
                    requestDoneFlags.getProjectTags = true;
                    if (isAllRequestDone()) {
                        if (initialRequest) {
                            self.originalWorkItemInfo = JSON.parse(JSON.stringify(self.workItemInfo));
                        }
                        uHideLoadingPage();
                        initialRequest = false;
                    }
                });
            },
            deleteAttachment: function (attachment) {
                for (var i = 0; i < this.attachmentList.length; i++) {
                    if (attachment.content.src == this.attachmentList[i].content.src) {
                        this.attachmentList.splice(i,1);
                        fileCount--;
                        totalSize -= attachment.content.size;
                        break;
                    }
                }
                this.$nextTick(function () {
                    var div = $(".workItem_content")[0];
                    div.scrollTop = div.scrollHeight;
                });
            },
            showAttachment:function (attachment) {
                var tmpAttachmentList = [];
                var index = 0;
                var currentIndex = 0;
                if (attachment.type == "picture") {
                    for(var i = 0; i < this.attachmentList.length; i++) {
                        if (this.attachmentList[i].type == "picture") {
                            if (attachment.content.src == this.attachmentList[i].content.src) {
                                currentIndex = index;
                            }
                            tmpAttachmentList.push({"src": this.attachmentList[i].content.src});
                            index ++;
                        }
                    }
                    uShowAttachment(tmpAttachmentList,currentIndex,"picture");
                } else {
                    tmpAttachmentList.push({"src": attachment.content.src});
                    uShowAttachment(tmpAttachmentList,0,"file");
                }
            },
            addAttachment: function (src, fileSize, duration) {
                var index1=src.lastIndexOf("/");
                var index2=src.lastIndexOf(".");
                var fileName=src.substring(index1+1);
                var showSrc = src.replace(fileName,encodeURIComponent(fileName));

                index1=src.lastIndexOf(".");
                index2=src.length;
                var suffix=src.substring(index1+1,index2).toLowerCase();
                var newAttachment = null;
                if (suffix == "arm" || suffix == "amr") {

                    if (duration) {
                        newAttachment = {type:"voice",content:{time:Math.floor(duration / 1000) + '"',name:fileName,src:src,size:fileSize},isPlaying:false};
                    } else {
                        newAttachment = {type:"voice",content:{time:0,name:fileName,src:src,size:fileSize},isPlaying:false};
                    }
                } else if (suffix == "gif" || suffix == "jpeg" || suffix == "jpg" || suffix == "png"){
                    newAttachment = {type:"picture",content:{name:fileName,src:src,size:fileSize,showSrc:showSrc}};
                } else if (suffix == "3gp" || suffix == "mp4" || suffix == "avi" || suffix == "mkv" || suffix == "flv" || suffix == "wmv" || suffix == "mpg" || suffix == "mov" || suffix == "3gp"){
                    newAttachment = {type:"video",content:{name:fileName,src:src,size:fileSize}};
                } else {
                    if (suffix == "pdf") {
                        showSrc = "../../theme/image/workItem-attachment-pdf.png";
                    } else if (suffix == "ppt" || suffix == "pptx") {
                        showSrc = "../../theme/image/workItem-attachment-ppt.png";
                    } else if (suffix == "rar") {
                        showSrc = "../../theme/image/workItem-attachment-rar.png";
                    } else if (suffix == "txt") {
                        showSrc = "../../theme/image/workItem-attachment-txt.png";
                    } else if (suffix == "doc" || suffix == "docx") {
                        showSrc = "../../theme/image/workItem-attachment-word.png";
                    } else if (suffix == "xls" || suffix == "xlsx") {
                        showSrc = "../../theme/image/workItem-attachment-xlsx.png";
                    } else if (suffix == "xmind") {
                        showSrc = "../../theme/image/workItem-attachment-xmind.png";
                    } else if (suffix == "zip") {
                        showSrc = "../../theme/image/workItem-attachment-zip.png";
                    } else if (suffix == "html") {
                        showSrc = "../../theme/image/workItem-attachment-html.png";
                    } else if (suffix == "xml") {
                        showSrc = "../../theme/image/workItem-attachment-xml.png";
                    } else if (suffix == "log") {
                        showSrc = "../../theme/image/workItem-attachment-log.png";
                    } else {
                        showSrc = "../../theme/image/workItem-attachment-unknown.png";
                    }
                    newAttachment = {type:"file",content:{name:fileName,src:src,showSrc:showSrc,size:fileSize}};
                }
                if (newAttachment) {
                    totalSize += fileSize;
                    fileCount++;
                    this.attachmentList.push(newAttachment);
                    this.$nextTick(function () {
                        var div = $(".workItem_content")[0];
                        div.scrollTop = div.scrollHeight;
                    });
                }
            },
            startPlayingAudio: function (attachment) {

                if (attachment.isPlaying) {
                    uStopPlayingAudio();
                    attachment.isPlaying = false;
                } else {
                    uStopPlayingAudio();
                    for (var i = 0; i < this.attachmentList.length; i++) {
                        if (this.attachmentList[i].isPlaying) {
                            this.attachmentList[i].isPlaying = false;
                        }
                    }
                    uStartPlayingAudio(attachment.content.src);
                    attachment.isPlaying = true;
                }
            },
            getFileFromPhone: function () {
                uGetFileFromPhone();
            },
            takePicture: function () {
                uTakePicture();
            },
            getImageFromAlbum: function () {
                uGetImageFromAlbum();
            },
            voicePlayFinished: function () {
                for (var i = 0; i < this.attachmentList.length; i++) {
                    if (this.attachmentList[i].isPlaying) {
                        this.attachmentList[i].isPlaying = false;
                    }
                }
            },
            jumpPrefix:function(){
                uJumpPrefix(this.workItemInfo.subject);

            },
            changeWorkItemInfoSubject:function(subject){
                console.log("+++++"+subject);
                this.workItemInfo.subject = subject;
            }
        }
    });
    function initialize() {
        uSet("WorkItem0", "0");
    	uSet("WorkItem1", "0");
    	uSet("WorkItem2", "0");
    	uSet("WorkItem3", "0");
    }
};