window.onload = function () {
    var choosedItemKey;
    var vm = new Vue({
        el: '#view-container',
        data: {
            items: [],
            itemList: [],
            queryValue: "",
            searchHint: [],
            indexList: [],
            indexObjectList: [],
            isKeyboardShown: false,
            workItemInfo:"",
            showSearchHint:false,
            userId:""
        },

        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },

        mounted: function () {
            var self = this;
            document.addEventListener('scroll', self.pageScroll, true);
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            self.workItemInfo = JSON.parse(uGet("workItemInfo"));
            self.userId = uGet("user_id");

            this.getUserList();
            choosedItemKey = "assigned_to_id";
            self.searchHint = [stringMap.member_not_found];

            this.$nextTick(function () {
                uShowSelf();
            });

            uSetKeyboardHeightListener(function (height) {
                console.log("workItemList:keyboard height:" + height);
                self.isKeyboardShown = height == "0" ? false: true;
            });
        },

        methods: {
            getUserList: function () {
                var userList;
                var self = this;
                if (uGet("userList") && uGet("userList") != "") {
                    userList = JSON.parse(uGet("userList"));
                    self.setUserList(userList);
                    self.itemList = userList;
                    self.items = self.itemList;
                    self.setIndexList();
                } else {
                    hGetUserListByProjectId({
                        "project_uuid": self.workItemInfo.project.uuid
                    }, function (data) {
                        userList = data.members;
                        self.setUserList(userList);
                        self.itemList = userList;
                        self.items = self.itemList;
                        self.showSearchHint = true;
                        uHideLoadingPage();
                        self.setIndexList();
                    });
                }
            },
            setIndexList: function () {
                var self = this;
                self.$nextTick(function () {
                    if ($("#workItem_memberList")[0].scrollHeight > window.innerHeight) {
                        $("#workItem_memberList")[0].style.height = window.innerHeight - 100 + "px";
                    }

                    for (var i = 0; i < self.items.length; i++) {
                        if (self.items[i].group_name == '#') {
                            self.items[i].top = $("#number_sign").offset().top;
                        } else {
                            self.items[i].top = $("#" + self.items[i].group_name).offset().top;
                        }
                        console.log("self.items[i].top:" + self.items[i].top);
                    }
                    self.indexList = ["#", "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
                    for (var j = 0; j < self.indexList.length; j++) {
                        if (self.indexList[j] == self.items[0].group_name) {
                            self.indexObjectList.push({"name":self.indexList[j], "checked": true});
                        } else {
                            self.indexObjectList.push({"name":self.indexList[j], "checked": false});
                        }
                    }
                });
            },
            setUserList: function (userList) {
                var self = this;
                var tmpAssigner = null;
                for (var i = 0; i < userList.length; i++) {
                    for (var j = 0; j < userList[i].group_members.length; j++) {
                        userList[i].group_members[j].sid = j;
                    }

                    for (var j = 0; j < userList[i].group_members.length; j++) {
                        if (userList[i].group_members[j].id == self.workItemInfo.assigned_to.id) {
                            tmpAssigner = userList[i].group_members[j];
                            break;
                        }
                    }
                }
            },

            scrollToIndex: function (index) {
                console.log("scrollToIndex:" + index);
                for (var i = 0; i < this.items.length; i++) {
                    if (this.items[i].group_name.toUpperCase() == index) {
                        var div = $("#workItem_memberList")[0];
                        div.scrollTop = this.items[i].top - 100;
                        console.log("div.scrollTop:" + div.scrollTop);
                    }
                }
            },
            goBack: function () {
                uSet("atUser","");
                uHideAtSomeone();
            },

            chooseItemFromList: function (item,itemGroup) {
                if (item.user_id == this.userId) {
                    return
                }
                uSet("atUser",JSON.stringify(item));
                uHideAtSomeone();
            },

            search: function () {
                if (this.queryValue != "") {
                    this.items = [];
                    for (var i = 0; i < this.itemList.length; i++) {
                        var tmpGroups = {
                            "group_name":this.itemList[i].group_name,
                            "group_members":[]
                        };
                        for (var j = 0; j < this.itemList[i].group_members.length; j++) {
                            if (this.itemList[i].group_members[j].display_name.toUpperCase().indexOf(this.queryValue.toUpperCase()) == 0) {
                                tmpGroups.group_members.push(this.itemList[i].group_members[j]);
                            }
                        }
                        if (tmpGroups.group_members.length) {
                            this.items.push(tmpGroups);
                        }
                    }
                } else {
                    this.items = this.itemList;
                }
            },
            pageScroll:function() {
                var div = $("#workItem_memberList")[0];
                console.log(div.scrollTop);
                var currentIndex;
                for (var i = 0; i < this.items.length; i++) {
                    if (div.scrollTop >= this.items[i].top - 100) {
                        currentIndex = this.items[i].group_name.toUpperCase();
                    }
                }
                for (var j = 0; j < this.indexObjectList.length; j++) {
                    if (this.indexObjectList[j].name == currentIndex) {
                        this.indexObjectList[j].checked = true;
                        console.log("scroll to:" + currentIndex);
                    } else {
                        this.indexObjectList[j].checked = false;
                    }
                }
            }
        },

        watch: {
            queryValue:function (val,oldVal) {
                this.search();
            }
        }
    });
};
