window.onload = function () {
    var time1 = 0;
    var time2 = 0;
    var vm = new Vue({
        el: '#view-container',
        data: {
            items: [],
            itemList: [],
            queryValue: "",
            searchHint: [],
            indexList: [],
            indexObjectList: [],
            showSearchHint:false,
            showSearchResult: false
        },

        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },

        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });

            self.workItemInfo = JSON.parse(uGet("workItemInfo"));

            self.getParentIssueList();
            self.searchHint = [stringMap.issue_not_found, stringMap.issue_not_found];

            this.$nextTick(function () {
                uShowSelf();
            });
        },

        methods: {
            getParentIssueList: function () {
                var issueList;
                var self = this;
                var parentIssueQueryParam = uGet("parentIssueQueryParam");
                if (parentIssueQueryParam != "") {
                    parentIssueQueryParam = JSON.parse(parentIssueQueryParam);
                    hQueryIssue(parentIssueQueryParam, function (data) {
                        issueList = [];
                        var tmpIssueList = data.issues;
                        for (var i = 0; i < tmpIssueList.length; i++) {
                            if (tmpIssueList[i].id != self.workItemInfo.id)
                            {
                                tmpIssueList[i].sid = i + 1;
                                issueList.push(tmpIssueList[i]);
                            }
                        }
                        if (issueList.length > 0) {
                            issueList.unshift({'subject': '待分配', 'checked': true, 'sid': 0, 'id':0});
                        }

                        self.setList(issueList, self.workItemInfo.parent.id);

                        self.itemList = issueList;
                        self.items = self.itemList;
                        self.showSearchHint = true;
                        uHideLoadingPage();
                    });
                }
            },
            setList: function (list, id) {
                for (var i = 0; i < list.length; i++) {
                    list[i].checked = false;
                    list[i].sid = i;
                    if (list[i].id == id) {
                        list[i].checked = true;
                    }
                    if (list[i].project_uuid == id) {
                        list[i].checked = true;
                    }
                    if (list[i].statusId == id) {
                        list[i].checked = true;
                    }
                }
            },
            goBack: function () {
                uFinishCurrentPage();
            },

            chooseItemFromList: function (item) {
                item.checked = true;
                if (this.workItemInfo.parent.id != item.id) {
                    uSet("choosedItemKey","parent_issue_id");
                    uSet("choosedItem",JSON.stringify(item));
                }
                uFinishCurrentPage();
            },

            search: function () {
                if (this.queryValue != "") {
                    time1 = new Date().getTime();
                    var issueList;
                    var self = this;
                    var parentIssueQueryParam = JSON.parse(uGet("parentIssueQueryParam"));
                    parentIssueQueryParam["subject"] = encodeURIComponent(encodeURIComponent(this.queryValue));
                    hQueryIssueSearch(this.queryValue, parentIssueQueryParam, function (data, functionId) {
                        //判断返回结果是否匹配当前搜索内容
                        if (functionId == "hQueryIssueSearch:" + self.queryValue) {
                            issueList = [];
                            var tmpIssueList = data.issues;
                            for (var i = 0; i < tmpIssueList.length; i++) {
                                if (tmpIssueList[i].id != self.workItemInfo.id)
                                {
                                    tmpIssueList[i].sid = i + 1;
                                    issueList.push(tmpIssueList[i]);
                                }
                            }

                            self.setList(issueList, self.workItemInfo.parent.id);
                            self.items = issueList;
                            self.showSearchResult = true;
                            self.showSearchHint = true;
                        } else {
                            console.log("functionId:" + functionId);
                            console.log("queryValue:" + self.queryValue);
                        }
                    });
                } else {
                    this.showSearchResult = false;
                    this.items = this.itemList;
                }
            }
        },

        watch: {
            queryValue:function (val,oldVal) {
                time2 = new Date().getTime();
                this.search();
            }
        }
    });
};
