window.onload = function () {
    var vm = new Vue({
        el: '#view-container',
        data: {
            items: [],
            itemList: [],
            queryValue: "",
            searchHint: [],
            indexList: [],
            indexObjectList: [],
            showSearchHint:false,
            choosedProjectId: 0,
            operation: ""
        },

        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },

        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });

            self.choosedProjectId = uGet("choosedProject") != "" ? JSON.parse(uGet("choosedProject")).id : 0 ;
            self.operation = uGet("operation");

            this.getProjectList();
            self.searchHint = [stringMap.project_not_found];

            this.$nextTick(function () {
                uShowSelf();
            });
        },

        methods: {
            getProjectList: function () {
                var projectList;
                var self = this;
                var params = {};
                params["query_type"] = "simplify";
                if (self.operation != "filter") {
                    params["type"] = uGet("project_type");
                }
                hGetMyProjects(params, function (data) {
                    projectList = [];
                    if (self.operation == "filter") {
                        projectList[0] = {'name': '不限', 'checked': true, 'sid': 0, 'id':0};
                    }

                    var tmpProjectList = data.projects;
                    for (var i = 0; i < tmpProjectList.length; i++) {
                        tmpProjectList[i].sid = i + 1;
                        projectList.push(tmpProjectList[i]);
                    }

                    if (self.operation == "filter") {
                        self.setList(projectList, self.choosedProjectId);
                    }

                    self.itemList = projectList;
                    self.items = self.itemList;
                    self.showSearchHint = true;
                    uHideLoadingPage();
                });
            },
            setList: function (list, id) {
                for (var i = 0; i < list.length; i++) {
                    list[i].checked = false;
                    list[i].sid = i;
                    if (list[i].id == id) {
                        list[i].checked = true;
                    }
                    if (list[i].project_uuid == id) {
                        list[i].checked = true;
                    }
                    if (list[i].statusId == id) {
                        list[i].checked = true;
                    }
                }
            },
            goBack: function () {
                uFinishCurrentPage();
            },

            chooseItemFromList: function (item) {
                item.checked = true;
                if (this.operation == "filter") {
                    uSet("choosedProject",item.id == 0 ? "" : JSON.stringify(item));
                } else {
                    uSet("toProjectInfo",JSON.stringify(item));
                }
                uFinishCurrentPage();
            },

            search: function () {
                if (this.queryValue != "") {
                    this.items = [];
                    for (var i = 0; i < this.itemList.length; i++) {
                        if (this.itemList[i].name.indexOf(this.queryValue) >= 0) {
                            this.items.push(this.itemList[i]);
                        }
                    }
                } else {
                    this.items = this.itemList;
                }
            }
        },

        watch: {
            queryValue:function (val,oldVal) {
                this.search();
            }
        }
    });
};
