window.onload = function () {
    var optionList = [];
    var originOptionList = "";
    var vm = new Vue({
        el: '#view-container',
        data: {
            items: [],
            itemList: [],
            queryValue: "",
            searchHint: [],
            isKeyboardShown: false,
            workItemInfo:"",
            customFieldKey:"",
            customFieldValue:"",
            customFieldId:"",
            showSearchHint:false
        },

        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            uSetPublicCompleteButtonClickListener(function () {
                self.save();
            });

            self.workItemInfo = JSON.parse(uGet("workItemInfo"));
            self.customFieldKey = uGet("customFieldKey");
            self.customFieldValue = uGet("customFieldValue");

            this.getCustomFields();
            self.searchHint = [stringMap.option_not_found];

            this.$nextTick(function () {
                uShowSelf();
            });

            uSetKeyboardHeightListener(function (height) {
                console.log("workItemList:keyboard height:" + height);
                self.isKeyboardShown = height == "0" ? false: true;
            });
        },

        methods: {
            getCustomFields: function () {
                var customFields;
                var self = this;
                hGetCustomFields({
                    "project_uuid": self.workItemInfo.project.uuid,
                    "tracker_id": self.workItemInfo.type.id
                }, function (data) {
                    customFields = data.customField;
                    for(var i = 0; i < customFields.length; i++) {
                        if (customFields[i].customField == self.customFieldKey) {
                            console.log("options:" + customFields[i].options);
                            var tmpList = customFields[i].options.split(",");
                            for (var j = 0; j < tmpList.length; j++) {
                                optionList.push({"name": tmpList[j]});
                            }
                            self.customFieldId = customFields[i].id;
                            self.setList(optionList, self.customFieldValue);
                            originOptionList = JSON.stringify(optionList);
                            self.itemList = optionList;
                            self.items = self.itemList;
                            self.showSearchHint = true;
                            break;
                        }
                    }
                    uHideLoadingPage();
                });
            },
            setList: function (list, value) {
                var valueList = value.split(",");
                for (var i = 0; i < list.length; i++) {
                    list[i].checked = false;
                    list[i].sid = i;
                    for (var j = 0; j < valueList.length; j++) {
                        if (list[i].name == valueList[j]) {
                            list[i].checked = true;
                        }
                    }
                }
            },
            goBack: function () {
                if (JSON.stringify(this.itemList) != originOptionList) {
                    var customFieldValue = "";
                    for (var i = 0; i < optionList.length; i++) {
                        if (optionList[i].checked) {
                            customFieldValue = customFieldValue + optionList[i].name + ",";
                        }
                    }
                    customFieldValue = customFieldValue.substring(0, customFieldValue.length - 1);
                    uSet("customFieldId",this.customFieldId);
                    uSet("customFieldValue",customFieldValue);
                }
                uFinishCurrentPage();
            },
            save: function () {
                var customFieldValue = "";
                for (var i = 0; i < optionList.length; i++) {
                    if (optionList[i].checked) {
                        customFieldValue = customFieldValue + optionList[i].name + ",";
                    }
                }
                customFieldValue = customFieldValue.substring(0, customFieldValue.length - 1);
                uSet("customFieldId",this.customFieldId);
                uSet("customFieldValue",customFieldValue);
                uFinishCurrentPage();
            },
            chooseItemFromList: function (item) {
                item.checked = !item.checked;
            },

            search: function () {
                if (this.queryValue != "") {
                    this.items = [];
                    for (var i = 0; i < this.itemList.length; i++) {
                        if (this.itemList[i].name.indexOf(this.queryValue) >= 0) {
                            this.items.push(this.itemList[i]);
                        }
                    }
                } else {
                    this.items = this.itemList;
                }
            }
        },

        watch: {
            queryValue:function (val,oldVal) {
                this.search();
            },
            itemList: {
                handler: function (val, oldVal) {
                    console.log("optionList:" + JSON.stringify(this.itemList));
                    console.log("originOptionList:" + originOptionList);
                    if (JSON.stringify(this.itemList) == originOptionList) {
                        uSetSaveButtonClickable("false");
                    } else {
                        uSetSaveButtonClickable("true");
                    }
                },
                deep: true
            }
        }
    });
};
