window.onload = function () {
    var vm = new Vue({
        el: '#view-container',
        data: {
            startDate:"",
            dueDate:"",
            startDatePicker:true,
            iteration:{}
        },

        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            uSetChooseDateFinishedListener(function (date) {
                self.chooseDate(date);
            });
            self.startDate = JSON.parse(uGet("startDate"));
            self.dueDate = JSON.parse(uGet("dueDate"));
            uSet("startDate","");
            uSet("dueDate","");
            this.$nextTick(function () {
                uShowSelf();
            });
        },

        methods: {
            goBack: function () {
                uFinishCurrentPage();
            },
            showDatePicker: function (flag) {
                this.startDatePicker = flag;
                uSetData();
            },
            chooseDate: function (date) {
                //判断日期是否合法
                if (this.startDatePicker) {
                    if (new Date(date).getTime() > new Date(this.dueDate).getTime() && formatDateTime(new Date(date), 'yyyy-MM-dd') != formatDateTime(new Date(this.dueDate), 'yyyy-MM-dd')) {
                        uShowToast(stringMap.date_limit1);
                    } else {
                        this.startDate = new Date(date);
                        uSet("startDate",JSON.stringify(this.startDate));
                    }
                } else {

                    if (new Date(date).getTime() < new Date(this.startDate).getTime() && formatDateTime(new Date(date), 'yyyy-MM-dd') != formatDateTime(new Date(this.startDate), 'yyyy-MM-dd')) {
                        uShowToast(stringMap.date_limit2);
                    }

                    else {
                        this.dueDate = new Date(date);
                        uSet("dueDate",JSON.stringify(this.dueDate));
                    }
                }
            }
        },

        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        }
    });
};
