window.onload = function () {
    var imagesParentElement = null;
    var imagesElememtsParamsForPhotoswipe = [];
    var getImagesElememts = function () {
        var imageElements = imagesParentElement.find('img');
        for (var i = 0; i < imageElements.length; i++) {
            var width = imageElements[i].width;
            var widthScale = width / 2000.0;
            var height = imageElements[i].height;
            var heightScale = height / 1500.0;
            var scale = widthScale < heightScale ? heightScale : widthScale;
            scale = scale > 1 ? scale : 1;
            imagesElememtsParamsForPhotoswipe.push({
                src: imageElements[i].getAttribute("src"),
                w: width / scale,
                h: height / scale
            });
        }
    };

    var customizeImages = function (tmpImagesParentElement) {
        var imageElements = tmpImagesParentElement.find('img');
        for (var i = 0; i < imageElements.length; i++) {
            if (imageElements[i].width > 950) {
                imageElements[i].width = 950;
            }
        }
    };
    var bindImagesFunction = function () {
        imagesParentElement.find('img').on("click", function () {
            openPhotoswipe(this);
        });
    };

    var openPhotoswipe = function (targetElement) {
        var pswpElement = document.querySelectorAll('.pswp')[0];

        var options = {
            index: imagesParentElement.find('img').index(targetElement),
            barsSize: {top: 0, bottom: 0},
            captionEl: false,
            closeEl: false,
            fullscreenEl: false,
            shareEl: false,
            bgOpacity: 0.85,
            maxSpreadZoom: 5,
            tapToClose: true,
            tapToToggleControls: false,
            getThumbBoundsFn: function (index) {
                var thumbnail = targetElement,
                    pageYScroll = window.pageYOffset || document.documentElement.scrollTop,
                    rect = thumbnail.getBoundingClientRect();

                return {x: rect.left, y: rect.top + pageYScroll, w: rect.width};
            }
        };

        var gallery = new PhotoSwipe(pswpElement, PhotoSwipeUI_Default, imagesElememtsParamsForPhotoswipe, options);
        gallery.init();
    };
    var vm = new Vue({
        el: '#view-container',
        data: {
            description:""
        },

        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            self.description = uGet("description");

            self.description= self.description.replace(/<img [^>]*src=['"]([^'"]+)[^>]*>/gi, function (match) {
                return "";
            });
            self.description= self.description.replace(/<img [^>]*>/gi, "");
            self.description = self.description.replace(/<a[^>]*href="([^"]*)"[^>]*>(.*?)<\/a>/g,'$2');

            self.$nextTick(function () {
                uShowSelf();
                if (!imagesParentElement) {
                    imagesParentElement = $('#autoTest_workItem_description');
                    getImagesElememts();
                    customizeImages(imagesParentElement);
                    bindImagesFunction();
                }
            });
        },

        methods: {
            goBack: function () {
                uFinishCurrentPage();
            }
        }
    });
};
