window.onload = function () {
    var choosedItemKey;
    var vm = new Vue({
        el: '#view-container',
        data: {
            hasSearch: false,
            items: [],
            itemList: [],
            queryValue: "",
            searchHint: [],
            isAssignerList: false,
            indexList: [],
            indexObjectList: [],
            isKeyboardShown: false,
            isIterationList: false,
            workItemInfo: "",
            showSearchHint: false
        },

        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },

        mounted: function () {
            var self = this;
            document.addEventListener('scroll', self.pageScroll, true);
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            self.hasSearch = true;
            self.isAssignerList = ((uGet("web_view_fragment_title") == "选择处理人") || (uGet("web_view_fragment_title") == "选择开发人员")
            || (uGet("web_view_fragment_title") == "选择抄送人"));
            self.isIterationList = ((uGet("web_view_fragment_title") == "选择迭代"));
            self.workItemInfo = JSON.parse(uGet("workItemInfo"));

            switch (uGet("web_view_fragment_title")) {
                case '选择处理人':
                    this.getUserList();
                    choosedItemKey = "assigned_to_id";
                    self.searchHint = [stringMap.member_not_found];
                    break;
                case '选择项目':
                    this.getProjectList();
                    choosedItemKey = "project_uuid";
                    self.searchHint = [stringMap.project_not_found];
                    break;
                case '选择迭代':
                    this.getIterationList();
                    choosedItemKey = "iteration_id";
                    self.searchHint = [stringMap.iteration_not_found, stringMap.no_iteration];
                    break;
                case '选择模块':
                    this.getModuleList();
                    choosedItemKey = "module_id";
                    self.searchHint = [stringMap.module_not_found, stringMap.no_module];
                    break;
                case '选择领域':
                    this.getDomainList();
                    choosedItemKey = "domain_id";
                    self.searchHint = [stringMap.domain_not_found, stringMap.no_domain];
                    break;
                case '选择开发人员':
                    choosedItemKey = "developer";
                    this.getUserList();
                    self.searchHint = [stringMap.member_not_found];
                    break;
                case '选择抄送人':
                    choosedItemKey = "assigned_cc";
                    this.getUserList();
                    self.searchHint = [stringMap.member_not_found];
                    break;
            }

            this.$nextTick(function () {
                uShowSelf();
            });

            uSetKeyboardHeightListener(function (height) {
                console.log("workItemList:keyboard height:" + height);
                self.isKeyboardShown = height == "0" ? false : true;
            });
        },

        methods: {
            getUserList: function () {
                var userList;
                var self = this;
                if (uGet("userList") && uGet("userList") != "") {
                    userList = JSON.parse(uGet("userList"));
                    if (choosedItemKey == "developer") {
                        self.addToBeAssigned(userList);
                    }
                    if (choosedItemKey == "assigned_cc") {
                        self.setCCList(userList);
                    } else {
                        self.setUserList(userList);
                    }
                    self.itemList = userList;
                    self.items = self.itemList;
                    self.setIndexList();
                } else {
                    hGetUserListByProjectId({
                        "project_uuid": self.workItemInfo.project.uuid
                    }, function (data) {
                        userList = data.members;
                        uSet("userList", JSON.stringify(userList));
                        if (choosedItemKey == "developer") {
                            self.addToBeAssigned(userList);
                        }
                        if (choosedItemKey == "assigned_cc") {
                            self.setCCList(userList);
                        } else {
                            self.setUserList(userList);
                        }
                        self.itemList = userList;
                        self.items = self.itemList;
                        self.showSearchHint = true;
                        uHideLoadingPage();
                        self.setIndexList();
                    });
                }
            },
            setIndexList: function () {
                var self = this;
                self.$nextTick(function () {
                    if ($("#workItem_memberList")[0].scrollHeight > window.innerHeight) {
                        $("#workItem_memberList")[0].style.height = window.innerHeight - 100 + "px";
                    }

                    for (var i = 0; i < self.items.length; i++) {
                        if (self.items[i].group_name == '#') {
                            self.items[i].top = $("#number_sign").offset().top;
                        } else {
                            self.items[i].top = $("#" + self.items[i].group_name).offset().top;
                        }
                        console.log("self.items[i].top:" + self.items[i].top);
                    }
                    self.indexList = ["#", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"];
                    for (var j = 0; j < self.indexList.length; j++) {
                        if (self.indexList[j] == self.items[0].group_name) {
                            self.indexObjectList.push({"name": self.indexList[j], "checked": true});
                        } else {
                            self.indexObjectList.push({"name": self.indexList[j], "checked": false});
                        }
                    }
                });
            },
            setCCList: function (userList) {
                console.log("setCCList");
                var self = this;
                var ccList = self.workItemInfo.assignedccUser;
                console.log(JSON.stringify(ccList));
                for (var i = 0; i < userList.length; i++) {
                    for (var j = 0; j < userList[i].group_members.length; j++) {
                        userList[i].group_members[j].checked = false;
                        userList[i].group_members[j].sid = j;
                    }

                    for (var j = 0; j < userList[i].group_members.length; j++) {
                        for (var k = 0; k < ccList.length; k++) {
                            if (userList[i].group_members[j].id == ccList[k].id) {
                                userList[i].group_members[j].checked = true;
                            }
                        }
                    }
                }
            },
            addToBeAssigned: function (userList) {
                var hasGroup = false;
                for (var i = 0; i < userList.length; i++) {
                    if (userList[i].group_name == "#") {
                        userList[i].group_members.unshift({"display_name": "待分配", "id": -1});
                        hasGroup = true;
                        break;
                    }
                }
                if (!hasGroup) {
                    userList.unshift({"group_name": "#", "group_members": [{"display_name": "待分配", "id": -1}]})
                }
            },
            setUserList: function (userList) {
                var self = this;
                var tmpAssigner = null;
                var checkedI = -1;
                var checkedJ = -1;
                var currentId;
                if ((uGet("web_view_fragment_title") ) == "选择开发人员") {
                    currentId = self.workItemInfo.developer.id;
                } else {
                    currentId = self.workItemInfo.assigned_to.id;
                }
                for (var i = 0; i < userList.length; i++) {
                    for (var j = 0; j < userList[i].group_members.length; j++) {
                        userList[i].group_members[j].checked = false;
                        userList[i].group_members[j].sid = j;
                    }

                    for (var j = 0; j < userList[i].group_members.length; j++) {
                        if (userList[i].group_members[j].id == currentId) {
                            tmpAssigner = userList[i].group_members[j];
                            checkedI = i;
                            checkedJ = j;
                            break;
                        }
                    }
                }
                if (tmpAssigner != null) {
                    userList[checkedI].group_members[checkedJ].checked = true;
                } else {
                    if (choosedItemKey == "developer") {
                        userList[0].group_members[0].checked = true;
                    }
                }
            },
            getDomainList: function () {
                var domainList;
                var self = this;
                if (uGet("domainList") && uGet("domainList") != "") {
                    domainList = JSON.parse(uGet("domainList"));
                    self.setList(domainList, self.workItemInfo.domain.id ? self.workItemInfo.domain.id : -1);
                    self.itemList = domainList;
                    self.items = self.itemList;
                } else {
                    hGetDomain({
                        "project_uuid": self.workItemInfo.project.uuid
                    }, function (data) {
                        domainList = [];
                        if (data.domains.length > 0) {
                            domainList[0] = {'name': '待分配', 'checked': true, 'sid': 0, 'id': -1};
                            var tmpDomainList = data.domains;
                            for (var i = 0; i < tmpDomainList.length; i++) {
                                tmpDomainList[i].sid = i + 1;
                                domainList.push(tmpDomainList[i]);
                            }
                            uSet("domainList", JSON.stringify(domainList));
                            self.setList(domainList, self.workItemInfo.domain && self.workItemInfo.domain.id ? self.workItemInfo.domain.id : -1);
                            self.itemList = domainList;
                            self.items = self.itemList;
                            self.showSearchHint = true;
                            uHideLoadingPage();
                        } else {
                            self.itemList = domainList;
                            self.items = self.itemList;
                            self.showSearchHint = true;
                            uHideLoadingPage();
                        }
                    });
                }
            },
            getModuleList: function () {
                var moduleList;
                var self = this;
                if (uGet("moduleList") && uGet("moduleList") != "") {
                    moduleList = JSON.parse(uGet("moduleList"));
                    self.setList(moduleList, self.workItemInfo.module.id ? self.workItemInfo.module.id : -1);
                    self.itemList = moduleList;
                    self.items = self.itemList;
                } else {
                    hGetModule({
                        "project_uuid": self.workItemInfo.project.uuid
                    }, function (data) {
                        moduleList = [];
                        if (data.modules.length > 0) {
                            moduleList[0] = {'name': '待分配', 'checked': true, 'sid': 0, 'id': -1};
                            var tmpModuleList = data.modules;
                            for (var i = 0; i < tmpModuleList.length; i++) {
                                tmpModuleList[i].sid = i + 1;
                                moduleList.push(tmpModuleList[i]);
                            }
                            uSet("moduleList", JSON.stringify(moduleList));
                            self.setList(moduleList, self.workItemInfo.module && self.workItemInfo.module.id ? self.workItemInfo.module.id : -1);
                            self.itemList = moduleList;
                            self.items = self.itemList;
                            if (uGet("userList") && uGet("userList") != "") {
                                self.searchHint = true;
                                uHideLoadingPage();
                            } else {
                                hGetUserListByProjectId({
                                    "project_uuid": self.workItemInfo.project.uuid
                                }, function (data) {
                                    uSet("userList", JSON.stringify(data.members));
                                    self.showSearchHint = true;
                                    uHideLoadingPage();
                                });
                            }
                        } else {
                            self.itemList = moduleList;
                            self.items = self.itemList;
                            self.showSearchHint = true;
                            uHideLoadingPage();
                        }
                    });
                }
            },
            getIterationList: function () {
                var iterationList;
                var self = this;
                if (uGet("iterationList") && uGet("iterationList") != "") {
                    iterationList = JSON.parse(uGet("iterationList"));
                    self.setList(iterationList, self.workItemInfo.iteration.id ? self.workItemInfo.iteration.id : -1);
                    self.itemList = iterationList;
                    self.items = self.itemList;
                } else {
                    hGetMilestone({
                        "project_uuid": self.workItemInfo.project.uuid
                    }, function (data) {
                        iterationList = [];
                        if (data.iterations.length > 0) {
                            iterationList[0] = {'name': '待分配', 'checked': true, 'sid': 0, 'id': -1};
                            var tmpIterationList = data.iterations;
                            for (var i = 0; i < tmpIterationList.length; i++) {
                                tmpIterationList[i].sid = i + 1;
                                iterationList.push(tmpIterationList[i]);
                            }
                            uSet("iterationList", JSON.stringify(iterationList));
                            self.setList(iterationList, self.workItemInfo.iteration && self.workItemInfo.iteration.id ? self.workItemInfo.iteration.id : -1);
                            self.itemList = iterationList;
                            self.items = self.itemList;
                            self.showSearchHint = true;
                            uHideLoadingPage();
                        } else {
                            self.itemList = iterationList;
                            self.items = self.itemList;
                            self.showSearchHint = true;
                            uHideLoadingPage();
                        }
                    });
                }
            },
            getProjectList: function () {
                var projectList;
                var self = this;
                hGetMyProjects({
                    "query_type": "simplify"
                }, function (data) {
                    projectList = data.projects;
                    uSet("projectList", JSON.stringify(projectList));
                    self.setList(projectList, self.workItemInfo.project.id);
                    self.itemList = projectList;
                    self.items = self.itemList;
                    self.showSearchHint = true;
                    uHideLoadingPage();
                });
            },
            setList: function (list, id) {
                for (var i = 0; i < list.length; i++) {
                    list[i].checked = false;
                    list[i].sid = i;
                    if (list[i].id == id) {
                        list[i].checked = true;
                    }
                    if (list[i].project_uuid == id) {
                        list[i].checked = true;
                    }
                    if (list[i].statusId == id) {
                        list[i].checked = true;
                    }
                }
            },
            scrollToIndex: function (index) {
                console.log("scrollToIndex:" + index);
                for (var i = 0; i < this.items.length; i++) {
                    if (this.items[i].group_name.toUpperCase() == index) {
                        var div = $("#workItem_memberList")[0];
                        div.scrollTop = this.items[i].top - 100;
                        console.log("div.scrollTop:" + div.scrollTop);
                    }
                }
            },
            goBack: function () {
                if (choosedItemKey != "assigned_cc") {
                    uFinishCurrentPage();
                } else {
                    var assigned_cc = "";
                    var assignedList = [];
                    for (var i = 0; i < this.itemList.length; i++) {
                        for (var j = 0; j < this.itemList[i].group_members.length; j++) {
                            if (this.itemList[i].group_members[j].checked) {
                                assigned_cc = assigned_cc + this.itemList[i].group_members[j].user_id + ",";
                                assignedList.push(this.itemList[i].group_members[j]);
                            }
                        }
                    }
                    assigned_cc = assigned_cc.substring(0, assigned_cc.length - 1);
                    console.log("assigned_cc:" + assigned_cc);
                    console.log("assignedList:" + JSON.stringify(assignedList));
                    uSet("choosedItemKey", choosedItemKey);
                    uSet("choosedItem",JSON.stringify(assignedList));
                    uFinishCurrentPage();
                }
            },

            chooseItemFromList: function (item, itemGroup) {
                if (choosedItemKey != "assigned_cc") {
                    uSet("choosedItemKey", choosedItemKey);
                    item.checked = true;
                    switch (choosedItemKey) {
                        case "assigned_to_id":
                            if (this.workItemInfo.assigned_to.id != item.id) {
                                uSet("choosedItem", JSON.stringify(item));
                            }
                            break;
                        case "project_uuid":
                            if (this.workItemInfo.project.id != item.id) {
                                uSet("choosedItem", JSON.stringify(item));
                            }
                            break;
                        case "iteration_id":
                            if (this.workItemInfo.iteration && this.workItemInfo.iteration.id != item.id) {
                                if (!(this.workItemInfo.iteration.id == 0 && item.id == -1)) {
                                    uSet("choosedItem", JSON.stringify(item));
                                }
                            } else if (!this.workItemInfo.iteration) {
                                if (item.id != -1) {
                                    uSet("choosedItem", JSON.stringify(item));
                                }
                            }
                            break;
                        case "module_id":
                            if (this.workItemInfo.module && this.workItemInfo.module.id != item.id) {
                                if (!(this.workItemInfo.module.id == 0 && item.id == -1)) {
                                    uSet("choosedItem", JSON.stringify(item));
                                }
                            } else if (!this.workItemInfo.module) {
                                if (item.id != -1) {
                                    uSet("choosedItem", JSON.stringify(item));
                                }
                            }
                            break;
                        case "domain_id":
                            if (this.workItemInfo.domain && this.workItemInfo.domain.id != item.id) {
                                if (!(this.workItemInfo.domain.id == 0 && item.id == -1)) {
                                    uSet("choosedItem", JSON.stringify(item));
                                }
                            } else if (!this.workItemInfo.domain) {
                                if (item.id != -1) {
                                    uSet("choosedItem", JSON.stringify(item));
                                }
                            }
                            break;
                        case "developer":
                            if (this.workItemInfo.developer.id != item.id) {
                                uSet("choosedItem", JSON.stringify(item));
                            }
                            break;
                    }
                    uFinishCurrentPage();
                } else {
                    item.checked = !item.checked;
                }
            },

            search: function () {
                if (this.queryValue != "") {
                    if (!this.isAssignerList) {
                        this.items = [];
                        for (var i = 0; i < this.itemList.length; i++) {
                            if (this.itemList[i].name.indexOf(this.queryValue) >= 0) {
                                this.items.push(this.itemList[i]);
                            }
                        }
                    } else {
                        this.items = [];

                        for (var i = 0; i < this.itemList.length; i++) {
                            var tmpGroups = {
                                "group_name": this.itemList[i].group_name,
                                "group_members": []
                            };
                            for (var j = 0; j < this.itemList[i].group_members.length; j++) {
                                if (this.itemList[i].group_members[j].display_name.toUpperCase().indexOf(this.queryValue.toUpperCase()) == 0) {
                                    tmpGroups.group_members.push(this.itemList[i].group_members[j]);
                                }
                            }
                            if (tmpGroups.group_members.length) {
                                this.items.push(tmpGroups);
                            }
                        }
                    }
                } else {
                    this.items = this.itemList;
                }
            },
            pageScroll: function () {
                var div = $("#workItem_memberList")[0];
                console.log(div.scrollTop);
                var currentIndex;
                for (var i = 0; i < this.items.length; i++) {
                    if (div.scrollTop >= this.items[i].top - 100) {
                        currentIndex = this.items[i].group_name.toUpperCase();
                    }
                }
                for (var j = 0; j < this.indexObjectList.length; j++) {
                    if (this.indexObjectList[j].name == currentIndex) {
                        this.indexObjectList[j].checked = true;
                        console.log("scroll to:" + currentIndex);
                    } else {
                        this.indexObjectList[j].checked = false;
                    }
                }
            }
        },

        watch: {
            queryValue: function (val, oldVal) {
                this.search();
            }
        }
    });
};
