window.onload = function () {
    var tmpAllTagList = [];
    var tagCount = 0;
    var TITLE_PATTERN = /^[a-zA-Z0-9\u4E00-\u9FA5\s\^\-_*&`~\\/|;；:：{},!@#$&().'\&quot;\[\]<>?·！（）——、‘“”？—。，《》%【】\\+]+$/;
    var vm = new Vue({
        el: '#view-container',
        data: {
            tagColor:"#48cfad",
            allTaglist: [],
            tmpNewTag: "",
            workItemInfo:""
        },

        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            uSetTagColorSelectedListener(function (color) {
                self.changeTagColor(color);
            });
            self.tagColor = JSON.parse(uGet("tagColor"));
            self.workItemInfo = JSON.parse(uGet("workItemInfo"));
            self.allTaglist = JSON.parse(uGet("allTaglist"));
            tmpAllTagList = self.allTaglist;

            if (uGet("queryProjectTags") && uGet("queryProjectTags") == "true") {
                self.$nextTick(function () {
                    uShowSelf();
                });
            } else {
                self.getProjectTagList();
            }

            tagCount = self.workItemInfo.tagList.length;
            uSet("tagColor","");
            uSet("allTaglist","");
        },
        computed: {
            // a computed getter
            trimedTmpNewTag: function () {
                // `this` points to the vm instance
                return this.tmpNewTag.replace(/(^\s*)|(\s*$)/g, "")
            }
        },
        methods: {
            getProjectTagList: function () {
                var self = this;
                uShowLoadingPage();
                hQueryProjectTags({'project_uuid' : self.workItemInfo.project.uuid}, function (data) {
                    self.allTaglist = data.tags;
                    for (var i = 0; i < self.allTaglist.length; i++) {
                        self.allTaglist[i].checked = false;
                        self.allTaglist[i].sid = i;
                        self.allTaglist[i].isNew = false;
                        if (self.allTaglist[i].color_id) {
                            self.allTaglist[i].color = colorIdMap[self.allTaglist[i].color_id];
                        } else {
                            self.allTaglist[i].color = colorIdMap[8];
                        }

                        self.allTaglist[i].styleObject = {backgroundColor:"#f4f4f4", color:self.allTaglist[i].color, borderColor:self.allTaglist[i].color};

                        for (var j = 0; j < self.workItemInfo.tagList.length; j++) {
                            if (self.workItemInfo.tagList[j].id == self.allTaglist[i].id) {
                                self.allTaglist[i].checked = true;
                                self.allTaglist[i].styleObject = {backgroundColor:self.allTaglist[i].color, color:"#FFFFFF", borderColor:self.allTaglist[i].color};
                            }
                        }
                    }
                    tmpAllTagList = self.allTaglist;
                    uHideLoadingPage();
                    uSet("queryProjectTags","true");
                    self.$nextTick(function () {
                        uShowSelf();
                    });
                });
            },
            goBack: function () {
                uSet("allTaglist",JSON.stringify(this.allTaglist));
                uFinishCurrentPage();
            },
            showTagColorDialog :function () {
                uShowTagColorDialog(this.tagColor);
            },
            changeTagColor: function (color) {
                color= "#" + color.substring(3,color.length);
                this.tagColor = color;
                uSet("tagColor",JSON.stringify(this.tagColor));
            },
            addNewTag: function () {
                this.tmpNewTag = this.tmpNewTag.replace(/(^\s*)|(\s*$)/g, "");
                if(this.tmpNewTag == "") {
                    return;
                }
                if (tagCount >= 10) {
                    uShowToast(stringMap.tag_limit1);
                    return;
                }
                for (var i = 0; i < this.allTaglist.length; i++) {
                    if (this.allTaglist[i].name == this.tmpNewTag) {
                        uShowToast(stringMap.tag_limit2);
                        return;
                    }
                }
                if (!(this.tmpNewTag.match(TITLE_PATTERN))) {
                    uShowToast(stringMap.tag_limit3);
                    return;
                }
                if ( this.tmpNewTag.length > 25) {
                    uShowToast(stringMap.tag_limit4);
                    return;
                }
                var newTag = {"name": this.tmpNewTag, "isNew":true, "checked": true, "sid": this.allTaglist.length,color: this.tagColor, "styleObject": {backgroundColor:this.tagColor, color:"#FFFFFF", borderColor:this.tagColor}};
                this.allTaglist.push(newTag);
                tagCount++;
                this.tmpNewTag = "";
            },
            deleteTag: function (sid) {
                if (this.allTaglist[sid].checked) {
                    tagCount--;
                }
                this.allTaglist.splice(sid,1);
                for (var i = 0; i < this.allTaglist.length; i++) {
                    this.allTaglist[i].sid = i;
                }
            },
            chooseTag: function (sid) {
                if (!tmpAllTagList[sid].checked) {
                    if (tagCount >= 10) {
                        uShowToast(stringMap.tag_limit1);
                        return;
                    }
                    tagCount++;
                } else {
                    tagCount--;
                }
                tmpAllTagList[sid].checked = !tmpAllTagList[sid].checked;
                if(!tmpAllTagList[sid].checked) {
                    tmpAllTagList[sid].styleObject = {backgroundColor:"#f4f4f4", color:tmpAllTagList[sid].color, borderColor:tmpAllTagList[sid].color};
                } else {
                    tmpAllTagList[sid].styleObject = {backgroundColor:tmpAllTagList[sid].color, color:"#FFFFFF", borderColor:tmpAllTagList[sid].color};
                }

                Vue.set(this.allTaglist, sid, tmpAllTagList[sid]);
            }
        }
    });
};
