window.onload = function () {
    var vm = new Vue({
        el: '#view-container',
        data: {
            hasSearch: false,
            items: [],
            itemList: [],
            queryValue: "",
            searchHint: [],
            isAssignerList: false,
            indexList: [],
            indexObjectList: [],
            isKeyboardShown: false,
            isIterationList: false
        },

        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },

        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            self.hasSearch = (uGet("hasSearch") == "true") ? true : false;
            self.isAssignerList = ((uGet("web_view_fragment_title") == "选择处理人")) ? true : false;
            self.isIterationList = ((uGet("web_view_fragment_title") == "选择迭代")) ? true : false;
            self.itemList = JSON.parse(uGet("itemList"));
            if (self.hasSearch) {
                self.searchHint = JSON.parse(uGet("searchHint"));
            }
            if ((uGet("web_view_fragment_title") == "选择领域")) {
                self.searchHint = JSON.parse(uGet("searchHint"));
            }
            self.items = self.itemList;
            document.addEventListener('scroll', self.pageScroll, true);

            this.$nextTick(function () {
                uShowSelf();

                if (self.isAssignerList) {
                    if ($("#workItem_memberList")[0].scrollHeight > window.innerHeight) {
                        $("#workItem_memberList")[0].style.height = window.innerHeight - 100 + "px";
                    }

                    for (var i = 0; i < self.items.length; i++) {
                        if (self.items[i].group_name == '#') {
                            self.items[i].top = $("#number_sign").offset().top;
                        } else {
                            self.items[i].top = $("#" + self.items[i].group_name).offset().top;
                        }
                    }
                    currentUserInfo = JSON.parse(uGet("choosedItem"));
                    console.log(currentUserInfo);
                    console.log(uGet("choosedItem"));
                    console.log(self.items);
                    console.log(JSON.stringify(self.items));
                    for (var i = 0; i < self.items.length; i++) {
                        for (var j = 0; j < self.items[i].group_members.length; j++) {
                            self.items[i].group_members[j].checked = false;
                            self.items[i].group_members[j].sid = j;
                            if (currentUserInfo.ownerid) {
                                id = currentUserInfo.ownerid;
                            } else {
                                id = currentUserInfo.id;
                            }
                            if (self.items[i].group_members[j].id == id) {
                                self.items[i].group_members[j].checked = true;
                                console.log(JSON.stringify(currentUserInfo));
                            }
                        }
                    }
                    self.indexList = ["#", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"];

                    for (var j = 0; j < self.indexList.length; j++) {
                        if (self.indexList[j] == self.items[0].group_name) {
                            self.indexObjectList.push({"name": self.indexList[j], "checked": true});
                        } else {
                            self.indexObjectList.push({"name": self.indexList[j], "checked": false});
                        }
                    }
                }
            });

            uSetKeyboardHeightListener(function (height) {
                console.log("workItemList:keyboard height:" + height);
                self.isKeyboardShown = height == "0" ? false : true;
            });

        },

        methods: {
            scrollToIndex: function (index) {
                console.log("scrollToIndex:" + index);
                for (var i = 0; i < this.items.length; i++) {
                    if (this.items[i].group_name.toUpperCase() == index) {
                        var div = $("#workItem_memberList")[0];
                        div.scrollTop = this.items[i].top - 100;
                    }
                }
            },
            goBack: function () {
                uFinishCurrentPage();
            },

            chooseItemFromList: function (item, itemGroup) {
                item.checked = true;
                uSet("choosedItem", JSON.stringify(item));
                uSet("choosedItemGroup", JSON.stringify(itemGroup));
                uFinishCurrentPage();
            },

            search: function () {
                if (this.queryValue != "") {
                    if (!this.isAssignerList) {
                        this.items = [];
                        for (var i = 0; i < this.itemList.length; i++) {
                            if (this.itemList[i].name.indexOf(this.queryValue) >= 0) {
                                this.items.push(this.itemList[i]);
                            }
                        }
                    } else {
                        this.items = [];

                        for (var i = 0; i < this.itemList.length; i++) {
                            var tmpGroups = {
                                "group_name": this.itemList[i].group_name,
                                "group_members": []
                            };
                            for (var j = 0; j < this.itemList[i].group_members.length; j++) {
                                if ((this.itemList[i].group_members[j].display_name.toUpperCase()).indexOf(this.queryValue.toUpperCase()) == 0) {
                                    tmpGroups.group_members.push(this.itemList[i].group_members[j]);
                                }
                            }
                            if (tmpGroups.group_members.length) {
                                this.items.push(tmpGroups);
                            }
                        }
                    }
                } else {
                    this.items = this.itemList;
                }
            },

            pageScroll: function () {
                var div = $("#workItem_memberList")[0];
                console.log(div.scrollTop);
                var currentIndex;
                for (var i = 0; i < this.items.length; i++) {
                    if (div.scrollTop >= this.items[i].top - 100) {
                        currentIndex = this.items[i].group_name.toUpperCase();
                    }
                }
                for (var j = 0; j < this.indexObjectList.length; j++) {
                    if (this.indexObjectList[j].name == currentIndex) {
                        this.indexObjectList[j].checked = true;
                        console.log("scroll to:" + currentIndex);
                    } else {
                        this.indexObjectList[j].checked = false;
                    }
                }
            }
        },

        watch: {
            queryValue: function (val, oldVal) {
                this.search();
            }
        }
    });
};
