window.onload = function () {

    var uniqueProjectUuid = "a451e2f5fcb34f88b39a2da106333234";
    var typeList_normal = [
        {'name': '需求', 'checked': false, 'id': '1', 'sid': 0},
        {'name': '任务', 'checked': false, 'id': '2', 'sid': 1},
        {'name': '缺陷', 'checked': true, 'id': '3', 'sid': 2}
    ];
    var typeList_scrum = [
        {'name': 'Bug', 'checked': false, 'id': '3', 'sid': 0},
        {'name': 'Feature', 'checked': false, 'id': '6', 'sid': 1},
        {'name': 'Story', 'checked': true, 'id': '7', 'sid': 2}
    ];
    var current_type_list = typeList_normal;
    var last_type_list = uGet("type");
    var last_project_list = uGet("project");
    var last_finishtime_list = uGet("finishTime");
    var last_currentuser_list = uGet("currentUser");

    var vm = new Vue({
        el: '#view-container',
        data: {
            hasSearchInput: false,
            items: [],
            itemList: [],
            queryValue: "",
            searchHint: [],
            isAssignerList: false,
            indexList:[],
            indexObjectList: [],
            isKeyboardShown: false,
            isIterationList: false
        },

        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },

        mounted: function () {
            var self = this;
            uniqueProjectUuid = uGet("uniqueProjectUuid");
            console.log("——————————");
            document.addEventListener('scroll', self.pageScroll, true);

            self.hasSearchInput = (uGet("hasSearchInput") == "true") ? true : false;
            self.isAssignerList = ((uGet("entry_page") == "personliable")) ? true : false;
            self.isIterationList = ((uGet("entry_page") == "选择迭代")) ? true : false;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            this.$nextTick(function () {
                uShowSelf();

            });
            console.log(self.isAssignerList);
            console.log(uGet("entry_page"));
            switch (uGet("entry_page")) {
                case "project":
                    uShowLoadingPage();
                    self.getMyProjects();
                    break;
                case "type":
                    self.items = current_type_list;

                    if (last_project_list && last_project_list != "" && JSON.parse(last_project_list)) {
                        console.log("__________" + last_type_list);
                        typeList = (JSON.parse(last_project_list).type == "normal") ? typeList_normal : typeList_scrum;
                        self.items = typeList;
                        self.setList(self.items, JSON.parse(last_type_list).id);
                    } else {
                        console.log("__________");
                        if (last_type_list && last_type_list != "" && JSON.parse(last_type_list)) {
                            self.setList(self.items, JSON.parse(last_type_list).id);
                        } else {
                            self.items = current_type_list;
                        }
                    }
                    break;
                case "finishtime":
                    break
                case "personliable":
                    if (last_project_list && last_type_list != "") {
                        uShowLoadingPage();

                        self.getCurrentUserinfo(JSON.parse(last_project_list), false);

                    }
                    break;
            }
        },

        methods: {
            scrollToIndex: function (index) {
               var self = this;
                console.log("scrollToIndex:" + index);
                console.log(JSON.stringify(self.items));
                for (var i = 0; i < self.items.length; i++) {
                    if (self.items[i].group_name.toUpperCase() == index) {
                        var div = $("#workItem_memberList")[0];
                        div.scrollTop = self.items[i].top - 100;
                        console.log(self.items[i].top - 100);
                    }
                }
            },
            goBack: function () {
                uFinishCurrentPage();
            },
            getMyProjects: function () {
                var self = this;
                hGetMyProjects({
                    "query_type": "simplify"
                }, function (data) {
                    projectList = data.projects;
                    for (var i = 0; i < projectList.length; i++) {
                        if (projectList[i].project_uuid == uniqueProjectUuid) {
                            projectList[i].checked = true;
                        } else {
                            projectList[i].checked = false;
                        }
                    }
                    self.items = projectList;
                    self.itemList = self.items;
                    uHideLoadingPage();
                });
            },
            getUserListByProjectId: function (projectItem, closePage) {
                var self = this;
                hGetUserListByProjectId({
                    "project_uuid": projectItem.project_uuid
                }, function (data) {
                    userList = data.members;
                    console.log(userList);
                    console.log(JSON.stringify(userList));
                    console.log(JSON.stringify(currentUserInfo));

                    self.items = userList;
                    uHideLoadingPage();
                    if (currentUserInfo.user_name && currentUserInfo.user_name != "") {
                        for (var i = 0; i < userList.length; i++) {
                            for (var j = 0; j < userList[i].group_members.length; j++) {
                                userList[i].group_members[j].checked = false;
                                userList[i].group_members[j].sid = j;
                                if (userList[i].group_members[j].name == currentUserInfo.user_name) {
                                    userList[i].group_members[j].checked = true;
                                    currentUserInfo = userList[i].group_members[j];
                                    console.log(JSON.stringify(currentUserInfo));
                                }
                            }
                        }
                    } else {
                        for (var i = 0; i < userList.length; i++) {
                            for (var j = 0; j < userList[i].group_members.length; j++) {
                                userList[i].group_members[j].checked = false;
                                for (var j = 0; j < userList[i].group_members.length; j++) {
                                    userList[i].group_members[j].checked = false;
                                    userList[i].group_members[j].sid = j;
                                    if (userList[i].group_members[j].user_id == currentUserInfo.user_id) {
                                        userList[i].group_members[j].checked = true;
                                        console.log(JSON.stringify(userList[i].group_members[j]));
                                    }
                                }
                            }
                        }
                    }


                    self.items = userList;
                    self.itemList = self.items;

                    self.$nextTick(function () {
                        if ($("#workItem_memberList")[0].scrollHeight > window.innerHeight) {
                            $("#workItem_memberList")[0].style.height = window.innerHeight - 100 + "px";
                        }
                        
                        for (var i = 0; i < self.items.length; i++) {
                            if (self.items[i].group_name == '#') {
                                self.items[i].top = $("#number_sign").offset().top;
                            } else {
                                self.items[i].top = $("#" + self.items[i].group_name).offset().top;
                            }
                        }
                        self.indexList = ["#", "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];

                        for (var j = 0; j < self.indexList.length; j++) {
                            if (self.indexList[j] == self.items[0].group_name) {
                                self.indexObjectList.push({"name":self.indexList[j], "checked": true});
                            } else {
                                self.indexObjectList.push({"name":self.indexList[j], "checked": false});
                            }
                        }
                    });
                    if (closePage) {
                        projectItem.checked = true;
                        uSet("currentUser",JSON.stringify(currentUserInfo));
                        console.log(JSON.stringify(currentUserInfo));
                        uFinishCurrentPage();
                    }
                });
            },
            getCurrentUserinfo: function (projectitem, closePage) {
                self = this;
                hGetCurrentUserInfo({}, function (data) {
                    console.log(JSON.stringify(data));
                    if (last_currentuser_list && last_currentuser_list != "") {
                        currentUserInfo = JSON.parse(last_currentuser_list);
                    } else {
                        currentUserInfo = data;

                    }
                    console.log(JSON.stringify(currentUserInfo));
                    console.log(JSON.stringify(projectitem));
                    console.log(closePage);
                    if (closePage) {
                        currentUserInfo = data;
                        uSet(JSON.stringify(currentUserInfo));
                    }
                    if (projectitem) {
                        self.getUserListByProjectId(projectitem, closePage);
                    }
                });
            },
            chooseItemFromList: function (item, itemGroup) {
                self = this;
                uSet("choosedItemGroup", JSON.stringify(itemGroup));
                console.log("________" + JSON.stringify(itemGroup))
                switch (uGet("entry_page")) {
                    case "project":
                        uSet("project", JSON.stringify(item));
                        console.log(JSON.stringify(item));
                        typeList = (item.type == "normal") ? typeList_normal : typeList_scrum;
                        chooseTypeList = (item.type == "normal") ? typeList[2] : typeList[2];
                        uSet("type", JSON.stringify(chooseTypeList));
                        uShowLoadingPage();
                        self.getCurrentUserinfo(item, true);
                        break;
                    case "type":
                        item.checked = true;
                        uSet("type", JSON.stringify(item));
                        console.log(JSON.stringify(item));
                        console.log("+++++++++");
                        uFinishCurrentPage();
                        break;
                    case "finishtime":
                        break
                    case "personliable":
                        uSet("currentUser", JSON.stringify(item));
                        uFinishCurrentPage();
                        break;
                }
            },
            setList: function (list, id) {
                self = this;
                console.log(JSON.stringify(list));
                console.log(id);
                for (var i = 0; i < list.length; i++) {
                    list[i].checked = false;
                    list[i].sid = i;
                    if (list[i].id == id) {
                        list[i].checked = true;
                    }
                    if (list[i].project_uuid == id) {
                        list[i].checked = true;
                    }
                }
                self.items = list;
                console.log(JSON.stringify(self.items));
            },
            search: function () {
                if (this.queryValue != "") {
                    console.log(this.isAssignerList+"————————");
                    console.log(JSON.stringify(this.items));
                    if (!this.isAssignerList) {
                        this.items = [];
                        console.log(this.queryValue+"————————");
                        for (var i = 0; i < this.itemList.length; i++) {
                            if (this.itemList[i].name.indexOf(this.queryValue) >= 0) {
                                this.items.push(this.itemList[i]);
                            }
                        }
                    } else {
                        this.items = [];

                        for (var i = 0; i < this.itemList.length; i++) {
                            var tmpGroups = {
                                "group_name":this.itemList[i].group_name,
                                "group_members":[]
                            };
                            for (var j = 0; j < this.itemList[i].group_members.length; j++) {
                                if (this.itemList[i].group_members[j].display_name.toUpperCase().indexOf(this.queryValue.toUpperCase()) == 0) {
                                    tmpGroups.group_members.push(this.itemList[i].group_members[j]);
                                }
                            }
                            if (tmpGroups.group_members.length) {
                                this.items.push(tmpGroups);
                            }
                        }
                    }
                } else {
                    this.items = this.itemList;
                }
            },
            pageScroll:function() {
                var div = $("#workItem_memberList")[0];
                console.log(div.scrollTop);
                var currentIndex;
                for (var i = 0; i < this.items.length; i++) {
                    if (div.scrollTop >= this.items[i].top - 100) {
                        currentIndex = this.items[i].group_name.toUpperCase();
                    }
                }
                for (var j = 0; j < this.indexObjectList.length; j++) {
                    if (this.indexObjectList[j].name == currentIndex) {
                        this.indexObjectList[j].checked = true;
                        console.log("scroll to:" + currentIndex);
                    } else {
                        this.indexObjectList[j].checked = false;
                    }
                }
            }
        },
        watch: {
            queryValue:function (val,oldVal) {
                this.search();
            }
        }
    });
};
