window.onload = function() {
    var tmpAllTagList = [];
    var tagCount = 0;
    var TITLE_PATTERN = /^[a-zA-Z0-9\u4E00-\u9FA5\s\^\-_*&`~\\/|;；:：{},!@#$&().'\&quot;\[\]<>?·！（）——、‘“”？—。，《》%【】\\+]+$/;
    var vm = new Vue({
        el: '#view-container',
        data: {
            tagColor: "#48cfad",
            allTaglist: [],
            tmpNewTag: "",
            searchallTaglist: [],
            isShowSearchList:false,
        },

        mounted: function() {
            var self = this;
            uSetPublicBackButtonClickListener(function() {
                self.goBack();
            });
            uSetTagColorSelectedListener(function(color) {
                self.changeTagColor(color);
            });
            self.tagColor = JSON.parse(uGet("tagColor"));
            self.allTaglist = JSON.parse(uGet("allTaglist"));
            tagCount = JSON.parse(uGet("tagCount"));
            tmpAllTagList = self.allTaglist;
            uSet("tagColor", "");
            uSet("allTaglist", "");
            this.$nextTick(function() {
                uShowSelf();
            });
        },
        computed: {
            trimedTmpNewTag: function() {
                // `this` points to the vm instance
                return this.tmpNewTag.replace(/(^\s*)|(\s*$)/g, "")
            }
        },
        methods: {
            goBack: function() {
                uSet("allTaglist", JSON.stringify(this.allTaglist));
                uSet("tagCount", JSON.stringify(tagCount));
                uFinishCurrentPage();
            },
            showTagColorDialog: function() {
                uShowTagColorDialog(this.tagColor);
            },
            changeTagColor: function(color) {
                color = "#" + color.substring(3, color.length);
                this.tagColor = color;
                uSet("tagColor", JSON.stringify(this.tagColor));
            },
            addNewTag: function() {
                this.tmpNewTag = this.tmpNewTag.replace(/(^\s*)|(\s*$)/g, "");
                if (this.tmpNewTag == "") {
                    return;
                }
                if (tagCount >= 10) {
                    uShowToast(stringMap.tag_limit1);
                    return;
                }
                for (var i = 0; i < this.allTaglist.length; i++) {
                    if (this.allTaglist[i].name == this.tmpNewTag) {
                        uShowToast(stringMap.tag_limit2);
                        return;
                    }
                }
                if (!(this.tmpNewTag.match(TITLE_PATTERN))) {
                    uShowToast(stringMap.tag_limit3);
                    return;
                }
                if (this.tmpNewTag.length > 25) {
                    uShowToast(stringMap.tag_limit4);
                    return;
                }
                var newTag = { "name": this.tmpNewTag, "isNew": true, "checked": true, "sid": this.allTaglist.length, color: this.tagColor, "styleObject": { backgroundColor: this.tagColor, color: "#FFFFFF", borderColor: this.tagColor } };
                this.allTaglist.unshift(newTag);
                for(var i = 0; i < this.allTaglist.length; i++){
                    this.allTaglist[i].sid = i;
                }
                tagCount++;
                this.tmpNewTag = "";
            },
            deleteTag: function(sid) {
                self = this;
                if (this.allTaglist[sid].checked) {
                    tagCount--;
                }
                this.allTaglist.splice(sid, 1);
                for (var i = 0; i < this.allTaglist.length; i++) {
                    this.allTaglist[i].sid = i;
                }
                self.search();

            },
            chooseTag: function(sid) {
                if (!tmpAllTagList[sid].checked) {
                    if (tagCount >= 10) {
                        uShowToast(stringMap.tag_limit1);
                        return;
                    }
                    tagCount++;
                } else {
                    tagCount--;
                }
                console.log(sid);
                tmpAllTagList[sid].checked = !tmpAllTagList[sid].checked;
                if (!tmpAllTagList[sid].checked) {
                    tmpAllTagList[sid].styleObject = { backgroundColor: "#f4f4f4", color: tmpAllTagList[sid].color, borderColor: tmpAllTagList[sid].color };
                } else {
                    tmpAllTagList[sid].styleObject = { backgroundColor: tmpAllTagList[sid].color, color: "#FFFFFF", borderColor: tmpAllTagList[sid].color };
                }

                Vue.set(this.allTaglist, sid, tmpAllTagList[sid]);
            },
            search: function() {
                this.searchallTaglist= [];
                if (this.tmpNewTag != "") {
                    this.isShowSearchList=true;
                    for (var i = 0; i < this.allTaglist.length; i++) {
                        if (this.allTaglist[i].name.indexOf(this.tmpNewTag) >= 0) {
                            this.searchallTaglist.push(this.allTaglist[i]);
                        }
                    }
                } else {
                    this.isShowSearchList= false;
                }

            }
        },
        watch: {
            tmpNewTag: function(val, oldVal) {
                this.search();
            }
        }
    });
};