window.onload = function() {
    var tmpAllTagList = [];
    var tagCount = 0;
    var TITLE_PATTERN = /^[a-zA-Z0-9\u4E00-\u9FA5\s\^\-_*&`~\\/|;；:：{},!@#$&().'\&quot;\[\]<>?·！（）——、‘“”？—。，《》%【】\\+]+$/;
    var vm = new Vue({
        el: '#view-container',
        data: {
            tagColor: "#48cfad",
            allTaglist: [],
            tmpNewTag: "",
            workItemInfo: "",
            searchallTaglist: [],
            isShowSearchList: false,
            needSave: false
        },

        mounted: function() {
            var self = this;
            uSetPublicBackButtonClickListener(function() {
                self.goBack();
            });
            uSetTagColorSelectedListener(function(color) {
                self.changeTagColor(color);
            });
            self.tagColor = uGet("tagColor") != "" ? JSON.parse(uGet("tagColor")) : self.tagColor;
            self.workItemInfo = JSON.parse(uGet("workItemInfo"));

            self.allTaglist = JSON.parse(uGet("allTaglist"));
            console.log(JSON.stringify(self.allTaglist));
            self.initData();
            tagCount = self.workItemInfo.tags.length;
        },
        computed: {
            // a computed getter
            trimedTmpNewTag: function() {
                // `this` points to the vm instance
                return this.tmpNewTag.replace(/(^\s*)|(\s*$)/g, "")
            }
        },
        methods: {
            getProjectTagList: function() {
                var self = this;
                hQueryProjectTags({ 'project_uuid': self.workItemInfo.project.uuid }, function(data) {
                    self.allTaglist = data.tags;
                    console.log(JSON.stringify(self.allTaglist));
                    for (var i = 0; i < self.allTaglist.length; i++) {
                        self.allTaglist[i].checked = false;
                        self.allTaglist[i].sid = i;
                        self.allTaglist[i].isNew = false;
                        if (self.allTaglist[i].color_id) {
                            self.allTaglist[i].color = colorIdMap[self.allTaglist[i].color_id];
                        } else {
                            self.allTaglist[i].color = colorIdMap[8];
                        }

                        self.allTaglist[i].styleObject = { backgroundColor: "#f4f4f4", color: self.allTaglist[i].color, borderColor: self.allTaglist[i].color };

                        if (self.workItemInfo.tags && self.workItemInfo.tags.length) {
                            for (var j = 0; j < self.workItemInfo.tags.length; j++) {
                                if (self.workItemInfo.tags[j].id == self.allTaglist[i].id) {
                                    self.allTaglist[i].checked = true;
                                    self.allTaglist[i].styleObject = { backgroundColor: self.allTaglist[i].color, color: "#FFFFFF", borderColor: self.allTaglist[i].color };
                                }
                            }
                        }
                    }
                    tmpAllTagList = self.allTaglist;
                    uHideLoadingPage();
                    uSet("queryProjectTags", "true");
                    self.$nextTick(function() {
                        uShowSelf();
                        self.needSave = true;
                    });
                });
            },
            initData: function() {
                var self = this;
                console.log(JSON.stringify(self.allTaglist));
                for (var i = 0; i < self.allTaglist.length; i++) {
                    self.allTaglist[i].checked = false;
                    self.allTaglist[i].sid = i;
                    self.allTaglist[i].isNew = false;
                    if (self.allTaglist[i].color_id) {
                        self.allTaglist[i].color = colorIdMap[self.allTaglist[i].color_id];
                    } else {
                        self.allTaglist[i].color = colorIdMap[8];
                    }

                    self.allTaglist[i].styleObject = { backgroundColor: "#f4f4f4", color: self.allTaglist[i].color, borderColor: self.allTaglist[i].color };

                    if (self.workItemInfo.tags && self.workItemInfo.tags.length) {
                        for (var j = 0; j < self.workItemInfo.tags.length; j++) {
                            if (self.workItemInfo.tags[j].id == self.allTaglist[i].id) {
                                self.allTaglist[i].checked = true;
                                self.allTaglist[i].styleObject = { backgroundColor: self.allTaglist[i].color, color: "#FFFFFF", borderColor: self.allTaglist[i].color };
                            }
                        }
                    }
                }
                tmpAllTagList = self.allTaglist;
                uHideLoadingPage();
                uSet("queryProjectTags", "true");
                self.$nextTick(function() {
                    uShowSelf();
                    self.needSave = true;
                });
            },
            goBack: function() {
                if (this.needSave) {
                    this.saveTags();
                }
                uFinishCurrentPage();
            },
            saveTags: function() {
                var tmpWorkItemInfoTagList = [];
                this.tmpTagList = [];
                for (var i = 0; i < this.allTaglist.length; i++) {
                    if (this.allTaglist[i].checked) {
                        this.tmpTagList.push(this.allTaglist[i]);
                        if (this.allTaglist[i].id) {
                            tmpWorkItemInfoTagList.push({ "name": this.allTaglist[i].name, "id": this.allTaglist[i].id, "color_id": colorIdReverseMap[this.allTaglist[i].color] });
                        } else {
                            tmpWorkItemInfoTagList.push({ "name": this.allTaglist[i].name, "color_id": colorIdReverseMap[this.allTaglist[i].color] });
                        }
                    }
                }
                if (this.workItemInfo.tags == null) {
                    this.workItemInfo.tags = [];
                }
                console.log("tmpWorkItemInfoTagList" + JSON.stringify(tmpWorkItemInfoTagList.sort(this.compare)));
                console.log("workItemInfo.tagList" + JSON.stringify(this.workItemInfo.tags.sort(this.compare)));

                for (var i = 0; i < this.workItemInfo.tags.length; i++) {
                    if (this.workItemInfo.tags[i].color_id == 0) {
                        this.workItemInfo.tags[i].color_id = 8;
                    }

                }
                var params = [];
                if (!_.isEqual(tmpWorkItemInfoTagList.sort(this.compare), this.workItemInfo.tags.sort(this.compare))) {
                    if (tmpWorkItemInfoTagList.length) {
                        params = tmpWorkItemInfoTagList;
                    } else {
                        params = [];
                    }
                    uSet("choosedTags", JSON.stringify(params));
                }
            },
            compare: function(obj1, obj2) {
                var val1 = obj1.name;
                var val2 = obj2.name;
                if (val1 < val2) {
                    return -1;
                } else if (val1 > val2) {
                    return 1;
                } else {
                    return 0;
                }
            },
            showTagColorDialog: function() {
                uShowTagColorDialog(this.tagColor);
            },
            changeTagColor: function(color) {
                color = "#" + color.substring(3, color.length);
                this.tagColor = color;
                uSet("tagColor", JSON.stringify(this.tagColor));
            },
            addNewTag: function() {
                this.tmpNewTag = this.tmpNewTag.replace(/(^\s*)|(\s*$)/g, "");
                if (this.tmpNewTag == "") {
                    return;
                }
                if (tagCount >= 10) {
                    uShowToast(stringMap.tag_limit1);
                    return;
                }
                for (var i = 0; i < this.allTaglist.length; i++) {
                    if (this.allTaglist[i].name == this.tmpNewTag) {
                        uShowToast(stringMap.tag_limit2);
                        return;
                    }
                }
                if (!(this.tmpNewTag.match(TITLE_PATTERN))) {
                    uShowToast(stringMap.tag_limit3);
                    return;
                }
                if (this.tmpNewTag.length > 25) {
                    uShowToast(stringMap.tag_limit4);
                    return;
                }
                var newTag = { "name": this.tmpNewTag, "isNew": true, "checked": true, "sid": this.allTaglist.length, color: this.tagColor, "styleObject": { backgroundColor: this.tagColor, color: "#FFFFFF", borderColor: this.tagColor } };
                this.allTaglist.unshift(newTag);
                for (var i = 0; i < this.allTaglist.length; i++) {
                    this.allTaglist[i].sid = i;
                }
                tagCount++;
                this.tmpNewTag = "";
                uSet("allTaglist",JSON.stringify(this.allTaglist));
            },
            deleteTag: function(sid) {
                self = this;
                if (this.allTaglist[sid].checked) {
                    tagCount--;
                }
                this.allTaglist.splice(sid, 1);
                for (var i = 0; i < this.allTaglist.length; i++) {
                    this.allTaglist[i].sid = i;
                }
                self.search();
                uSet("allTaglist",JSON.stringify(this.allTaglist));
            },
            chooseTag: function(sid) {
                if (!tmpAllTagList[sid].checked) {
                    if (tagCount >= 10) {
                        uShowToast(stringMap.tag_limit1);
                        return;
                    }
                    tagCount++;
                } else {
                    tagCount--;
                }
                tmpAllTagList[sid].checked = !tmpAllTagList[sid].checked;
                if (!tmpAllTagList[sid].checked) {
                    tmpAllTagList[sid].styleObject = { backgroundColor: "#f4f4f4", color: tmpAllTagList[sid].color, borderColor: tmpAllTagList[sid].color };
                } else {
                    tmpAllTagList[sid].styleObject = { backgroundColor: tmpAllTagList[sid].color, color: "#FFFFFF", borderColor: tmpAllTagList[sid].color };
                }

                Vue.set(this.allTaglist, sid, tmpAllTagList[sid]);
            },
            search: function() {
                this.searchallTaglist = [];
                if (this.tmpNewTag != "") {
                    this.isShowSearchList = true;
                    for (var i = 0; i < this.allTaglist.length; i++) {
                        if (this.allTaglist[i].name.indexOf(this.tmpNewTag) >= 0) {
                            this.searchallTaglist.push(this.allTaglist[i]);
                        }
                    }
                } else {
                    this.isShowSearchList = false;
                }

            }
        },
        watch: {
            tmpNewTag: function(val, oldVal) {
                this.search();
            }
        }

    });
};